#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                    BROWSERS STATS                              #####
####                                                                #####
####                    (http server)                               #####
####                                                                #####
####    domisse@w3perl.com                   version 26/04/2007     #####
####                                                                #####
#########################################################################

$version = "2.99";
$verdate = "26/04/07";

$debug = 0;

$dirjs = "js";
$dircss = "css";

$sorttablejs = "sorttable.js";
$helpjs = "help.js";

$css_w3perl = "w3perl.css";
$css_help = "help.css";

require "flush.pl";

## valeur a modifier par fixperlpath.pl

require "/var/www/cgi-bin/w3perl/libw3perl.pl";

if ($logfile_format eq "FTP") {
    &error_exit("No agent stats can be done for FTP logfile\n");
}

$fileagentday = $path.$dirinc.$dirsep."agentday";
#$datafile = "time-agent";

$pos = rindex($conf_file,$dirsep);
$vtmp = substr($conf_file,$pos+1,length($conf_file));
$pos = rindex($0,"-");
$vtmp .= substr($0,$pos+1,length($0));
$vtmp =~ s/$plext//g;

print "Agent stats : $version\n";
print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");

# Retrieve external log
&retrieve_external_logfile($fileroot,$remote_host_log) if ($retrieve_external_log == 1 && $opt_w eq '');

$starttime = time();
# calculer le temps mis pour le calcul
$startrun = "$hour:$minute:$second";

# debut de l'initialisation

if ($logfile_format ne "W3C") {
    if ($struct_logfile !~ /\%agent/ || $agentlog eq '') {
	&error_exit("The logfile format you have defined don't have agent data\n");
    }
}

if ($zipcut == 3 || ($struct_compressed_logfile =~ /\%hour/ && $struct_compressed_logfile =~ /\%min/ && $struct_compressed_logfile =~ /\%sec/)) {
    $filetmpzip = &find_last_log($fileroot,$prefixlog);
    $first_logfile = &find_first_log($fileroot,$prefixlog);
    if ($filetmpzip == -1 || $first_logfile == -1) {
	if (!(-f "$fileroot$prefixlog")) {
	    &error_exit("No file found in $fileroot\n");
	} else {
	    $zip = 0;
	    $zipcut = 0;
	}
    }
    if ($zipcut == 3) {
	$tmp = $filetmpzip;
	$filetmpzip =  $first_logfile;
	$first_logfile = $tmp;
    }
    $rotate_index = $max_rotate_index;
   if ($rotate_index !~ /^\d+$/) {
	&error_exit("Found a logfile I don't understand $prefixlog$rotate_index. Index should be a number");
    }
#    print "DEB : $first_logfile\n";
#    print "END : $filetmpzip\n";
}

### NEWNEW
$prefixlog = $agentlog if ($file ne $fileagent && $agentlog ne '');

$diros = "os";
#$yesterday = &yesterday_date($day,$countmonth,$year);
$i = 0;
$count_day = 0;
$initday = 0;
$scan = 1;
$jour_of_year = 1;
$pastjour_of_year = 0;
$sizeold = 0;
#$addit = 0;
$timesec = time;
&get_time($timesec);
#($jour_of_year_end) = split(/ /,$datemisc);

if ($struct_compressed_logfile !~ /\%hour/ && $struct_compressed_logfile !~ /\%min/ && $struct_compressed_logfile !~ /\%sec/) {
if ($zipcut == 2) {
$monthtmp = $month;
$filetmpzip = $fileroot;
$month = $month_equiv{$month};
$month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
   $lettermonth = $month_nb[$month-1];
$smallyear = $year - int($year/100)*100;
$smallyear = "0".$smallyear if (length($smallyear) == 1);
$smallday = $day;
$smallday = substr($smallday,1,2) if ($smallday < 10);
$smallmonth = $month;
$datetmpzip = $year.$month.$day;
for ($i=1;$i<=$#compressed_logfile_fields;$i++) {
    $date_filename = $day.$dirsepurl.$lettermonth.$dirsepurl.$year; # Format XX/Mmm/YYYY
    $compressed_logfile_fields[$i] =~ s/\%/\$/;
    $filetmpzip .= eval($compressed_logfile_fields[$i]).$compressed_sep_fields[$i];
}
   $filetmpzip_day .= &nbday($date_filename);
$filetmpzip = $filetmpzip.$zipext if ($zip == 1);
$month = $monthtmp;
}
}

%translate_agent = ('Mozilla','Netscape',
		    'MSIE','Microsoft Internet Explorer',
		    'Gecko','Gecko',
		    'Microsoft Internet Explorer','Microsoft Internet Explorer',
		    'Firefox','Firefox');

@agent = ('Mozilla','MSIE','Gecko','Microsoft Internet Explorer','Firefox');
#@agent = ('Mozilla','MSIE','Microsoft Internet Explorer');

%translate_os = ('Win98','Windows 98',
		 'Win98 A','Windows 98',
		 'Windows 98','Windows 98',
		 'Win 9x 4.90','Windows Me',
		 'Windows ME','Windows Me',
		 'Windows XP','Windows XP',
		 'Win95','Windows 95',
		 'Windows 95','Windows 95',
		 'Win32','Windows 95',		 
		 'Win16','Windows 3.1',
		 'Win3.1','Windows 3.1',
		 'Windows 16','Windows 3.1',
		 'Windows 3.1','Windows 3.1',		 
		 'WinNT','Windows NT',
		 'Windows NT','Windows NT',
		 'Windows-NT','Windows NT',
		 'Win2k','Windows 2000',
		 'Windows 2000','Windows 2000',
		 'Windows 2000 5.0','Windows 2000',
		 'Windows NT 5.0','Windows 2000',
#		 'Windows5.0','Windows 2000',
		 'Windows NT 5.1','Windows XP',
		 'Windows XP 5.1','Windows XP',
		 'Windows NT 5.2','Windows Server 2003',
		 'Windows 5.2','Windows Server 2003',
		 'Windows NT 4.0','Windows NT',
		 'WinNT4.0','Windows NT',
		 'Windows NT 6.0','Windows Vista',
		 'Windows 6.0','Windows Vista',
		 "Windows CE","Windows CE",
		 "WinCE","Windows CE",
#		 "cp/m","CPM",
#		 "sunos","Sun Solaris",
#		 "irix","Irix",
#		 "unix","Unknown Unix system",
#		 "linux","Linux",
#		 "os/2","Warp OS/2",
#		 "osf","OSF Unix",
#		 "crayos","CrayOS",
#		 "amigaos","AmigaOS",
#		 "hp-ux","HP Unix",
#		 "riscos","Acorn RISC OS",
#		 "aix","Aix",
#		 "netbsd","NetBSD",
#		 "bsdi","BSDi",
#		 "freebsd","FreeBSD",
		 "Webtv","WebTV",
		 "Macintosh","Macintosh",
		 "Mac OS","Macintosh",
		 "Macintosh PPC","Macintosh PPC MacOS X",
		 "Macintosh Intel","Macintosh Intel MacOS X",
		 'Mac_PPC','Macintosh PPC',
		 'MacPPC','Macintosh PPC',
		 'Mac_PowerPC Mac','Macintosh PPC',
		 'Mac_PowerPC','Macintosh PPC');

@os = ('Win98','Win98 A','Windows 98','Win 9x 4.90','Windows ME','Windows XP','Win95','Windows 95','Win32','Win16','Win3.1','Windows 16','Windows 3.1','WinNT','Windows NT','Windows-NT','Win2k','Windows 2000','Windows 2000 5.0','Windows NT 5.0','Windows NT 5.1','Windows XP 5.1','Windows NT 5.2','Windows 5.2','Windows NT 4.0','WinNT4.0','Windows NT 6.0','Windows 6.0','Windows CE','WinCE','Webtv','Macintosh','Mac OS','Macintosh PPC','Macintosh Intel','Mac_PPC','MacPPC','Mac_PowerPC Mac','Mac_PowerPC');
	    
@linux_distrib = ('Mandriva','Mandrake','Ubuntu','Fedora','Debian','Red\s*Hat','Suse','Gentoo','Slackware','Knoppix','CentOS');
#@linux_distrib = ('Mandriva','Mandrake','Ubuntu','Fedora','Debian','Red\[ \]*Hat','Suse','Gentoo','Slackware','Knoppix','CentOS');

@main_os = ('Windows','Macintosh','Linux','Unix');
@main_unix_os = ('IRIX','SunOS','Freebsd','OpenBSD','NetBSD','AIX','OSF','VMS','HP-UX');

for ($i=0;$i<=$#main_os;$i++) {
    $main_os_string .= "$main_os[$i]|";
}
chop($main_os_string);

#

for ($i=0;$i<=$#main_unix_os;$i++) {
    $main_unix_string .= "$main_unix_os[$i]|";
}
chop($main_unix_string);

#

for ($i=0;$i<=$#linux_distrib;$i++) {
    $distrib_string .= "$linux_distrib[$i]|";
}
chop($distrib_string);
@list_distrib = split(/\|/,$distrib_string);

#################################################################
###            parsing the command line option                ###
#################################################################

if ($opt_h == 1) {
      print STDOUT "Usage : \n";
#      print STDOUT "        -a                    : show all browser\n";
      print STDOUT "        -b                    : don't run incremental mode\n";
      print STDOUT "        -c <file>             : load configuration file\n";
      print STDOUT "        -d <nbdays>           : number of days to scan (Extended NCSA logifle only)\n"; 
      print STDOUT "        -g <nograph ";
      for ($i=0;$i<$#graphic;$i++) {
      print STDOUT "$graphic[$i] ";
      } 
      print STDOUT "$graphic[$#graphic]";
      print STDOUT "> : graphic output (choose one)\n";
      print STDOUT "        -l <";
      for ($i=0;$i<$#lang;$i++) {
      print STDOUT "$lang[$i],";
      } 
      print STDOUT "$lang[$#lang]";
      print STDOUT ">            : language output (comma split)\n";      
      print STDOUT "        -i <file>             : input logfile\n";
      print STDOUT "        -f                    : scan only HTML files (Extended NCSA logfile only)\n"; 
      print STDOUT "        -t <toplist>          : display only toplist browsers\n";
      print STDOUT "        -x                    : show default value for flag options\n";
      print STDOUT "        -v                    : version\n";
      print STDOUT "        -z                    : zip logfiles\n";        
      print STDOUT "\n";
      exit;
}


if ($opt_v == 1) {
      print STDOUT "cron-agent.pl version $version $verdate\n";
      exit;
}

if ($opt_x == 1) {
      print STDOUT "Default : \n";
#      print STDOUT "          -a            : ";
#      &id($opt_a);
      print STDOUT "          -b            : ";
      &id($opt_b);
      print STDOUT "          -c            : $configfile\n";
      print STDOUT "          -d <nbdays>   : $nbdays\n"; 
      print STDOUT "          -g <graphic>  : $graphic[0]\n";
      print STDOUT "          -l <language> : ";
      for ($i=0;$i<$#lang;$i++) {
      print STDOUT "$lang[$i],";
      }
      print STDOUT "$lang[$#lang]\n";
      print STDOUT "          -i <file>     : $fileagent\n";
      print STDOUT "          -f            : No\n";
      print STDOUT "          -t <toplist>  : $topten\n";
      print STDOUT "          -v            : $version\n";
      print STDOUT "          -z            : ";
      &id($opt_z);       
      exit;
}

# argument cmds line

if ($opt_z ne '') {
$zip = $opt_z;
}

if ($opt_i ne '') {
    $zip = 0;
$fileagent = $opt_i;
}

if ($opt_t ne '') {
$topten = $opt_t;
}

if ($opt_d ne '') {
$nbdays = $opt_d;
print STDERR "Only extended NSCA logfile !!!\nThis switch \"-d\" has no effect.\n" if ($file ne $fileagent);
}

if ($opt_l ne '') {
  @lang = split(/, /,$opt_l);
  for ($i=0;$i<=$#lang;$i++) {
      $tmp = $dirress.$dirsep."lang".$dirsep.$lang[$i].$plext;
      $tmp = $pathinit.$tmp;
      require "$tmp";
  }
  if ($lang[0] eq '') {
      &error_exit("\nNone of your language choices have been yet translated !\n");
      }
}


# switch

if ($opt_g ne '') {
  print STDERR "Only extended NSCA logfile !!!\nThis switch \".$opt_g.\" has no effect.\n" if ($file ne $fileagent);
  if ($opt_g eq "nograph")  {
      $nograph = 1;
  }
  if ($opt_g eq "3d")  {
      $bargraph = 1;
      $linegraph = 0;
      $tridim = 1;
  }
  if ($opt_g eq "fill") {
      $bargraph = 0;
      $linegraph = 1;
      $fillgraph = 1;
  }
  if ($opt_g eq "line") {
      $bargraph = 0;
      $linegraph = 1;
  }
  if ($opt_g eq "bar") {
      $bargraph = 1;
      $linegraph = 0;
      $tridim = 0;
  }
}

if ($opt_f == 1) {
print "Only extended NSCA logfile !!!\nThis switch \"-f\" has no effect.\n" if ($file ne $fileagent);
}

###################################################################

if ($zipcut == 0 && $zip == 0) {
    &error_exit("Agentlog file $fileagent not found\nAre you sure your server produce one ?\n\n") unless (-f $fileagent);
}
$nbline = 0;

$agentgraph = $path.$dirgraph.$dirsep."agent".$gifext;
$agentgraphx = $path.$dirgraph.$dirsep."agentx".$gifext;
$agentgraphy = $path.$dirgraph.$dirsep."agenty".$gifext;

$linkagentgraph = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."agent".$gifext;
$linkagentgraphx = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."agentx".$gifext;
$linkagentgraphy = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."agenty".$gifext;

$others = "others".$gifext;

$reverse_dns = 0 if ($nolog eq '');

&MakeDirectories;

#################################################################
####                   date de ce jour                    #######
#################################################################

if ($file eq $fileagent || $type_serveur == 2) {

    $month_number = $month_equiv{$month};
    $month_number--;

### nombre de jour entre le 1er janvier et $today

    $timesec = time;
    &get_time($timesec);
    ($jour_of_year_end) = split(/ /,$datemisc);

### date il y a $nbdays jours

    if ($nbdays != 0) {
	
	$pastday = $day  - $nbdays; 
	$pastyear = $year;
	$pastmonth = $month_nb[$month_number];
	
	while ($pastday < 1) {
	    $month_number--;
	    if ($month_number < 0) {
		$pastyear--;
		$month_number = 11;
	    }
	    $pastmonth = $month_nb[$month_number];
	    $pastday = $pastday + $month_of_year{$pastmonth};
	}

	$pasttoday = $pastday." ".$pastmonth." ".$pastyear;         

	$pastjour_of_year = &nbday($pasttoday);
	print "DATE il y a $nbdays days : $pasttoday ($pastjour_of_year)\n" if ($debug == 1);
    }

    if (($pastyear%4 == 0 && $pastyear%100 != 0) || $pastyear%400 == 0) {
	$pastbisextil = 1;
    }

    $jour_of_year_end++ if ($pastbisextil == 1);
}

$size = -s $fileagent;
if ($size == 0 && -f $fileagent) {
    &error_exit("Your logfile $fileagent is empty !\n");
}

if ($size < 0) {
    $msg = "Problem with logfile size\n";
    $msg .= "You should upgrade to the latest Perl version to be able to handle file larger than 2 Gb\n";
    $msg .= "or split your logfile under the 2 Gb limit\n\n";
    &error_exit($msg);
}

if ($opt_d ne '') {
    $oldjour = $pasttoday;
}

#############################################################################

&load_reverse_dns if ($reverse_dns == 1); # chargement de la table de DNS

if ($exclude_robot == 1) {
    &LoadRobot($opt_w);
}

if ($exclude_refererspam == 1) {
    &LoadReferSpam($reverse_dns,$opt_w);
}

#################################################################
#######        chargement des anciennes valeurs      ############
#################################################################

$opt_b = 1 if (!(-f "$path$dirinc$dirsep$incbrowser"));

if ($opt_b != 1 && $opt_d eq '') {

    if (-f "$path$dirinc$dirsep$incbrowser") {

	open(OUT,"$path$dirinc$dirsep$incbrowser") || &error_exit("Unable to open $path$dirinc$dirsep$incbrowser");
	$a = (<OUT>);
	($nbline,$sizeold,$firstday,$oldjour) = split(/\t/,$a);
	chop($oldjour);
	while (<OUT>) {
	    ($browser,$nb) = split(/\t/);
	    chop($nb);
	    $nbre{$browser} = $nb;
	    $unique++;
	    $browser[$unique] = $browser;
	}
	close(OUT);    
	
	($pastday,$pastmonth) = split(/ /,$firstday);
	$jour_of_year = &nbday($firstday);
	$jour_of_year_first = $jour_of_year; 
	
	open(OUT,"$path$dirinc$dirsep$incos") || &error_exit("Error, unable to open $path$dirinc$dirsep$incos");
	$count = (<OUT>);
	chop($count);
	while (<OUT>) {
	    $tmp = ($os,$nb,$tmp2) = split(/\t/);
	    if ($tmp == 2) {
		chop($nb);
		$nbreos{$os} = $nb;
		$uniqueos++;
	    }
	    if ($tmp == 3) {
		chop($tmp2);
		$distrib{$nb} = $tmp2;
	    }
	}
	close(OUT);    

	open(OUT,"$path$dirinc$dirsep$dayagent") || &error_exit("Error, unable to open $path$dirinc$dirsep$dayagent");
	while (<OUT>) {
	    (@uni) = split;
	    for ($i=0;$i<=$#uni;$i++) {
		$evolbrowser{$count_day,$i+1} = $uni[$i];
	    }
	    $count_day++;
	}
	close (OUT);
	$count_day--;
	
	for ($i=1;$i<=$unique;$i++) {
	    $nbreday{$browser[$i]} = $evolbrowser{$count_day,$i};
	}
    }
}

# load inc day data

#if (-f $fileagentday && $opt_d eq '' && $opt_b != 1 && $struct_logfile =~ /\%agent/) {
if (-f $fileagentday && $opt_d eq '' && $opt_b != 1) {
#if (-f $fileagentday && $opt_d eq '' && $opt_b != 1 && $agentlog eq $prefixlog) {
#print "Loading daily incremental data : $fileagentday\n";
#print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

    open(FILEDAYAGENT,"$fileagentday") || &error_exit("Error, unable to open $fileagentday");

    $tmp = <FILEDAYAGENT>;
    chop($tmp);

    ($yesterday,$countday) = split(/\t/,$tmp);
    $oldjour = $yesterday;
    $loadinc = 1;
    $nb = 0;

    while (<FILEDAYAGENT>) {
	($tmp,$tmp1,$tmp2) = split(/\t/);
	chop($tmp2);
	
	if ($tmp eq "A") {
	    $nbrebrowserday{$tmp1} = $tmp2;
	    $uniqueday++;
	}
	
	if ($tmp eq "B") {
	    $nbreosday{$tmp1} = $tmp2;
	    $uniqueosday++;
	}

	if ($tmp eq "C") {
	    chop($tmp1);
	    $nb++;
	    $browserday[$nb] = $tmp1;
	}
    }
    close (FILEDAYAGENT);
}

#################################################################
###                     gzip log file                         ###
#################################################################

#$yeartmp = $year;

if (($zip == 1 || $zipcut != 0) && (($opt_b == 1) || ($nbline == 0))) {

    $month = $monthindex;
    $monthprev = $month-1;
    $yyear = $year;
    $year = $fyear;

   # detection du premier mois de log zipe
    
    while ($out == 0) {
	$tmp++;
	if ($zipcut == 2) {
	    $day++;
	    $day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);
	    if ($day > $month_of_year{$month_nb[$monthprev]}) {
		$month++;
		$monthprev++;
		$day = "1" if ($struct_compressed_logfile =~ /\%smallday/);
		$day = "01" if ($struct_compressed_logfile !~ /\%smallday/);
	    }
	}
	$month++ if ($zipcut == 1);
	$monthprev++ if ($zipcut == 1);       
	$year++ if ($month == 13);
	$month = "1" if ($month == 13);
	$month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
	$monthprev = 0 if ($month == 1);
	$lettermonth = $month_nb[$monthprev];             
	if ($year ==  $fullyear && $month > $monthindex && $zipcut != 0) {
            $msg = "No gziped files found !\n\n" if ($zip == 1);
            $msg = "No log files found !\n\n" if ($zip != 1);
            &error_exit($msg);
	}
	$fileagent = $fileroot;
	$smallyear = $year - int($year/100)*100;
	$smallyear = "0".$smallyear if (length($smallyear) == 1);
	
	$smallday = $day;
	$smallmonth = $month;

	for ($i=1;$i<=$#compressed_logfile_fields;$i++) {
	    $date_filename = $day.$dirsepurl.$lettermonth.$dirsepurl.$year; # Format XX/Mmm/YYYY
	    $compressed_logfile_fields[$i] =~ s/\%/\$/;
	    $fileagent .= eval($compressed_logfile_fields[$i]).$compressed_sep_fields[$i];
	}
	$real_deb = 1 if ($fileagent eq $file_re);
	$out = 1 if (-e $fileagent && $zip == 0);
	$filezip = $fileagent.$zipext if ($zip == 1);
	$out = 1 if (-e $filezip && $zip == 1);
	if ($zipcut == 3 && $filetmpzip eq $fileagent) {
	    $out = 1;
	    $zip = 0;
	    $filezip = $fileagent;
	}
	# if larger then (today-1996)*366 for daily logfiles
	if ($tmp > 5000) {
	    $msg = "No logfile found\n";
	    $msg .= "Are you sure you are using compressed logfile ?\n" if ($zip == 1);
	    &error_exit($msg);
	}
    }
#        until (-e $filezip || -e $fileagent);

    $lastfile = $fileagent;
    $lastfilezip = $filezip;
    $stop = 0;
    $fyear = $year;
    $year = $yyear;
}

#################################################################
#####               computing agent stats                  ######
#################################################################

$line_parsed = 0;
$no_agent = 0;

if (($zip == 1 || $zipcut != 0) && ($opt_b != 1 || $opt_d ne '')) {
#if ($zipcut != 0 && ($opt_b != 1 || $opt_d ne '')) {
    ($day,$month2,$year) = split(/ /,$oldjour) if ($opt_d eq '');
    ($day,$month2,$year) = split(' ',$pasttoday) if ($opt_d ne '');

    $day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);
    $month = $month_equiv{$month2};
    $month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
    $lettermonth = $month2;
    $out = 0 if (!(-f $fileagent));
    while ($out == 0 && (($year <=  $fullyear) || (($year == $fullyear) && $month <= $monthindex))) {
	
	$fyear = $year;
        $smallyear = $year - int($year/100)*100;
        $smallyear = "0".$smallyear if (length($smallyear) == 1);
	$smallday = $day;
	$smallmonth = $month;
	
        $fileagent = $fileroot;

     	for ($i=1;$i<=$#compressed_logfile_fields;$i++) {
	    $date_filename = $day.$dirsepurl.$lettermonth.$dirsepurl.$year; # Format XX/Mmm/YYYY
	    $compressed_logfile_fields[$i] =~ s/\%/\$/;
	    $fileagent .= eval($compressed_logfile_fields[$i]).$compressed_sep_fields[$i];
	}
	$filezip = $fileagent.$zipext if ((!(-f $fileagent)) && $zip == 1);
	$filezip = $fileagent.$zipext if ($retrieve_external_log == 1 && $zip == 1); # NEW
	$real_deb = 1 if ($fileagent eq $file_re);
	$out = 1 if (-f $fileagent || -f $filezip);
        if (!(-f $filezip) && !(-f $fileagent)) {
	    if ($zipcut == 2) {
                $day++;
		$day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);
                if ($day > $month_of_year{$month_nb[$month-1]}) {
		    $month++;
		    $day = "1" if ($struct_compressed_logfile =~ /\%smallday/);
		    $day = "01" if ($struct_compressed_logfile !~ /\%smallday/);
		}
	    }
	    $month++ if ($zipcut == 1);
	    $year++ if ($month == 13);
	    $month = "1" if ($month == 13);
	    $month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
	    $lettermonth =  $month_nb[$month-1];
	}
    }   
}   

if ($zipcut == 3) {
    $fileagent = &find_index_log($fileroot,$prefixlog,$pasttoday);
    $filezip = $file.$zipext if ($zip == 1);
}

$fileagent = $fileroot.$prefixlog if (!(-f $filezip) && !(-f $fileagent));
if ($opt_b != 1 && $opt_d eq '' && $zipcut == 3 && -f "$path$dirinc$dirsep$incbrowser") {
    $fileagent = $fileroot.$prefixlog;
    $filezip = $fileagent;
    $zip = 0;
}

if ($size < $sizeold) {
    $nbline = 0;
    print "Your logfile $fileagent have been cut\n";
}

if (-f $filezip && -f $fileagent && $retrieve_external_log == 1) {
    unlink($fileagent);
}

#unlink($file) if (-f $filezip && -f $file && $retrieve_external_log == 1);

&flush(STDOUT);
$|=1;

while ($stop == 0) {

    $skipl = 0;

    if ($count_day != 0 && $loadinc == 0 && $zipcut != 3) {

	$skipl = 1;
	
	$unique_new_browserday = 0;

	for ($l=1;$l<=$uniqueday;$l++) {	       
	    for ($j=0;$j<=$#agent;$j++) {
		if ($browserday[$l] =~ /$agent[$j]/) {
		    $tmp = $agent[$j];
		    $tmp1 = $translate_agent{$tmp};
		    $bro_ver = $browserday[$l];
		    $bro_ver =~ /(\d)+/;
		    $bro_ver = int($1);
		    $new_browserday{$tmp1} += $nbreday{$browserday[$l]};
		    $browser_versionday{$tmp1,$bro_ver} += $nbreday{$browserday[$l]};
		    $browser_version_nbday{$tmp1} = $bro_ver if ($bro_ver > $browser_version_nbday{$tmp1});
		    $browserday[$l] = '';
		    $unique_new_browserday++ if (!($seen{"$tmp1 $oldjour"}++));
		}
	    }
	    $new_browserday{$browserday[$l]} += $nbreday{$browserday[$l]} if ($browserday[$l] ne '');
	    $unique_new_browserday++ if ($browserday[$l] ne '');
	}
	
# tri des $topten browser les plus frequents

	for ($i=0;$i<$unique_new_browserday;$i++) {
	    $maxi = 0;
	    foreach $browser (keys(%new_browserday)) {
		if ($new_browserday{$browser} > $maxi) {
		    $maxi = $new_browserday{$browser};
		    $bestbrowserday[$i] = $browser;
		    $occurbrowserday[$i] = $new_browserday{$browser};                 
		}
	    }
	    $new_browserday{$bestbrowserday[$i]} = 0;
	}

#

	for ($i=0;$i<$unique_new_browser;$i++) {
	    for ($j=0;$j<=$#agent;$j++) {
		if ($bestbrowserday[$i] =~ /$agent[$j]/) {
		    $tmp = $agent[$j];
		    $tmp1 = $translate_agent{$tmp};
		}
	    }
	    $bestbrowserday[$i] =~ s/$tmp/$tmp1/ if ($tmp1 ne '');
	}
	
# OS

	$unique_new_osday = $uniqueosday;
	foreach $osday (keys(%nbreosday)) {
	    $ok = 0;
	    for ($j=0;$j<=$#os;$j++) {
		if ($osday eq $os[$j]) {
		    $tmp = $os[$j];
		    $tmp1 = $translate_os{$tmp};
		    $new_osday{$tmp1} += $nbreosday{$tmp} if ($ok == 0);
		    $ok = 1;
		    $unique_new_osday-- if ($seen{"$tmp1 $oldjour"}++);
		}
	    }
	    $new_osday{$osday} = $nbreosday{$osday} if ($ok != 1);
	}
	
	for ($i=0;$i<$unique_new_osday;$i++) {
	    $maxi = 0;
	    foreach $os (keys(%new_osday)) {
		if ($new_osday{$os} > $maxi) {
		    $maxi = $new_osday{$os};
		    $bestosday[$i] = $os;
		    $occurosday[$i] = $new_osday{$os};                 
		}
	    }
	    $new_osday{$bestosday[$i]} = 0;
	}

       ###

	($tmp1,$tmp2,$tmp3) = split(/ /,$oldjour);
	$dirresume = $tmp3."-".$tmp2."-".$tmp1;
	
	for ($nblang=0;$nblang<=$#lang;$nblang++) {
	    
	    $tmp = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$dirresume;
	    mkdir ($tmp,0775) unless -d $tmp;
	    
	    open(FILEDAYAGENT,">$path$lang[$nblang]$dirsep$dirdate$dirsep$dirresume$dirsep$tabnamebrowser") || &error_exit("Error, unable to open $path$lang[$nblang]$dirsep$dirdate$dirsep$dirresume$dirsep$tabnamebrowser");
	       
	    &AgentDay(*FILEDAYAGENT, eval($Lang{$lang[$nblang]}));
	    
	    close (FILEDAYAGENT);
	}

	for ($i=1;$i<=$unique;$i++) {
	    $evolbrowser{$count_day,$i} = $nbreday{$browser[$i]};
	}

	undef %nbreday;

	###

	for ($i=0;$i<=$unique_new_browserday;$i++) {
	    for ($l=$browser_version_nbday{$bestbrowserday[$i]};$l>0;$l--) {
		$browser_versionday{$bestbrowserday[$i],$l} = '';
	    }
	}

	undef %new_browserday;
	undef %nbrebrowserday;
	undef %nbreosday;
	undef %browser_version_nbday;
	undef %browser_versionday;
	undef $bestbrowserday;
	undef $occurbrowserday;
	
	$unique_new_browserday = 0;
	
	$countday = 0; # if ($nb eq '');
	$uniqueday = 0;
	$uniqueosday = 0;
	$unique_new_osday = 0;	
	$scan = 1;
	$tmp = $month_nb[$month-1];
	$oldjour = $tmp1." ".$tmp." ".$year;
	$count_day++;
	$nbline = 0;
    }

    $loadinc = 0;

    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET" && $reverse_dns == 1);

#print "Scanning ";

    if (($zip == 1) && (-f $filezip) && ((($fileagent ne $filezip) && ($nbline == 0 || $opt_b == 0)) || ($zipcut == 2))) {
#if (($zip == 1) && ((($fileagent ne $filezip) || ($nbline == 0)) || ($zipcut == 2))) {
	if ($zipcut != 3) {
#	    &retrieve_external_logfile($fileroot,$remote_host_log,$filezip) if ($retrieve_external_log == 1);
	    &error_open($filezip) if (!(-r $filezip));
	    open(INFILE, "$GZIP $filezip |") || &error_exit("Error, unable to open $filezip");
	    print "Scanning $filezip\n";
	} else {
	    # Apache rotate, trying uncompressed file
#	    &retrieve_external_logfile($fileroot,$remote_host_log,$filezip) if ($retrieve_external_log == 1);
	    if (-r $filezip) {
		open(INFILE, "$GZIP $filezip |") || &error_exit("Error, unable to open $filezip");
		print "Scanning $filezip\n";
	    } else {
#		&retrieve_external_logfile($fileroot,$remote_host_log,$fileagent) if ($retrieve_external_log == 1);
		&error_open($fileagent) if (!(-r $fileagent));
		open(INFILE,$fileagent) || &error_exit("Error, unable to open $fileagent");
		print "Scanning $fileagent\n";
	    }
	}

#       print "$filezip file...\n";
#       open(INFILE, "$GZIP $filezip |") || die "Error, unable to open $filezip\n";
    } else {
#	&retrieve_external_logfile($fileroot,$remote_host_log,$fileagent) if ($retrieve_external_log == 1);
	&error_open($fileagent) if (!(-r $fileagent));
	print "Scanning $fileagent\n";
	open(INFILE,$fileagent) || &error_exit("Error, unable to open $fileagent");
    }
      
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

    $line = 0;
    $year = $fyear if ($opt_d eq '' && $fields_logfile{'%date'} eq '');
    
  BOUCLE:
    while (<INFILE>) {
	
	$line++;
	next BOUCLE if (-f "$path$dirinc$dirsep$incbrowser" && $opt_b != 1 && $line <= $nbline);
	
#if ($struct_logfile =~ /\%agent/) {
	if ($struct_logfile =~ /\%/) {
	    
	    @line_log = split(/$logfile_sep/);
	    chomp($line_log[$#line_log]);
	    if ($line_log[$#line_log] =~ /\r\n$/) {
		$dos_format = 1;
		chop($line_log[$#line_log]);
	    }
	    $struct_logfile = &detect_w3c_logformat($_) if ($line_log[0] =~ /^\#Fields:/);
	    next if ($line_log[0] =~ /^\#/);
	    
	    $date = $line_log[$fields_logfile{'%date'}];
	    $date =~ s/\[//;
	    $date = &date_squid($date) if ($date =~ /\d{9}\.\d{3}/);
	    $date = &date_common($line_log[$fields_logfile{'%date'}],$line_log[$fields_logfile{'%hour'}]) if ($iis_format == 1 && $fields_logfile{'%date'} ne '');
	    $date = $date_filename.":".$line_log[$fields_logfile{'%hour'}] if ($fields_logfile{'%date'} eq '');
	    next if ($date !~ m/^((\d+)\/(\w+)\/(\d\d\d\d):)(.*)/);
	    
	    $adresse = $line_log[$fields_logfile{'%host'}];
	    $page = $line_log[$fields_logfile{'%page'}];
	    $page =~ s/$ftpserver// if ($ftp_format == 1);
	    $page =~ s/\/\//\// if ($page !~ /^http:\/\//);
	    $page =~ s/\%3C.*\%3E//g;
	    
	    if ($page =~ /\/\.\.\//) {
		while ($page =~ /\/\.\.\//) {
		    $page =~ s/\.\.\///;
		    $pos = index($page,$dirsepurl,1);
		    $page = substr($page,$pos,length($page));
		}
	    }
	    
	    $d = $line_log[$fields_logfile{'%method'}];
	    $query = $line_log[$fields_logfile{'%query'}] if ($fields_logfile{'%query'} ne '');     
	    $status = $line_log[$fields_logfile{'%status'}];
	    if ($notrafic == 0) {
		$requetesize = $line_log[$fields_logfile{'%requetesize'}] if ($mail_format == 0);
		next if ($requetesize !~ /^\d+/ && $requetesize ne "-" && $ftp_format == 0);
	    }
	    $vserver = $line_log[$fields_logfile{'%virtualhost'}] if ($fields_logfile{'%virtualhost'} ne '');
	    $vserver = $line_log[$#line_log] if ($#logfile_fields == $fields_logfile{'%virtualhost'});
	    $vserver = $1 if ($page =~ /^\/\/([-.0-9a-z]+)\//i && $virtualCLF != 0);
	    $page =~ s/\/\/$virtualfilter// if (($virtualCLF != 0 && $virtualfilter ne '') || ($d =~ /$localserver/));
	    $page =~ s/^http:\/// if ($squid_format == 1);
	    
	    next if ($status !~ /^(\d+)$/);
	    next if ($page =~ /$dirsepurl[_]/ && $type_serveur == 1);
	    
	    $reverse_dns = 0 if ($reverse_dns == 1 && $adresse !~ /^[0-9.]+$/);
	    
	    $adresse = $nis{$adresse} if ($nis{$adresse} ne '');
	    $adresse = &reversedns($adresse) if ($reverse_dns == 1 && $adresse =~ /^[0-9.]+$/);
	    $adresse = $adresse.".".$localdomainename if (split(/[.]/,$adresse) == 1);
	    
	    next if (($adresse =~ m/$localdomaine/o) && ($locallog == 0));
	    next if (($adresse !~ m/$localdomaine/o) && ($localonly == 1));
	    next if (($adresse =~ /$nolog/i) && ($nolog ne ''));
	    
	    if ($squid_format != 1) {
		next if ($page =~ /\"$/ && $iis_format != 1); # all format should be %page %protocol
		next if ($d !~ /^\"/ && $iis_format != 1); # all format should be %page %protocol
	    }
	    next if ($page =~ /^http:\/\// || $page eq ''); # (proxy)
	    
	    ($tmp) = split(/:/,$date);
	    ($daytoday,$monthtoday,$yeartoday) = split(/\//,$tmp);
	    $yesterday = "$daytoday $monthtoday $yeartoday";
	    next if ($month_equiv{$monthtoday} !~ /(\d+)/);
	    next if (length($yeartoday) != 4);
	    next if ($adresse eq '');
	    
	    if ($adresse =~ /\//) {
		($tmp,$adresse) = split(/:/,$adresse);
		print "Problem : found $tmp ... fixing done\n";
	    }
	    
	    $i = $fields_logfile{'%agent'};
	    $f = $line_log[$i];

	    $line_parsed++;
	    if ($f =~ /^\d+/ || ($f =~ m/[<>]/) || ($f !~ /^\"/ && $iis_format != 1)) {
		$no_agent++;
		next BOUCLE;
	    }
	    

	    $f = &GetAgentString($f,$i);
	    
	    if ($exclude_robot == 1) {
		$foundrobot = 0;
		if ($opt_w eq '') {
		    $foundrobot = &ExcludeRobot($f);
		} else {
		    if ($robot_list ne '') {
			$foundrobot = 0;
			$foundrobot = 1 if ($adresse =~ /$robot_list/);
		    }
		}
		if ($foundrobot == 1) { next BOUCLE; }
	    }
	    
	    if ($exclude_refererspam == 1) {
		$foundreferspam = 0;
		if ($opt_w eq '') {
		    $foundreferspam = &ExcludeRefererSpam($adresse);
		} else {
		    if ($spam_list ne '') {
			$foundreferspam = 0;
			$foundreferspam = 1 if ($adresse =~ /$spam_list/);
		    }
		}
		if ($foundreferspam == 1) { next BOUCLE }
	    }
	    
#	    $f =~ s/\+/ /g if ($f !~ /\s/);
#	    next if ($f !~ /\"/ && $f != '');
	    ($browser,$agent1,$agent2) = split(/ \(/,$f) if ($f !~ /\]\(/);
	    ($browser,$agent1) = split(/\]\(/,$f) if ($f =~ /\]\(/);
	    $agent1 = $agent1." ".$agent2 if ($agent2 ne '');
	    
	    $status = $1 if ($query =~ /(\d\d\d);http:\/\// && $type_serveur == 1);
	    if ($squid_format == 1) {
		$codestatus = $line_log[$fields_logfile{'%codestatus'}];
		($code_squid,$status) = split(/\//,$codestatus);
	    }
	    
	    next if (($status >= 400) && ($status < 599));
	    
	    $page =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	    $page =~ tr/[A-Z]/[a-z]/ if ($type_serveur == 1);    
	    $page = $page."?".$query if ($query ne '' && $query !~ /^-,*/);

	    next if ($page !~ m#$tri#i && $tri ne '/'); # stats sur une partie du serveur
	    next if ($page =~ /$dirsepurl[_]/ && $type_serveur == 1 && $mail_format == 0);

	    next if ($d =~ /$localserver/ && $vserver ne '');
	    next if ($vserver =~ /$excludevirtual/i && $excludevirtual ne '');    
	    next if ($vserver !~ /$virtualfilter/i && $virtualfilter ne '' && $vserver ne '');
	    next if ($page =~ /$excluderepert/i && $excluderepert ne '');
	    next if ($page !~ /\.(s)?htm(l)?/i && $opt_f == 1);
	    
	    next if ($requetesize == 0 && $notrafic == 0) ; #ote les pages ne contenant rien
	    
	    if ($opt_d ne '') {
		($fa) = split(':',$date);	
		($fa1,$fa2,$fa3) = split('/',$fa);
		next if ($fa3 < $pastyear);
		$mequiv = $month_equiv{$fa2};
		next if ($fa3 == $pastyear && $mequiv < $pastmonthnb);
		next if ($fa3 == $pastyear && $mequiv == $pastmonthnb && $fa1 < $pastday);
	    }
	    
	    if ($firstday eq '') {
		($firstday) = $date =~ m/^((\d+)\/(\w+)\/(\d+))(.*)/;
		$firstday =~ s/[\/]/ /g;
		$jour_of_year = &nbday($firstday);
		$jour_of_year_first = $jour_of_year; 
		$oldjour = $firstday;
	    }
	    
	    ($jour) = split(/:/,$date);
	    $jour =~ s/[\/]/ /g;
	    
	    next if ($browser eq '');
	    next if ($agent1 =~ /http/);
	    
	    if ($page !~ /^\//) {
		($os) = split(/_/,$browser); ### REALSERVER
		$browser = "-";
	    }

	    if ($page =~ /^\//) {
		if ($agent1 ne '') {
		    $agent1 =~ s/\)\"//g;
		    ($os) = split(/[;(]+/,$agent1); # if ($os eq '');    
			      } else {
				  $os = $agent1;
			      }
		}
		
		if ($os =~ /^[A-Z]+$/) {
		    $os =~ tr/[A-Z]/[a-z]/;
		    $os = ucfirst($os);
		}

		$browser2 = $browser;
		if ($os eq "Macintosh" || $os eq "Windows") {
		    ($a,$tmp,$tmp1,$tmp2) = split(/[;]/,$agent1);	
		    $tmp1 =~ s/WINDOWS/Windows/;
		    if ($os eq "Macintosh") {
			$os = $os." ".$tmp1 if ($tmp =~ /\sU/);
			$os = $os." ".$tmp if ($tmp1 =~ /\sU/);
			$os =~ s/ Mach-O//;
		    }
		    $os = $tmp1 if ($os eq "Windows");
		}
		
		# explorer browser hiding in mozilla !
		if ($agent1 =~ /compatible/i) {
		    ($a,$browser,@tmp) = split(/[;-] /,$agent1);
		    
		    $tmp = '';
		    for ($k=0;$k<=$#tmp;$k++) {
			$tmp .= $tmp[$k];
		    }
		    
		    if ($tmp =~ /DigExt/i) {
			$tmp1 = '';
			for ($k=0;$k<=$#tmp;$k++) {
			    $tmp1 = $tmp[$k];
			    $os = $tmp1 if ($tmp1 =~ /Win/);
			}
		    }
		    
		    if ($tmp !~ /DigExt/i) {
			$os = $tmp[0];
			$os = $tmp[1] if ($tmp[1] =~ /Win/ && $tmp[0] !~ /Win/);
		    }
		    
		    if ($tmp[0] eq '') {
			($browser,$os) = split(/\s+/,$browser2);
		    }
		    
		    $os = "" if ($agent1 !~ /; /);
		    $os = "" if ($browser eq '');
		    $browser = $browser2 if ($agent1 !~ /; /);
		    $tmp = '';
		    $os =~ s/\)(.*)/\)/;
		    $os =~ s/WINDOWS/Windows/;
		}
		
		if ($agent1 =~ /X11/i) {
		    ($a,$tmp,$tmp1,@tmp) = split(/; /,$agent1);    	
		    ($os) = split(/\s+/,$tmp1);
		}
		
		if ($agent1 =~ /gecko/i) {
		    ($a,$b,$browser3) = split(/Gecko\)(\s)/,$agent1) if ($agent1 =~ /Gecko\)/);
		    if ($agent1 =~ /Gecko\//) {
			($a,$b,$browser3,$browser4) = split(/Gecko\/(\d{8})/,$agent1);
			$browser3 = $browser4 if ($browser3 eq " ");
			($a,$b,$browser3) = split(/\s+/,$browser3) if ($browser3 =~ /$main_unix_string/i);
		    }
		    
		    if ($agent1 =~ /rv:(.*)\)/) {
			if ($browser3 eq '') {
			    $browser3 = "Gecko/$1";
			}
		    }
		    
		    if ($browser3 eq '') {
			$browser3 = $browser;
		    }
		    $browser3 =~ s/Netscape6/Mozilla/ if ($browser3 =~ "Netscape6");
		    $browser3 =~ s/Netscape/Mozilla/;
		    
		    $browser = $browser3;
		    
		    ($a,$browser,$tmp2,$tmp3) = split(/ /,$browser) if ($browser =~ /\s/);
		    if ($browser eq "Red") {
			$browser = $tmp3;
		    }
		    if ($browser =~ /$distrib_string/i) {
			($a,$tmp3,$browser,$tmp4) = split(/ /,$browser3);
			$browser = $tmp4 if ($tmp4 ne '' && $tmp4 =~ /\//);
			$browser = $browser2 if ($browser eq '');
		    }
		    $browser = $browser2 if ($browser eq '');
		}

#		print "BB - $browser - $f\n";

		if ($page =~ /^\//) {
		    ($browser,$tmp) = split(/ \[/,$browser);
		    ($browser,$tmp) = split(/\s+/,$browser);
		    $browser = $browser." ".$tmp if ($tmp ne '');
		    ($browser) = split(/\//,$browser) if ($browser !~ /Firefox/ && $browser !~ /Mozilla/ && $browser !~ /gecko/i);
		    ($os) = split(/\//,$os) if ($os !~ /Unknown/);
		    $browser =~ s/\s+$//;
		    $os =~ s/\s+$//;
		    if ($os !~ /Win/) {
			($os,$tmp) = split(/\s+/,$os);
			$os = $os." ".$tmp if ($tmp ne '' && $tmp !~ /\d+/);
		    }
		    
		    if ($browser eq '') {
			$msg = "$fileagent have not an extented common log file format on all lines!\n";
			$msg .= "or this line $_ is not correctly parsed by this script. Send it to me !\n\n";
			$msg .= "$date - $adresse - $page - $f\n";
			&error_exit($msg);
		    }
		}
		
		$os = "" if ($os =~ /^\d+$/);

		if ($jour ne $oldjour && $skipl == 0) {
		    if ($zip == 0 && $zipcut != 2) {
			print "$oldjour done\n";
			print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
		    }
		    $yday = &nbday($jour);
		    $ydayold = &nbday($oldjour);
		    $diff = $yday - $ydayold;
		    
		    $diff++ if ($yday == 0);
		    $jour_of_year += $diff;
		    
		    if ($jour_of_year < $pastjour_of_year && $opt_d ne '') {
			$oldjour = $jour;
			$scan = 0;
			next BOUCLE;
		    }
		    
		    ($var1,$var2,$var3) = split(' ',$jour);
		    ($oldvar1,$oldvar2,$oldvar3) = split(' ',$oldjour);
		    
		    $skipout = 0;
		    
		    if ($var3 < $oldvar3) {
			unless ($seen_problem_date{$jour}++) {
			    print "1 - Problem found (date) : $var1$dirsep$var2$dirsep$var3 - should be $oldvar1$dirsep$oldvar2$dirsep$oldvar3 (skipping...)\n";
			    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
			}
			$skipout = 1;
			$jour = $oldjour;
			next BOUCLE;
		    }
		    
		    if ($oldvar3 == $var3 && $month_equiv{$var2} < $month_equiv{$oldvar2} && $skipout == 0) {
			unless ($seen_problem_date{$jour}++) {
			    print "2 - Problem found (date) : $var1$dirsep$var2$dirsep$var3 - should be $oldvar1$dirsep$oldvar2$dirsep$oldvar3 (skipping...)\n";
			    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
			}
			$skipout = 1;
			$jour = $oldjour;
			next BOUCLE;
		    }
		    
		    if (($var2 eq $oldvar2) && ($var1 < $oldvar1) && $skipout == 0) {
			unless ($seen_problem_date{$jour}++) {
			    print "3 - Problem found (date) : $var1$dirsep$var2$dirsep$var3 - should be $oldvar1$dirsep$oldvar2$dirsep$oldvar3 (skipping...)\n";
			    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
			}
			$skipout = 1;
			$jour = $oldjour;
			next BOUCLE;
		    }

		    ###

		    if ($skipout == 0) {

			$unique_new_browserday = 0;
			
			for ($l=1;$l<=$uniqueday;$l++) {
			    
			    for ($j=0;$j<=$#agent;$j++) {
				if ($browserday[$l] =~ /$agent[$j]/) {
				    $tmp = $agent[$j];
				    $tmp1 = $translate_agent{$tmp};
				    $bro_ver = $browserday[$l];
				    $bro_ver =~ /(\d)+/;
				    $bro_ver = int($1);
				    $new_browserday{$tmp1} += $nbreday{$browserday[$l]};
				    $browser_versionday{$tmp1,$bro_ver} += $nbreday{$browserday[$l]};
				    $browser_version_nbday{$tmp1} = $bro_ver if ($bro_ver > $browser_version_nbday{$tmp1});
				    $browserday[$l] = '';
				    $unique_new_browserday++ if (!($seen{"$tmp1 $oldjour"}++));
				}
			    }
			    $new_browserday{$browserday[$l]} += $nbreday{$browserday[$l]} if ($browserday[$l] ne '');
			    $unique_new_browserday++ if ($browserday[$l] ne '');
			}
			
# tri des $topten browser les plus frequents
			
			for ($i=0;$i<$unique_new_browserday;$i++) {
			    $maxi = 0;
			    foreach $browser (keys(%new_browserday)) {
				if ($new_browserday{$browser} > $maxi) {
				    $maxi = $new_browserday{$browser};
				    $bestbrowserday[$i] = $browser;
				    $occurbrowserday[$i] = $new_browserday{$browser};                 
				}
			    }
			    $new_browserday{$bestbrowserday[$i]} = 0;
			}
			
#
			
			for ($i=0;$i<$unique_new_browser;$i++) {
			    for ($j=0;$j<=$#agent;$j++) {
				if ($bestbrowserday[$i] =~ /$agent[$j]/) {
				    $tmp = $agent[$j];
				    $tmp1 = $translate_agent{$tmp};
				}
			    }
			    $bestbrowserday[$i] =~ s/$tmp/$tmp1/ if ($tmp1 ne '');
			}

#
			$unique_new_osday = $uniqueosday;
			foreach $osday (keys(%nbreosday)) {
			    $ok = 0;
			    for ($j=0;$j<=$#os;$j++) {
				if ($osday eq $os[$j]) {
				    $tmp = $os[$j];
				    $tmp1 = $translate_os{$tmp};
				    $new_osday{$tmp1} += $nbreosday{$tmp} if ($ok == 0);
				    $ok = 1;
				    $unique_new_osday-- if ($seen{"$tmp1 $oldjour"}++);
				}
			    }
			    $new_osday{$osday} = $nbreosday{$osday} if ($ok != 1);
			}
			
			for ($i=0;$i<$unique_new_osday;$i++) {
			    $maxi = 0;
			    foreach $os (keys(%new_osday)) {
				if ($new_osday{$os} > $maxi) {
				    $maxi = $new_osday{$os};
				    $bestosday[$i] = $os;
				    $occurosday[$i] = $new_osday{$os};                 
				}
			    }
			    $new_osday{$bestosday[$i]} = 0;
			}
			
       ###

			($tmp1,$tmp2,$tmp3) = split(/ /,$oldjour);
			$dirresume = $tmp3."-".$tmp2."-".$tmp1;
			
			for ($nblang=0;$nblang<=$#lang;$nblang++) {
			    
			    $tmp = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$dirresume;
			    mkdir ($tmp,0775) unless -d $tmp;
			    
			    open(FILEDAYAGENT,">$path$lang[$nblang]$dirsep$dirdate$dirsep$dirresume$dirsep$tabnamebrowser") || &error_exit("Error, unable to open $path$lang[$nblang]$dirsep$dirdate$dirsep$dirresume$dirsep$tabnamebrowser");
			    
			    &AgentDay(*FILEDAYAGENT, eval($Lang{$lang[$nblang]}));
			    
			    close (FILEDAYAGENT);
			}
			
			for ($i=1;$i<=$unique;$i++) {
			    $evolbrowser{$count_day,$i} = $nbreday{$browser[$i]};
			}
			undef %nbreday;
			
			###
			
			for ($i=0;$i<=$unique_new_browserday;$i++) {
			    for ($l=$browser_version_nbday{$bestbrowserday[$i]};$l>0;$l--) {
				$browser_versionday{$bestbrowserday[$i],$l} = '';
			    }
			}
			
			undef %new_browserday;
			undef %nbrebrowserday;
			undef %nbreosday;
			undef %browser_version_nbday;
			undef %browser_versionday;
			undef $bestbrowserday;
			undef $occurbrowserday;
			
			$unique_new_browserday = 0;
			
			$countday = 0;
			$uniqueday = 0;
			$uniqueosday = 0;
			$unique_new_osday = 0;	
			$scan = 1;
			$count_day += $diff;
			$oldjour = $jour;
			$nbline = 0;
		    }
		}
		
	    } # else {

	    if ($page !~ /^\//) {
		###### 2ieme Partie ######
		
		($date,$f) = split(/\"/) if ($_ =~ /\"/);
		$f = $_ if ($_ !~ /\"/);
		chop($f);
		
		$f =~ s/\+/ /g if ($f !~ /\s/);
		($browser,$agent1) = split(/ \(/,$f) if ($f !~ /\]\(/);
		($browser,$agent1) = split(/\]\(/,$f) if ($f =~ /\]\(/);
		
		if ($agent1 ne '') {
		    $agent1 =~ s/\)\"//g;
		    ($os) = split(/[;(]+/,$agent1);    
			      } else {
				  $os = $agent1;
			      }
		    
		    $browser2 = $browser;

		    if ($os eq "Macintosh" || $os eq "Windows") {
			($a,$tmp,$tmp1,$tmp2) = split(/[;]/,$agent1);	
			$tmp1 =~ s/WINDOWS/Windows/;
			if ($os eq "Macintosh") {
			    $os = $os." ".$tmp1 if ($tmp =~ /\sU/);
			    $os = $os." ".$tmp if ($tmp1 =~ /\sU/);
			    $os =~ s/ Mach-O//;
			}
			$os = $tmp1 if ($os eq "Windows");
		    }
		    
		    # explorer browser hiding in mozilla !
		    if ($agent1 =~ /compatible/i) {
			($a,$browser,@tmp) = split(/; /,$agent1);
			
			$tmp = '';
			for ($k=0;$k<=$#tmp;$k++) {
			    $tmp .= $tmp[$k];
			}
			
			if ($tmp =~ /DigExt/i) {
			    $tmp1 = '';
			    for ($k=0;$k<=$#tmp;$k++) {
				$tmp1 = $tmp[$k];
				$os = $tmp1 if ($tmp1 =~ /Win/);
			    }
			}

			if ($tmp !~ /DigExt/i) {
			    $os = $tmp[0];
			    $os = $tmp[1] if ($tmp[1] =~ /Win/ && $tmp[0] !~ /Win/);
#	    $os = $tmp[2] if ($os !~ /Win/);
			}
			
			if ($tmp[0] eq '') {
			    ($browser,$os) = split(/\s+/,$browser2);
			}

			$os = "" if ($agent1 !~ /; /);
			$os = "" if ($browser eq '');
			$browser = $browser2 if ($agent1 !~ /; /);
			$tmp = '';
			$os =~ s/\)(.*)/\)/;
			$os =~ s/WINDOWS/Windows/;
		    }
		    
		    if ($agent1 =~ /X11/i) {
			($a,$tmp,$tmp1,@tmp) = split(/; /,$agent1);    	
			($os) = split(/\s+/,$tmp1);
		    }
		    
		    if ($agent1 =~ /gecko/i) {
			($a,$b,$browser3) = split(/Gecko\)(\s)/,$agent1) if ($agent1 =~ /Gecko\)/);
			if ($agent1 =~ /Gecko\//) {
			    ($a,$b,$browser3,$browser4) = split(/Gecko\/(\d{8})/,$agent1);
			    $browser3 = $browser4 if ($browser3 eq " ");
			    ($a,$b,$browser3) = split(/\s+/,$browser3) if ($browser3 =~ /$main_unix_string/i);
			}
			
			if ($agent1 =~ /rv:(.*)\)/) {
			    if ($browser3 eq '') {
				$browser3 = "Gecko/$1";
			    }
			}
			
			if ($browser3 eq '') {
			    $browser3 = $browser if ($browser ne '');
			}
			
			$browser3 =~ s/Netscape6/Mozilla/ if ($browser3 =~ "Netscape6");
			$browser3 =~ s/Netscape/Mozilla/;
			
			$browser = $browser3;
			($a,$browser,$tmp2,$tmp3) = split(/ /,$browser) if ($browser =~ /\s/);
			if ($browser eq "Red") {
			    $browser = $tmp3;
			}
			
			if ($browser =~ /$distrib_string/i) {
			    ($a,$tmp3,$browser,$tmp4) = split(/ /,$browser3);
			    $browser = $tmp4 if ($tmp4 ne '' && $tmp4 =~ /\//);
			    $browser = $browser2 if ($browser eq '');
			}
		    }

		    ($browser,$tmp) = split(/ \[/,$browser);
		    ($browser,$tmp) = split(/\s+/,$browser);
		    $browser = $browser." ".$tmp if ($tmp ne '');
		    ($browser) = split(/\//,$browser) if ($browser !~ /Mozilla/ && $browser !~ /gecko/i);
		    ($os) = split(/\//,$os) if ($os !~ /Unknown/);
		    $browser =~ s/\s+$//;
		    $os =~ s/\s+$//;
		    if ($os !~ /Win/) {
			($os,$tmp) = split(/\s+/,$os);
			$os = $os." ".$tmp if ($tmp ne '' && $tmp !~ /\d+/);
		    }
		    
		    if ($type_serveur == 2) {
			$date =~ s/\[//;
			if ($firstday eq '') {
			    ($firstday) = $date =~ m/^((\d+)\/(\w+)\/(\d+))(.*)/;
			    $firstday =~ s/[\/]/ /g;
			    
			    $jour_of_year  = &nbday($firstday);
			    $jour_of_year_first = $jour_of_year; 
			    $oldjour = $firstday;
			}
			
			($jour) = split(/:/,$date);
			$jour =~ s/[\/]/ /g;
			
			if ($jour ne $oldjour) {
			    
			    $yday = &nbday($jour);
			    $ydayold = &nbday($oldjour);
			    $diff = $yday - $ydayold;
			    $diff++ if ($yday == 0);
			    
			    $jour_of_year += $diff;

			    if ($jour_of_year < $pastjour_of_year && $opt_b eq '') {
				$oldjour = $jour;
				$scan = 0;
				next BOUCLE;
			    }
			    
			    ($var1,$var2,$var3) = split(' ',$jour);
			    ($oldvar1,$oldvar2,$oldvar3) = split(' ',$oldjour);
			    
			    $skipout = 0;

			    if ($var3 < $oldvar3) {
				unless ($seen_problem_date{$jour}++) {
				    print "1 - Problem found (date) : $date (skipping...)\n";
				    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
				}
				$skipout = 1;
				$jour = $oldjour;
				next BOUCLE;
			    }

			    if ($month_equiv{$var2} < $month_equiv{$oldvar2}) {
				unless ($seen_problem_date{$jour}++) {
				    print "2 - Problem found (date) : $date (skipping...)\n";
				    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
				}
				$skipout = 1;
				$jour = $oldjour;
				next BOUCLE;
			    }

			    if (($var2 eq $oldvar2) && ($var1 < $oldvar1)) {
				unless ($seen_problem_date{$jour}++) {
				print "3 - Problem found (date) : $date (skipping...)\n";
				print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
			    }
				$skipout = 1;
				$jour = $oldjour;
				next BOUCLE;
			    }

			    ###

			    if ($skipout == 0) {  

				$unique_new_browserday = 0;

				for ($l=1;$l<=$uniqueday;$l++) {
	   
				    for ($j=0;$j<=$#agent;$j++) {
					if ($browserday[$l] =~ /$agent[$j]/) {
					    $tmp = $agent[$j];
					    $tmp1 = $translate_agent{$tmp};
					    $bro_ver = $browserday[$l];
					    $bro_ver =~ /(\d)+/;
					    $bro_ver = int($1);
					    $new_browserday{$tmp1} += $nbreday{$browserday[$l]};
					    $browser_versionday{$tmp1,$bro_ver} += $nbreday{$browserday[$l]};
					    $browser_version_nbday{$tmp1} = $bro_ver if ($bro_ver > $browser_version_nbday{$tmp1});
					    $browserday[$l] = '';
					    $unique_new_browserday++ if (!($seen{$tmp1}++));
					}
				    }
				    $new_browserday{$browserday[$l]} += $nbreday{$browserday[$l]} if ($browserday[$l] ne '');
				    $unique_new_browserday++ if ($browserday[$l] ne '');
				}

# tri des $topten browser les plus frequents

				for ($i=0;$i<$unique_new_browserday;$i++) {
				    $maxi = 0;
				    foreach $browser (keys(%new_browserday)) {
					if ($new_browserday{$browser} > $maxi) {
					    $maxi = $new_browserday{$browser};
					    $bestbrowserday[$i] = $browser;
					    $occurbrowserday[$i] = $new_browserday{$browser};                 
					}
				    }
				    $new_browserday{$bestbrowserday[$i]} = 0;
				}

#
				
				for ($i=0;$i<$unique_new_browser;$i++) {
				    for ($j=0;$j<=$#agent;$j++) {
					if ($bestbrowserday[$i] =~ /$agent[$j]/) {
					    $tmp = $agent[$j];
					    $tmp1 = $translate_agent{$tmp};
					}
				    }
				    $bestbrowserday[$i] =~ s/$tmp/$tmp1/ if ($tmp1 ne '');
				}
		   
#

				$unique_new_osday = $uniqueosday;
				foreach $osday (keys(%nbreosday)) {
				    $ok = 0;
				    for ($j=0;$j<=$#os;$j++) {
					if ($osday eq $os[$j]) {
					    $tmp = $os[$j];
					    $tmp1 = $translate_os{$tmp};
					    $new_osday{$tmp1} += $nbreosday{$tmp} if ($ok == 0);
					    $ok = 1;
					    $unique_new_osday-- if ($seen{"$tmp1 $oldjour"}++);
					}
				    }
				    $new_osday{$osday} = $nbreosday{$osday} if ($ok != 1);
				}
				
				for ($i=0;$i<$unique_new_osday;$i++) {
				    $maxi = 0;
				    foreach $os (keys(%new_osday)) {
					if ($new_osday{$os} > $maxi) {
					    $maxi = $new_osday{$os};
					    $bestosday[$i] = $os;
					    $occurosday[$i] = $new_osday{$os};                 
					}
				    }
				    $new_osday{$bestosday[$i]} = 0;
				}

				###

				($tmp1,$tmp2,$tmp3) = split(/ /,$oldjour);
				$dirresume = $tmp3."-".$tmp2."-".$tmp1;
				
				for ($nblang=0;$nblang<=$#lang;$nblang++) {
				    
				    $tmp = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$dirresume;
				    mkdir ($tmp,0775) unless -d $tmp;
				    
				    open(FILEDAYAGENT,">$path$lang[$nblang]$dirsep$dirdate$dirsep$dirresume$dirsep$tabnamebrowser") || &error_exit("Error, unable to open $path$lang[$nblang]$dirsep$dirdate$dirsep$dirresume$dirsep$tabnamebrowser");
				    
				    &AgentDay(*FILEDAYAGENT, eval($Lang{$lang[$nblang]}));
				    
				    close (FILEDAYAGENT);
				}

				###

				for ($i=1;$i<=$unique;$i++) {
				    $evolbrowser{$count_day,$i} = $nbreday{$browser[$i]};
				}
				
				undef %nbreday;

				###

				for ($i=0;$i<=$unique_new_browserday;$i++) {
				    for ($l=$browser_version_nbday{$bestbrowserday[$i]};$l>0;$l--) {
					$browser_versionday{$bestbrowserday[$i],$l} = '';
				    }
				}
		   
				undef %new_browserday;
				undef %nbrebrowserday;
				undef %nbreosday;
				undef %browser_version_nbday;
				undef %browser_versionday;
				undef $bestbrowserday;
				undef $occurbrowserday;
				
				$unique_new_browserday = 0;
				
				$countday = 0;
				$uniqueday = 0;
				$uniqueosday = 0;
				$unique_new_osday = 0;	
				$scan = 1;
				$count_day += $diff;
				$oldjour = $jour;
				
				$nbline = 0;
			    }	    
			}
		    }
		}
		

		if ($scan == 1 && (($jour_of_year >= $pastjour_of_year) || $opt_b ne '')) {
		    $os =~ s/;(.*)//;
		    $os =~ s/\)//;
		    $os =~ s/^\s+//;
		    $os = "<I>Unknown</I>" if ($os eq '' || length($os) < 3);
		    $os =~ s/^i?[\d\.]+\s+//;
		    $os = uc(substr($os,0,1)).substr($os,1,length($os)) if ($os =~ /^[a-z]/);
		    
		    $browser =~ s/\"//g;
		    $browser = "<I>Unknown</I>" if ($browser eq '' || $browser eq "-");
		    
		    $nbre{$browser}++;
		    $nbreday{$browser}++;
		    $nbreos{$os}++;
       
		    if ($os =~ /Linux/i) {
			for ($i=0;$i<=$#list_distrib;$i++) {
			    if ($f =~ /$list_distrib[$i]/i) {
				$distrib{$list_distrib[$i]}++;
			    }
			}
		    }

		    $nbrebrowserday{$browser}++;
		    $nbreosday{$os}++;
		    
		    $count++;
		    $countday++;
		    
		    $unique++ if ($nbre{$browser} == 1);
		    $uniqueos++ if ($nbreos{$os} == 1);
		    $uniqueday++ if ($nbrebrowserday{$browser} == 1);
		    $uniqueosday++ if ($nbreosday{$os} == 1);
		    
		    $browser[$unique] = $browser if ($nbre{$browser} == 1);
		    $browserday[$uniqueday] = $browser if ($nbreday{$browser} == 1);
		}
	    }

	    close (INFILE); 

#	    if ($line == $no_agent && $line != 0) {
#		print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");
#		print "\nYour logfile have no data about agent informations\n";
#		print "Check either your logfile format from the web admin or \n";
#		print "rectify your w3perl configuration file by removing the %agent string in \$struct_logfile\n\n";
#		print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");
#		exit;
#	    }

# last day

	    $oldjour = $jour if ($jour ne '');

	    if ($struct_logfile =~ /\%agent/) {
		
#print "Saving daily incremental data : $fileagentday\n";
#print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
		
		open(FILEDAYAGENT,">$fileagentday") || &error_exit("Error, unable to open $fileagentday");

		$jour = $oldjour if ($jour eq '');
		$jour = $yesterday if ($oldjour eq '');
		print FILEDAYAGENT "$jour\t$countday\n";
		
		foreach $browser (keys(%nbrebrowserday)) {
		    print FILEDAYAGENT "A\t$browser\t$nbrebrowserday{$browser}\n";
		}
		
		foreach $browser (keys(%nbreosday)) {
		    print FILEDAYAGENT "B\t$browser\t$nbreosday{$browser}\n";
		}
		
		for ($i=1;$i<=$uniqueday;$i++) {
#    print FILEDAYAGENT "C\t$browserday[$i]\t$nbreday{$browserday[$i]}\n"; 
		    print FILEDAYAGENT "C\t$browserday[$i]\n"; 
		}
    
		close (FILEDAYAGENT);
	    }

# mois gzip suivant

	    $stop = 1 if (($zip != 1 && $zipcut == 0) || ($fileagent eq $filezip));
	    $stop = 1 if ($rotate_index == 0 && $zipcut == 3);
	    $stop = 0 if ($zipcut == 3 && $max_rotate_index == 1 && $rotate_index == 1 && (-f "$fileroot$prefixlog"));
	    
	    if (($zip == 1 || $zipcut != 0) && $stop == 0) {
		
		$stop = 1 if ($fileagent eq "$fileroot$prefixlog");
		$yyear = $year;
		$year = $fyear;
		
		&nextlog;
		
		if ($rotate_index == 0 && $zipcut == 3) {
		    $filezip = $fileroot.$prefixlog if ($file eq $fileagent);
		    $fileagent = $fileroot.$prefixlog if ($file eq $fileagent);
		    $filezip = $fileroot.$agentlog if ($file ne $fileagent);
		    $fileagent = $fileroot.$agentlog if ($file ne $fileagent);       
		}
		
		if ($zip == 0) {
		    if ($zipcut == 2) {
			&nextlog while (!(-f $fileagent) && $datezip lt $datetmpzip);
			$stop = 1 if ($fileagent eq $filetmpzip);
		    }
		}
		
		if ($zip == 1) {
		    if (-e $filezip) {
		    } else {
			if ($zipcut == 2) {
			    &nextlog while (!(-f $filezip) && $datezip lt $datetmpzip);
			    $stop = 1 if ($filezip eq $filetmpzip);
			} elsif ($zipcut == 3) {
			    &nextlog while ((!(-f $filezip) && (!(-f $fileagent))) && $rotate_index > 0);
			    $stop = 1 if ($filezip eq $filetmpzip);		
			    $stop = 1 if (!(-f "$fileroot$prefixlog") && $rotate_index == 0);
#		$stop = 1 if (!(-f "$fileroot$agentlog") && $rotate_index == 0);
			} else {
			    $filezip = $fileroot.$prefixlog if ($file eq $fileagent);
			    $fileagent = $fileroot.$prefixlog if ($file eq $fileagent);
			    $filezip = $fileroot.$agentlog if ($file ne $fileagent);
			    $fileagent = $fileroot.$agentlog if ($file ne $fileagent);       
			    $stop = 1 if (!(-f $fileagent));
			}
		    }
		} else {
		    if (-e $fileagent && $zipcut != 0) {
		    } else {
			$stop = 1 if (!(-f $fileagent));
		    }
		}
		
		$fyear = $year;
		$year = $yyear;
	    }
	    
	}# REMETTRE
	    
# last day
	    if (($file eq $fileagent || $zipcut != 0)) {
		for ($i=1;$i<=$unique;$i++) {
		    $evolbrowser{$count_day,$i} = $nbreday{$browser[$i]};
		}
	    }


### Last day

	$unique_new_browserday = 0;

	for ($l=1;$l<=$uniqueday;$l++) {
	    for ($j=0;$j<=$#agent;$j++) {
		if ($browserday[$l] =~ /$agent[$j]/) {
		    $tmp = $agent[$j];
		    $tmp1 = $translate_agent{$tmp};
		    $bro_ver = $browserday[$l];
		    $bro_ver =~ /(\d)+/;
		    $bro_ver = int($1);
		    $new_browserday{$tmp1} += $nbreday{$browserday[$l]};
		    $browser_versionday{$tmp1,$bro_ver} += $nbreday{$browserday[$l]};
		    $browser_version_nbday{$tmp1} = $bro_ver if ($bro_ver > $browser_version_nbday{$tmp1});
		    $browserday[$l] = '';
		    $unique_new_browserday++ if (!($seen{$tmp1}++));
		}
	    }
	    $new_browserday{$browserday[$l]} += $nbreday{$browserday[$l]} if ($browserday[$l] ne '');
	    $unique_new_browserday++ if ($browserday[$l] ne '');
	}
	
# tri des $topten browser les plus frequents
	
	for ($i=0;$i<$unique_new_browserday;$i++) {
	    $maxi = 0;
	    foreach $browser (keys(%new_browserday)) {
		if ($new_browserday{$browser} > $maxi) {
		    $maxi = $new_browserday{$browser};
		    $bestbrowserday[$i] = $browser;
		    $occurbrowserday[$i] = $new_browserday{$browser};                 
		}
	    }
	    $new_browserday{$bestbrowserday[$i]} = 0;
	}

#
	
	for ($i=0;$i<$unique_new_browser;$i++) {
	    for ($j=0;$j<=$#agent;$j++) {
		if ($bestbrowserday[$i] =~ /$agent[$j]/) {
		    $tmp = $agent[$j];
		    $tmp1 = $translate_agent{$tmp};
		}
	    }
	    $bestbrowserday[$i] =~ s/$tmp/$tmp1/ if ($tmp1 ne '');
	}

#

	$unique_new_osday = $uniqueosday;
	foreach $osday (keys(%nbreosday)) {
	    $ok = 0;
	    for ($j=0;$j<=$#os;$j++) {
		if ($osday eq $os[$j]) {
		    $tmp = $os[$j];
		    $tmp1 = $translate_os{$tmp};
		    $new_osday{$tmp1} += $nbreosday{$tmp} if ($ok == 0);
		    $ok = 1;
		    $unique_new_osday-- if ($seen{"$tmp1 $oldjour"}++);
		}
	    }
	    $new_osday{$osday} = $nbreosday{$osday} if ($ok != 1);
	}
	
	for ($i=0;$i<$unique_new_osday;$i++) {
	    $maxi = 0;
	    foreach $os (keys(%new_osday)) {
		if ($new_osday{$os} > $maxi) {
		    $maxi = $new_osday{$os};
		    $bestosday[$i] = $os;
		    $occurosday[$i] = $new_osday{$os};                 
		}
	    }
	    $new_osday{$bestosday[$i]} = 0;
	}

###

	($tmp1,$tmp2,$tmp3) = split(/ /,$oldjour);
	$dirresume = $tmp3."-".$tmp2."-".$tmp1;
	
	for ($nblang=0;$nblang<=$#lang;$nblang++) {
    
	    $tmp = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$dirresume;
	    mkdir ($tmp,0775) unless -d $tmp;
	    
	    open(FILEDAYAGENT,">$path$lang[$nblang]$dirsep$dirdate$dirsep$dirresume$dirsep$tabnamebrowser") || &error_exit("Error, unable to open $path$lang[$nblang]$dirsep$dirdate$dirsep$dirresume$dirsep$tabnamebrowser");
	    
	    &AgentDay(*FILEDAYAGENT, eval($Lang{$lang[$nblang]}));
	    
	    close (FILEDAYAGENT);
	}

#################################################################
####             sauvegarde des donnees                   #######
#################################################################

open(OUT,">$path$dirinc$dirsep$incbrowser") || &error_exit("Error, unable to open $path$dirinc$dirsep$incbrowser");

print OUT "$line\t$size\t$firstday\t$oldjour\n";
for ($i=1;$i<=$unique;$i++) {
    print OUT "$browser[$i]\t$nbre{$browser[$i]}\n";
}
close(OUT);    

open(OUT,">$path$dirinc$dirsep$incos") || &error_exit("Error, unable to open $path$dirinc$dirsep$incos");
print OUT "$count\n";
foreach $os (keys(%nbreos)) {
    print OUT "$os\t$nbreos{$os}\n";
}
for ($i=0;$i<=$#list_distrib;$i++) {
    $distrib{$list_distrib[$i]} = 0 if ($distrib{$list_distrib[$i]} eq '');
    print OUT "Linux\t$list_distrib[$i]\t$distrib{$list_distrib[$i]}\n";
}
close(OUT);    


open(OUT,">$path$dirinc$dirsep$dayagent") || &error_exit("Error, unable to open $path$dirinc$dirsep$dayagent");
for ($j=0;$j<=$count_day;$j++) {
for ($i=1;$i<=$unique;$i++) {
	$evolbrowser{$j,$i} = 0 if ($evolbrowser{$j,$i} eq '');
        print OUT "$evolbrowser{$j,$i} ";
        }
print OUT "\n";
}
close (OUT);

#############################################################################

&save_reverse_dns if ($reverse_dns == 1); # sauvegarde de la table de DNS

	    if (($line_parsed == $no_agent && $line_parsed != 0) || ($firstday eq '' && $exclude_robot == 1 && ($exclude_robot_nb != $line))) {
		$msg = "\nYour logfile have no data about agent informations\n";
		$msg .= "You can : \n";
		$msg .= " - Check either your logfile format from the web admin\n";
		$msg .= " - Alter your w3perl configuration file by removing the %agent string in \$struct_logfile\n";
		$msg .= " - Disable running this script from the web interface\n";
		$msg .= "\n";
		&error_exit($msg);
	    }

if ($line == $nbline) {
    &error_exit("Nothing new\n",0);
}

# tri par browser sans version

$unique_new_browser = 0;

for ($l=1;$l<=$unique;$l++) {

	$browser2[$l] = $browser[$l];
	$nbre2{$browser2[$l]} = $nbre{$browser[$l]};	
	for ($j=0;$j<=$#agent;$j++) {
		if ($browser[$l] =~ /$agent[$j]/) {
			$tmp = $agent[$j];
			$tmp1 = $translate_agent{$tmp};
			$bro_ver = $browser[$l];

			$bro_ver =~ /(\d\.\d\d*)/;
###			$bro_ver = int($1);
			$bro_ver = $1;
			$bro_ver =~ s/00/0/;
#			$nb_browser{$tmp1} += $nbre{$browser[$l]};

			$new_browser{$tmp1} += $nbre{$browser[$l]};
			$browser_version{$tmp1,$bro_ver} += $nbre{$browser[$l]};
			$browser_version_nb{$tmp1} = $bro_ver if ($bro_ver > $browser_version_nb{$tmp1});
			$browser[$l] = '';
			$unique_new_browser++ if (!($seen{"$tmp1 priv"}++));
		}
	}
	$new_browser{$browser[$l]} += $nbre{$browser[$l]} if ($browser[$l] ne '');
	$unique_new_browser++ if ($browser[$l] ne '');
}

# tri par os

foreach $os (keys(%nbreos)) {
	$ok = 0;
	for ($j=0;$j<=$#os;$j++) {
		if ($os eq $os[$j]) {
			$tmp = $os[$j];
			$tmp1 = $translate_os{$tmp};
			$new_os{$tmp1} += $nbreos{$tmp} if ($ok == 0);
			$unique_new_os++ if (!($seen{"$tmp1 priv2"}++));
			$ok = 1;
		}
	}
	$new_os{$os} = $nbreos{$os} if ($ok != 1);
	$unique_new_os++ if ($ok != 1);
}

undef %nbreos;

$uniqueos = $unique_new_os;

foreach $os (keys(%new_os)) {
    $nbreos{$os} = $new_os{$os};
}

sub nextlog {

    $day++ if ($zipcut == 2);
    $day = 1 if ($zipcut == 1);

    if ($day > $month_of_year{$month_nb[$monthprev]}) {
	$month++;
	$monthprev++;
	$day = "1";
    } else {
	$month++ if ($zipcut == 1);
	$monthprev = $month-1;
    }

    $year++ if ($month == 13);
    $month = "1" if ($month == 13);
    $day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);
    $month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
    $monthprev = 0 if ($month == 1);
    $lettermonth = $month_nb[$monthprev];
    $fileagent = $fileroot;
    $smallyear = $year - int($year/100)*100;
    $smallyear = "0".$smallyear if (length($smallyear) == 1);
    $smallday = $day;
    $smallmonth = $month;

    if ($month == 2) {
	if (($year%4 == 0 && $year%100 != 0) || $year%400 == 0) {
	    $month_of_year{'Feb'} = "29";
	    $bisextil = 1;
	} else {
	    $month_of_year{'Feb'} = "28";
	    $bisextil = 0;
	}
    }

    $rotate_index-- if ($zipcut == 3);
    if ($rotate_index < 0) {
	&error_exit("Problem with apache rotating file\n");
    }

    if ($real_deb == 0) {
	for ($i=1;$i<=$#compressed_logfile_fields;$i++) {
	    $compressed_logfile_fields[$i] =~ s/\%/\$/;
	    $fileagent .= eval($compressed_logfile_fields[$i]).$compressed_sep_fields[$i];
	}
    }

    if ($real_deb == 1) {    
	if ($struct_compressed_logfile =~ /\%hour/ && $struct_compressed_logfile =~ /\%min/ && $struct_compressed_logfile =~ /\%sec/) {

	    $abort = 1;
	    for ($j=0;$j<$re;$j++) {
		$abort = 0 if ($tab_re[$j] eq "$day $month $year");
	    }

	    if ($abort == 0) {
		$sec = 60;
		$min = 59;
		$hour = 23;
		for ($k=0;$k<86400;$k++) {
		    
		    $fileagent = $fileroot;
		    $sec--;
		    if ($sec < 0) {
			$min--;
			if ($min < 0) {
			    $hour--;
			    $min = 59;
#			$sec = 59;
			}
			$sec = 59;
		    }
		    
		    $hour = "0".$hour if (length($hour) == 1);
		    $min = "0".$min if (length($min) == 1);
		    $sec = "0".$sec if (length($sec) == 1);
		    
		    for ($i=1;$i<=$#compressed_logfile_fields;$i++) {
			$fileagent .= eval($compressed_logfile_fields[$i]).$compressed_sep_fields[$i];
		    }
#		print "A - $fileagent\n";
		    last if (-f $fileagent);
		}
	    }
	}
    }
    
    $filezip = $fileagent.$zipext if ($zip == 1);
    $datezip = $year.$month.$day;
}

#################################################################
###                    computing maxima                       ###
#################################################################

# tri de browser2

for ($i=1;$i<=$unique;$i++) {
$maxi = 0;
for ($j=1;$j<=$unique;$j++) {
    if ($nbre{$browser2[$j]} > $maxi) {
         $maxi = $nbre{$browser2[$j]};
         $browser3[$i] = $browser2[$j];
         $nbre3{$browser3[$i]} = $maxi;
         $maxix = $j       
         }
}
$nbre{$browser2[$maxix]} = 0;
}

# tri des $topten browser les plus frequents
$boucle = $topten unless ($unique_new_browser < $topten);
$boucle = $unique_new_browser unless ($unique_new_browser > ($topten-1));

for ($i=0;$i<$boucle;$i++) {
$maxi = 0;
foreach $browser (keys(%new_browser)) {
    if ($new_browser{$browser} > $maxi) {
         $maxi = $new_browser{$browser};
         $bestbrowser[$i] = $browser;
         $occurbrowser[$i] = $new_browser{$browser};                 
         }
    }
$new_browser{$bestbrowser[$i]} = 0;
}

###

$boucleall = $topten unless ($unique < $topten);
$boucleall = $unique unless ($unique > ($topten-1));

for ($i=0;$i<$boucleall;$i++) {
$maxi = 0;
foreach $browser (keys(%nbre2)) {
    if ($nbre2{$browser} > $maxi) {
         $maxi = $nbre2{$browser};
         $bestbrowserall[$i] = $browser;
         $occurbrowserall[$i] = $nbre2{$browser};                 
         }
    }
$nbre2{$bestbrowserall[$i]} = 0;
}

#

foreach $os (keys(%nbreos)) {
    ($tmp) = split(/[\s+\-]/,$os);
    $tmp = "Unix" if ($os =~ /$main_unix_string/i);
    $tmp = "Linux" if ($os =~ /$distrib_string/i);
#    $tmp = "Misc" if ($tmp !~ /$main_os_string/);
    $tmp = "Misc" if ($tmp !~ /$main_os_string/i && $os !~ /$main_unix_string/i && $os !~ /$distrib_string/i);
    $main_os{$tmp} += $nbreos{$os};
    $count_main_os{$tmp}++;
#    print "$os - $tmp - $count_main_os{$tmp}\n";
}
#		  print FOUT "$occuros[$i]</TD>\n";

# tri des $topten OS les plus repandu
#$boucleos = $topten unless ($uniqueos < $topten);
#$boucleos = $uniqueos unless ($uniqueos > ($topten-1));
$boucleos = $uniqueos;

for ($i=0;$i<$boucleos;$i++) {
$maxi = 0;
foreach $os (keys(%nbreos)) {
    if ($nbreos{$os} > $maxi) {
         $maxi = $nbreos{$os};
         $bestos[$i] = $os;
         $occuros[$i] = $nbreos{$os};                 
         }
    }
$nbreos{$bestos[$i]} = 0;
}

$sum_distrib = 0;
for ($i=0;$i<=$#list_distrib;$i++) {
    $sum_distrib += $distrib{$list_distrib[$i]};
}

#################################################################
#####             browser evolution graphs                #######
#################################################################

#$year = $yeartmp;

if ($struct_logfile =~ /\%agent/ || $type_serveur == 2) {
#if ($prefixlog eq $agentlog || $type_serveur == 2) {

# check if something have been scan !

if ($jour_of_year < $pastjour_of_year && $pastyear == $year && $line == 0) {
    $increase = $jour_of_year_end - $jour_of_year_first;
#$increase +=365 if ($increase < 1);
    $msg = "Last day recorded in logfile is too old.\n";
    $msg .="Use \"-d $increase\" option to scan all the logfile!\n\n";
    &error_exit($msg);
}

if ($count_day == 0 && $unique == 0 && $line == 0) {
    $msg = "Don't seems to be a extended NCSA logfile !\n";
    $msg .= "Check inside your $fileroot directory...\n\n";
    &error_exit($msg);
}

### maximum

if ($count_day < $nbdays) {
    $initday = 0;
    $start_date = $firstday;
} else {
    $initday = $count_day - $nbdays;
    $start_date = $pasttoday;
}

$maxtot = 0;
for ($j=$initday;$j<=$count_day;$j++) {
    $max = 0;
    for ($i=1;$i<=$unique;$i++) {
       $max += $evolbrowser{$j,$i};
    }
    $newevol{$j-$initday,$boucleall} = $max;
    $maxtot = $max if ($max > $maxtot);
}


### recompute to select the $TOPTEN browsers

for ($j=$initday;$j<=$count_day;$j++) {
  for ($k=0;$k<$boucleall;$k++) {
     for ($i=1;$i<=$unique;$i++) {
       if ($bestbrowserall[$k] eq $browser2[$i]) {
         $newevol{$j-$initday,$k} = $evolbrowser{$j,$i};
       } 
     }
  }
}

for ($i=0;$i<=$nbdays;$i++) {
  for ($k=0;$k<$boucleall;$k++) {
    $newevol{$i,$boucleall} -= $newevol{$i,$k};
  }
}

### 

$count_day++;

#$nbdays = $count_day if (($count_day+$jour_of_year_first) < $jour_of_year_end);
#$nbdays = $count_day if ($count_day > $nbdays);
$nbdays = $count_day if ($count_day < $nbdays);

### compute graph

#if (-x $FLY) {

$it = length($nbdays)-1;
$div = 10**$it;
$factx = ($div*(int($nbdays/$div)+1))/$grad;

$perspec = $xstep/$factx if (($perspec > $xstep/$factx) && ($tridim == 1));

$it = length($maxtot)-1;
$div = 10**$it;
$facty = ($div*(int(($maxtot+$perspec)/$div)+1))/$grad;
 
 $yfirst = $ymax-1;

 open(FLY,">$tmpfly$vtmp");
 print FLY "new\n";
 print FLY "size $xmax,$ymax\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 
 for ($i=0;$i<=$nbdays;$i++) {
 $x1 = $i*$xstep/$factx;
 $x2 = ($i+1)*$xstep/$factx;
 
 $y2 = $ymax;
 $y1 = $ymax;
 $yfinal = $ymax;

 for ($j=0;$j<=$boucleall;$j++) {
 $yfinal -= ($ystep/$facty * $newevol{$i,$j});
 }

# print "A - $i - $yfinal - ";
# for ($j=0;$j<=$boucleall;$j++) {
#     print "$evolbrowser{$i,$j} / ";
# }
# print "\n";

 for ($j=0;$j<=$boucleall;$j++) {

 $ji = $j % ($#gcolor);
 $ji = 100 if ($j == $boucleall);

 if ($bargraph == 1) {
   $y2 -= ($ystep/$facty * $newevol{$i,$j});
   $y1 -= ($ystep/$facty * $newevol{$i,$j-1});
   print FLY "frect $x1,$y2,$x2,$y1,$red[$ji],$green[$ji],$blue[$ji]\n";
   print FLY "rect $x1,$y2,$x2,$y1,0,0,0\n";
   if ($tridim == 1 && ($y1-$y2) > 2) {
        $x1plus = $x1+$perspec;
        $x2plus = $x2+$perspec;
        $y2plus = $y2-$perspec;
        $y1plus = $y1-$perspec;

        print FLY "fpoly $red[$ji],$green[$ji],$blue[$ji],$x2,$y1,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
        print FLY "poly 0,0,0,$x2,$y1,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";

        if ($y2 == $yfinal) {
        print FLY "fpoly $red[$ji],$green[$ji],$blue[$ji],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        }
   }
 }

 if ($linegraph == 1) {
    $y2 = $ymax - ($ystep/$facty * $newevol{$i,$j});
    $y1 = $ymax - ($ystep/$facty * $newevol{$i+1,$j});
    print FLY "line $x1,$y2,$x2,$y1,$red[$ji],$green[$ji],$blue[$ji]\n";
    }

 if ($fillgraph == 1) {
     $ji = ($boucleall-$j) % ($#gcolor);
     $ji = 100 if ($j == 0);
     $y2 = $ymax;
     $y1 = $ymax;
     for ($l=0;$l<=($boucleall-$j);$l++) {
          $y2 -= ($ystep/$facty * $newevol{$i,$l});
          $y1 -= ($ystep/$facty * $newevol{$i+1,$l});
     }
     if ($y2 != $ymax || $y1 != $ymax) {
     print FLY "line $x1,$y2,$x2,$y1,$red[$ji],$green[$ji],$blue[$ji]\n";
 
     print FLY "line $x1,$ymax,$x1,$y2,$red[$ji],$green[$ji],$blue[$ji]\n";
     print FLY "line $x2,$ymax,$x2,$y1,$red[$ji],$green[$ji],$blue[$ji]\n";
     print FLY "line $x1,$yfirst,$x2,$yfirst,$red[$ji],$green[$ji],$blue[$ji]\n";

     $fx = ($x1+$x2)/2;
     $fy = $yfirst-1;

     print FLY "fill $fx,$fy,$red[$ji],$green[$ji],$blue[$ji]\n";
      } 
 }

 }
 }

 print FLY "transparent 200,200,200\n";
 close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $agentgraph |");
while( <FOO> ) {print;}
close(FOO);
#unlink($tmpfly$vtmp);

### image pour les abscisses

($startday, $startmonth) = split(/ /,$start_date);

$moischiffre = $month_equiv{$startmonth};
$moischiffre--;
$moisvar = $startmonth;
$valmois = $moischiffre;

$valstep = $startday;
$valstep = "0".$valstep if (length($valstep) == 1);

$xlegend = "$nbdays days (starting $start_date)";

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xmax,$ydecal\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 $posx = (($xmax/2)-(length($xlegend)*7/2));
 print FLY "string 0,0,0,$posx,$ydecalm,medium,$xlegend\n";
 for ($i=$xstep;$i<$xmax;$i+=$xstep) {
 $valstep = int(($i/$xmax)*(($xmax*$factx/$xstep)))+$startday;

 $moisvar = $startmonth;
 $valmois = $moischiffre;

 while  ($valstep > $month_of_year{$moisvar}) {
     $valstep = ($valstep - $month_of_year{$moisvar});
     $valmois++;
     $valmois = 0 if ($valmois > 11);
     $moisvar = $month_nb[$valmois];
 }

 $valstep = "0".$valstep if (length($valstep) == 1);
 $val = "$moisvar/$valstep";
 $posx = $i - length($valstep)*10;
 print FLY "line $i,0,$i,5,0,0,0\n";
 print FLY "string 0,0,0,$posx,10,small,$val\n";
 }
print FLY "transparent 200,200,200\n";
close (FLY);
 
open(FOO,"$FLY -q -i $tmpfly$vtmp -o $agentgraphx |");
while( <FOO> ) {print;}
close(FOO);
#unlink($tmpfly$vtmp);
 
### image pour les ordonnees

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xdecal,$ymax\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 if ($fillgraph == 1 || $bargraph == 1) {
 $posy = $ymax - (($ymax/2)-(length("Total added)")*2));
 print FLY "stringup 0,0,0,5,$posy,medium,Total added\n";
 }
 for ($i=$ystep;$i<$ymax;$i+=$ystep) {
 $valstep = int(($ymax - $i) * ($facty/$ystep));
 print FLY "line $xdecalm,$i,$xdecal,$i,0,0,0\n";
 $pos = ($xdecal - length($valstep)*9);
 $posy = $i-5;
 print FLY "string 0,0,0,$pos,$posy,small,$valstep\n";
 }
print FLY "transparent 200,200,200\n";
close (FLY);
 
open(FOO,"$FLY -q -i $tmpfly$vtmp -o $agentgraphy |");
while( <FOO> ) {print;}
close(FOO);
unlink("$tmpfly$vtmp");

}
#}

for ($i=0;$i<$boucle;$i++) {
    for ($j=0;$j<=$#agent;$j++) {
	if ($bestbrowser[$i] =~ /$agent[$j]/) {
	    $tmp = $agent[$j];
	    $tmp1 = $translate_agent{$tmp};
	}
    }
$bestbrowser[$i] =~ s/$tmp/$tmp1/ if ($tmp1 ne '');
$bestbrowser[$i] =~ s/\)//;
$bestbrowser[$i] =~ s/\(//;

}




for ($nblang=0;$nblang<=$#lang;$nblang++) {

 $tabbrowser = $path.$lang[$nblang].$dirsep.$dirlist.$dirsep.$tabnamebrowser;

 open(TABAGENT,">$tabbrowser") || &error_exit("Error, unable to open $tabbrowser");
 &AgentStats(*TABAGENT, eval($Lang{$lang[$nblang]}));
 close(TABAGENT);
}

&update_homepage;

# calculer le temps mis pour le calcul

$datesyst = &ctime(time);
($dayletter,$month,$day,$hourdate,$a,$year) = split(/[ \t\n\[]+/,$datesyst);
($hour,$minute,$second) = split(/:/,$hourdate);

$endrun = "$hour:$minute:$second";

($hour,$min,$sec) = &timetaken($startrun,$endrun);

$endtime = time();
#printf STDOUT "Computing took %d CPU secondes\n",$endtime - $starttime;
#print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
print "Computing took";
print " $hour h" if ($hour > 0);
print " $min min $sec sec\n\n";
print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");

#$today =~ s/ /\//g;

open(FILE,">>$history");
#print FILE "cron-agent\t$today\t$startrun\t$endrun\t$min:$sec\t$line\n";
printf FILE "cron-agent\t%s\t%s\t%s\t%d:%d:%d\t%d\n",$today,$startrun,$endrun,$hour,$min,$sec,$line;
close(FILE);


############################################
### creation du fichier pour les browser ###
############################################

##########################################################################
sub AgentDay {
  local(*FOUT,*L) = @_;

  print FOUT "$doctype\n";
  print FOUT "<HTML><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Browser'} - $oldjour</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - cron-agent.pl $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd2 TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  print FOUT "<H3>$L{'Browsers_used'}</H3><P>\n";
  
  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'most_succf_browsers1'} $topten $L{'most_succf_browsers2'} ($L{'among'} $unique_new_browserday)</DIV><P>\n";

  print FOUT "<TABLE>\n";
  print FOUT "<TR><TH COLSPAN=2>&nbsp;$L{'Browser'}&nbsp;</TH><TH>&nbsp;$L{'Occurence'}&nbsp;</TH><TH>&nbsp;$L{'Percentage'}&nbsp;</TH></TR>\n";

  $boucleagentday = $unique_new_browserday if ($unique_new_browserday < $topten);
  $boucleagentday = $topten if ($unique_new_browserday > $topten);

#for ($i=0;$i<$topten;$i++) {
  for ($i=0;$i<$boucleagentday;$i++) {
      last if ($i == $unique_new_browserday);
#for ($i=0;$i<$unique_new_browserday;$i++) {
      $pourcentage = ($occurbrowserday[$i]*100)/$countday if ($countday != 0);
      $intpourcentage = int($pourcentage);
      
      $tmp_browser = $bestbrowserday[$i];
      $tmp_browser = "Mozilla" if ($tmp_browser =~ /Gecko/i);
      ($tmp) = split(/\s+/,$tmp_browser);

      $tmp = "Unknown" if ($tmp_browser =~ /unknown/g);
      $tmp =~ tr/[A-Z]/[a-z]/;
      $tmp = "Unknown" if (!(-f "$pathinit$dirress$dirsepurl$diros$dirsepurl$tmp$gifext"));

      print FOUT "<TR>\n";
      print FOUT "<TD CLASS=\"head\"><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$diros$dirsepurl$tmp$gifext\" WIDTH=14 HEIGHT=14 ALT=\"icon\"></TD>\n";
      print FOUT "<TD CLASS=\"head_left\">&nbsp;$tmp_browser</TD><TD CLASS=\"head\"><B>$occurbrowserday[$i]</B> $L{'times'}</TD>\n<TD CLASS=\"head_left\">";
      print FOUT "<img width=$intpourcentage height=$square src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">" if ($intpourcentage != 0);
      print FOUT " <B>";
      printf FOUT "%.1f",$pourcentage;
      print FOUT "&nbsp;%</B></TD>\n</TR>\n";

      $tmp = 0;
      for ($l=$browser_version_nbday{$bestbrowserday[$i]};$l>0;$l--) {
	  if ($browser_versionday{$bestbrowserday[$i],$l} ne '') {
	      $tmp++;
	  }
      }

      $tmp2 = 0;
      for ($l=$browser_version_nbday{$bestbrowserday[$i]};$l>0;$l--) {
	  if ($browser_versionday{$bestbrowserday[$i],$l} ne '') {
	      $tmp2++;
	      print FOUT "<TR>";
	      print FOUT "<TD ROWSPAN=$tmp>&nbsp;</TD>\n" if ($l == $browser_version_nbday{$bestbrowserday[$i]});
	      print FOUT "<TD";
	      print FOUT " CLASS=\"left_alter\"" if (($tmp2/2) != int($tmp2/2));
	      print FOUT ">$tmp_browser $l</TD>\n";
	      print FOUT "<TD";
	      print FOUT " CLASS=\"right_alter\"" if (($tmp2/2) != int($tmp2/2));
	      print FOUT " CLASS=\"right\"" if (($tmp2/2) == int($tmp2/2));
	      print FOUT "><B>$browser_versionday{$bestbrowserday[$i],$l}</B> $L{'times'}</TD>\n";
	      print FOUT "<TD";
	      print FOUT " CLASS=\"left_alter\"" if (($tmp2/2) != int($tmp2/2));
	      print FOUT " CLASS=\"left\"" if (($tmp2/2) == int($tmp2/2));
	      print FOUT ">";
	      $pourcentage = ($browser_versionday{$bestbrowserday[$i],$l}*100)/$occurbrowserday[$i];
	      $intpourcentage = int($pourcentage);
	      print FOUT "<img width=$intpourcentage height=$square src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">" if ($intpourcentage != 0);
	      print FOUT " <B>";
	      printf FOUT "%.1f",$pourcentage;
	      print FOUT "&nbsp;%</B></TD>\n</TR>\n";
	  }
      }
  }

#

  print FOUT "</TABLE>\n";

  print FOUT "<P><BR>\n"; 

  print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'OS_used1'} $topten $L{'OS_used2'} ($L{'among'} $unique_new_osday)</DIV><p>\n";
  print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"osday\">\n";
  print FOUT "<TR><TH COLSPAN=2>&nbsp;$L{'OS'}&nbsp;</TH><TH>&nbsp;$L{'Occurence'}&nbsp;</TH><TH>&nbsp;$L{'Percentage'}&nbsp;</TH></TR>\n";

  for ($i=0;$i <$topten;$i++) {
      last if ($i == $unique_new_osday);  
      $pourcentage = ($occurosday[$i]*100)/$countday if ($countday != 0);
      $intpourcentage = int($pourcentage);

      ($tmp) = split(/\s+/,$bestosday[$i]);
      $tmp = "Unknown" if ($bestosday[$i] =~ /unknown/g);
      $tmp =~ tr/[A-Z]/[a-z]/;
      $tmp = "Unknown" if (!(-f "$pathinit$dirress$dirsepurl$diros$dirsepurl$tmp$gifext"));

      if ($occurosday[$i] != 0) {
	  print FOUT "<TR>\n<TD><IMG SRC=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$diros$dirsepurl$tmp$gifext\" WIDTH=14 HEIGHT=14 ALT=\"icon\"></TD><TD CLASS=\"left\">$bestosday[$i]</TD><TD CLASS=\"right\"><B>$occurosday[$i]</B> $L{'times'}</TD><TD CLASS=\"left\">";
	  print FOUT "<img width=$intpourcentage height=$square src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">" if ($intpourcentage != 0);
	  print FOUT "<B>";
	  printf FOUT "&nbsp;%.1f",$pourcentage;
	  print FOUT "&nbsp;%</B></TD>\n";
	  print FOUT "</TR>\n";
      }
  }

#

#foreach $osday (keys (%nbreosday)) {
#$pourcentage = ($nbreosday{$osday}*100)/$countday;
#$intpourcentage = int($pourcentage);

#if ($nbreosday{$osday} != 0) {
#print FOUT "<TR><TD>$osday</TD><TD ALIGN=CENTER><B>$nbreosday{$osday}</B> $L{'times'}</TD><TD>";
#print FOUT "<img width=$intpourcentage height=$square src=\"..$dirsepurl..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\">" if ($intpourcentage != 0);
#print FOUT "<B>";
#printf FOUT "&nbsp;%.1f",$pourcentage;
#print FOUT " %</B></TD>";
#print FOUT "</TR>\n";
#}
#}

  print FOUT "</TABLE><P><BR>\n";
  print FOUT "<!-- PAGE BREAK -->\n"; # PDF break
  print FOUT "</BODY></HTML>\n";
}

##########################################################################
sub AgentStats {
  local(*FOUT,*L) = @_;

  print FOUT "$doctype\n";
  print FOUT "<HTML><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Browsers_used'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - cron-agent.pl $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

  print FOUT "<CENTER>\n";
  print FOUT "<TABLE BORDER=0 WIDTH=\"100%\">\n";
  print FOUT "<TR>\n";
  print FOUT "<TD ALIGN=LEFT VALIGN=MIDDLE WIDTH=\"20%\">";
  print FOUT "</TD>\n";
  print FOUT "<TD ALIGN=CENTER WIDTH=\"60%\">\n";
  print FOUT "<TABLE BORDER=1 BGCOLOR=\"#000000\">\n<TR>\n<TD BGCOLOR=\"#FFEECC\" ALIGN=CENTER>\n";
  print FOUT "<H1>".uc(&noaccentinhtml($L{'Browsers_used'}))."</H1><P>\n";
  print FOUT "</TD>\n</TR>\n</TABLE>\n";
  print FOUT "</TD>\n";
  print FOUT "<TD ALIGN=RIGHT VALIGN=MIDDLE WIDTH=\"20%\">\n";
  print FOUT "</TD>\n";
  print FOUT "</TR>\n";
  print FOUT "</TABLE>\n";
  print FOUT "</CENTER>\n";

  print FOUT "<HR size=5>\n";
  print FOUT "<CENTER><B>$firstday - $jour</B></CENTER>\n" if ($file eq $fileagent);
  print FOUT "<HR size=5>\n" if ($file eq $fileagent);
  print FOUT "<P>\n";

  if ($nograph != 1) {
      if ($bestbrowser[0] ne "<I>Unknown</I>" || $boucle > 1) {

	  if ($struct_logfile =~ /\%agent/ || $type_serveur == 2) {
	      print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	      print FOUT "<TR>\n";
	      print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkagentgraphy\" ALT=\"y\"></TD>\n";
	      print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkagentgraph\" ALT=\"graph\"></TD>\n";
	      print FOUT "</TR>\n<TR><TD></TD>\n";
	      print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkagentgraphx\" ALT=\"x\"></TD>\n";
	      print FOUT "</TR>\n";
	      print FOUT "<TR>\n<TD></TD>\n";
	      print FOUT "<TD ALIGN=CENTER>\n";

	      print FOUT "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0><TR>\n";
	      print FOUT "<TD><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$others\" ALT=\"$others\"></TD>\n";
	      print FOUT "<TD>&nbsp; $L{'Others'}</TD>\n</TR>\n";
	      for ($i=($boucle-1);$i>=0;$i--) {
		  $j = $i % ($#gcolor);
		  $couleur = $gcolor[$j];
		  $bestbrowserall[$i] =~ s/Mozilla/Netscape/ if ($bestbrowserall[$i] =~ "Mozilla");
		  $bestbrowserall[$i] =~ s/Gecko/Mozilla/ if ($bestbrowserall[$i] =~ "Gecko");
		  print FOUT "<TR>\n<TD><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$couleur\" ALT=\"$couleur\"></TD>\n";
		  print FOUT "<TD>&nbsp; $bestbrowserall[$i]</TD>\n</TR>\n";
	      }
	      print FOUT "</TABLE>\n";

	      print FOUT "</TD></TR>\n";        
	      print FOUT "</TABLE></CENTER>\n";

	      print FOUT "<P><CENTER><I>$L{'most_succf_browsers_vtime1'} $boucle $L{'most_succf_browsers_vtime2'}</I></CENTER>\n";
	      print FOUT "<P><HR><P>\n"; 
	  }
      }
  }

  print FOUT "<TABLE BORDER=0 WIDTH=\"100%\">\n";
  print FOUT "<TR>";

  if ($bestbrowser[0] ne "<I>Unknown</I>" || $boucle > 1) {
      print FOUT "<TH ALIGN=CENTER>$L{'most_succf_browsers1'} $boucle $L{'most_succf_browsers2'}</TH>\n";
  }

  print FOUT "<TH>$L{'OS_used1'} $boucleos $L{'OS_used2'}</TH>\n";
  print FOUT "</TR><TR>";

  if ($bestbrowser[0] ne "<I>Unknown</I>" || $boucle > 1) {
      print FOUT "<TD ALIGN=LEFT VALIGN=TOP>\n";
      print FOUT "<CENTER>\n";
      print FOUT "<TABLE>\n";
      print FOUT "<TR>\n<TH COLSPAN=2>&nbsp;$L{'Browser'}&nbsp;</TH>\n<TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n</TR>\n";

      for ($i=0;$i<$boucle;$i++) {
	  $pourcentage = ($occurbrowser[$i]*100)/$count;
	  $intpourcentage = int($pourcentage);

	  $tmp_browser = $bestbrowser[$i];
	  $tmp_browser = "Mozilla" if ($tmp_browser =~ /Gecko/i);
	  ($tmp) = split(/\s+/,$tmp_browser);

	  $tmp =~ tr/[A-Z]/[a-z]/;
	  $tmp = "Unknown" if (!(-f "$pathinit$dirress$dirsepurl$diros$dirsepurl$tmp$gifext"));
	  print FOUT "<TR>\n";
	  print FOUT "<TD CLASS=\"head\"><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$diros$dirsepurl$tmp$gifext\" WIDTH=\"16\" HEIGHT=\"16\" ALT=\"icon\"></TD>\n";
	  
	  print FOUT "<TD CLASS=\"head_left\">$tmp_browser</TD>\n";
	  print FOUT "<TD CLASS=\"head_right\"><B>$occurbrowser[$i]</B></TD>\n";
	  print FOUT "<TD CLASS=\"head_left\">";
	  print FOUT "<IMG WIDTH=$intpourcentage HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">" if ($intpourcentage != 0);
	  print FOUT "&nbsp;<B>";
	  printf FOUT "%.1f",$pourcentage;
	  print FOUT "&nbsp;%</B></TD>\n</TR>\n";

	  $tmp = 0;
	  for ($l=int($browser_version_nb{$bestbrowser[$i]}*100);$l>0;$l--) {
	      $l2 = $l/100;
	      $l2 = $l2.".0" if (length($l2) == 1);
	      $pourcentage = ($browser_version{$bestbrowser[$i],$l2}*100)/$occurbrowser[$i];
	      $intpourcentage = int($pourcentage);
	      if ($browser_version{$bestbrowser[$i],$l2} ne '' && $intpourcentage >= 1) {
		  $tmp++;
	      }
	  }

	  $tmp2 = 0;
	  for ($l=int($browser_version_nb{$bestbrowser[$i]}*100);$l>0;$l--) {
	      $l2 = $l/100;
	      $l2 = $l2.".0" if (length($l2) == 1);

	      $pourcentage = ($browser_version{$bestbrowser[$i],$l2}*100)/$occurbrowser[$i];
	      $intpourcentage = int($pourcentage);
### display browser more than 1% !

	      if ($browser_version{$bestbrowser[$i],$l2} ne '' && $intpourcentage >= 1) {
		  $tmp2++;
		  print FOUT "<TR>\n";
		  print FOUT "<TD ROWSPAN=$tmp>&nbsp;</TD>\n" if ($tmp2 == 1);
		  print FOUT "<TD";
		  print FOUT " CLASS=\"left_alter\"" if (($tmp2/2) != int($tmp2/2));
		  print FOUT " CLASS=\"left\"" if (($tmp2/2) == int($tmp2/2));
		  print FOUT ">$tmp_browser&nbsp;$l2</TD>\n";
		  print FOUT "<TD";
		  print FOUT " CLASS=\"right_alter\"" if (($tmp2/2) != int($tmp2/2));
		  print FOUT " CLASS=\"right\"" if (($tmp2/2) == int($tmp2/2));
		  print FOUT ">$browser_version{$bestbrowser[$i],$l2}</TD>\n";
		  print FOUT "<TD";
		  print FOUT " CLASS=\"left_alter\"" if (($tmp2/2) != int($tmp2/2));
		  print FOUT " CLASS=\"left\"" if (($tmp2/2) == int($tmp2/2));
		  print FOUT ">";
		  print FOUT "<IMG WIDTH=$intpourcentage HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">" if ($intpourcentage != 0);
		  print FOUT "&nbsp;";
		  printf FOUT "%.1f",$pourcentage;
		  print FOUT "&nbsp;%</TD>\n";
		  print FOUT "</TR>\n";
	      }
	  }
#}

# No longer used
#if ($opt_a ne '') {
#for ($l=0;$l<=$unique;$l++) {
#	for ($j=0;$j<=$#agent;$j++) {
#		$tmp = $agent[$j];
#		$tmp1 = $translate_agent{$tmp};
#		$tmpnbre = $browser3[$l];
#		$browsertmp = $browser3[$l];		
#		$browsertmp =~ s/$tmp/$tmp1/;
#		if ($browsertmp =~ /$bestbrowser[$i]/) {
#			$pourcentage = ($nbre3{$tmpnbre}*100)/$occurbrowser[$i];
#			$intpourcentage = int(($nbre3{$tmpnbre}*100)/$occurbrowser[$i]);			
#			print FOUT "<TR><TD>$browsertmp</TD><TD ALIGN=CENTER><B>$nbre3{$tmpnbre}</B> $L{'times'}</TD><TD>";
#			print FOUT "<img width=$intpourcentage height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\">" if ($intpourcentage != 0);
#			print FOUT " <B>";
#			printf FOUT "%.1f",$pourcentage;
#			print FOUT " %</B></TD></TR>\n";
#			last;
#		}
#	}
#    }
#}

      }

      print FOUT "</TABLE>\n";
      print FOUT "</CENTER>\n";
      print FOUT "</TD>\n";
  }

  print FOUT "<TD ALIGN=RIGHT VALIGN=TOP>\n";

  print FOUT "<CENTER>\n";
  print FOUT "<TABLE>\n";
  print FOUT "<TR>\n<TH COLSPAN=2>&nbsp;$L{'OS'}&nbsp;</TH>\n<TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n</TR>\n";
  foreach $os (&reverse_sort_by_value(*main_os)) {
      $pourcentage = ($main_os{$os}*100)/$count;
      $intpourcentage = int($pourcentage);
      $tmp = $os;
      $tmp =~ tr/[A-Z]/[a-z]/;
      $tmp = "Unknown" if ($os =~ /unknown/g);
      $tmp = "Unknown" if (!(-f "$pathinit$dirress$dirsepurl$diros$dirsepurl$tmp$gifext"));
      print FOUT "<TR>";
      print FOUT "<TD CLASS=\"head\"><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$diros$dirsepurl$tmp$gifext\" WIDTH=\"14\" HEIGHT=\"14\" ALT=\"$tmp\"></TD>\n";
      print FOUT "<TD CLASS=\"head_left\">&nbsp;$os&nbsp;</TD><TD CLASS=\"head_right\"><B>$main_os{$os}</B></TD>\n<TD CLASS=\"head_left\">";
      print FOUT "<img width=$intpourcentage height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">" if ($intpourcentage != 0);
      print FOUT "&nbsp;<B>";
      printf FOUT "%.1f",$pourcentage;
      print FOUT "&nbsp;%</B></TD></TR>\n";

      $tmp4 = 0;
      if ($os ne "Linux") {
#      for ($i=0;$i < $boucleos;$i++) {
	  for ($i=0;$i<$uniqueos;$i++) {
	      next if ($bestos[$i] =~ /$distrib_string/i);
	      $pourcentage = ($occuros[$i]*100)/$main_os{$os};
	      $intpourcentage = int($pourcentage);
#	      ($tmp2) = split(/\s+/,$bestos[$i]);
	      ($tmp2) = split(/[\-\s+]/,$bestos[$i]);
	      $tmp3 = $tmp2;
	      $tmp2 = "Unknown" if ($bestos[$i] =~ /unknown/g);
	      $tmp2 = "Unix" if ($bestos[$i] =~ /$main_unix_string/i);
	      $tmp2 =~ tr/[A-Z]/[a-z]/;
#	      $tmp2 = "Unknown" if (!(-f "$pathinit$dirress$dirsepurl$diros$dirsepurl$tmp2$gifext"));
	      $tmp2 = "Unknown" if ($tmp2 !~ /$main_os_string/i);
	      $tmp3 = "Misc" if ($tmp2 eq "Unknown");
	      $tmp3 = "Unix" if ($tmp2 eq "unix");
#	  print "A $tmp3 - $count_main_os{$tmp3} - $tmp2 - $tmp - $os - $bestos[$i] - $main_unix_string\n";
	      $tmp_max_boucleos = $count_main_os{$tmp3};
	      $tmp_max_boucleos = $topten if ($topten < $tmp_max_boucleos);

	      if ($tmp2 eq $tmp) { 
		  $tmp4++;
		  print FOUT "<TR>\n";
#	      print FOUT "<TD ROWSPAN=$count_main_os{$tmp3}></TD>\n" if ($tmp4 == 1);
		  print FOUT "<TD ROWSPAN=\"$tmp_max_boucleos\"></TD>\n" if ($tmp4 == 1);
		  print FOUT "<TD";
		  print FOUT " CLASS=\"left\">" if (($tmp4/2) == int($tmp4/2));
		  print FOUT " CLASS=\"left_alter\">" if (($tmp4/2) != int($tmp4/2));
		  print FOUT "&nbsp;$bestos[$i]</TD>\n";
		  print FOUT "<TD";
		  print FOUT " CLASS=\"right\">" if (($tmp4/2) == int($tmp4/2));
		  print FOUT " CLASS=\"right_alter\">" if (($tmp4/2) != int($tmp4/2));
		  print FOUT "$occuros[$i]</TD>\n";
		  print FOUT "<TD";
		  print FOUT " CLASS=\"left\">" if (($tmp4/2) == int($tmp4/2));
		  print FOUT " CLASS=\"left_alter\">" if (($tmp4/2) != int($tmp4/2));
		  print FOUT "<img width=$intpourcentage height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"progress bar\">" if ($intpourcentage != 0);
		  print FOUT "&nbsp;";
		  printf FOUT "%.1f",$pourcentage;
		  print FOUT "&nbsp;%</TD>\n</TR>\n";
		  last if ($tmp4 == $topten);
	      }
	  }
      }

      if ($os eq "Linux") {
	  for ($j=0;$j<=$#list_distrib;$j++) {
	      next if ($distrib{$list_distrib[$j]} == 0);
	      $tmp4++;
	      $pourcentage = ($distrib{$list_distrib[$j]}*100)/$main_os{$os};
	      $intpourcentage = int($pourcentage);
	      $tmp = $list_distrib[$j];
	      $tmp =~ tr/[A-Z]/[a-z]/;
	      $tmp =~ s/\s/_/g;
	      $tmp =~ s/\\s\*//;
	      $tmp = "Unknown" if (!(-f "$pathinit$dirress$dirsepurl$diros$dirsepurl$tmp$gifext"));
	      print FOUT "<TR>\n";
	      print FOUT "<TD\n";
#	      print FOUT " CLASS=\"left\">" if (($tmp4/2) == int($tmp4/2));	      
	      print FOUT " ALIGN=\"center\">" if (($tmp4/2) == int($tmp4/2));
	      print FOUT " CLASS=\"alter\">" if (($tmp4/2) != int($tmp4/2));
	      print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$diros$dirsepurl$tmp$gifext\" WIDTH=\"14\" HEIGHT=\"14\" ALT=\"$tmp\"></TD>\n";
	      print FOUT "<TD";
	      print FOUT " CLASS=\"left\">" if (($tmp4/2) == int($tmp4/2));
	      print FOUT " CLASS=\"left_alter\">" if (($tmp4/2) != int($tmp4/2));
	      $tmp = $list_distrib[$j];
	      $tmp =~ s/\\s\*/&nbsp;/;
	      print FOUT "&nbsp;$tmp</TD>\n";
	      print FOUT "<TD";
	      print FOUT " CLASS=\"right\">" if (($tmp4/2) == int($tmp4/2));
	      print FOUT " CLASS=\"right_alter\">" if (($tmp4/2) != int($tmp4/2));
	      print FOUT "$distrib{$list_distrib[$j]}</TD>\n";
	      print FOUT "<TD";
	      print FOUT " CLASS=\"left\">" if (($tmp4/2) == int($tmp4/2));
	      print FOUT " CLASS=\"left_alter\">" if (($tmp4/2) != int($tmp4/2));
	      print FOUT "<img width=$intpourcentage height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">" if ($intpourcentage != 0);
	      print FOUT "&nbsp;";
	      printf FOUT "%.1f",$pourcentage;
	      print FOUT "&nbsp;%</TD>\n</TR>\n";
	      last if ($tmp4 == $topten);
	  }	  
	  # others
	  $tmp4++;
	  $tmp = "Unknown";
	  print FOUT "<TR>\n";
	  print FOUT "<TD\n";
#	  print FOUT " CLASS=\"left\">" if (($tmp4/2) == int($tmp4/2));
	  print FOUT " ALIGN=\"center\">" if (($tmp4/2) == int($tmp4/2));
	  print FOUT " CLASS=\"alter\">" if (($tmp4/2) != int($tmp4/2));
	  print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$diros$dirsepurl$tmp$gifext\" WIDTH=\"14\" HEIGHT=\"14\" ALT=\"$tmp\"></TD>\n";
	  print FOUT "<TD";
	  print FOUT " CLASS=\"left\">" if (($tmp4/2) == int($tmp4/2));
	  print FOUT " CLASS=\"left_alter\">" if (($tmp4/2) != int($tmp4/2));
	  print FOUT "&nbsp;$tmp</TD>\n";
	  print FOUT "<TD";
	  print FOUT " CLASS=\"right\">" if (($tmp4/2) == int($tmp4/2));
	  print FOUT " CLASS=\"right_alter\">" if (($tmp4/2) != int($tmp4/2));

	  print FOUT "".($main_os{$os}-$sum_distrib)."</TD>\n";
	  $pourcentage = (($main_os{$os}-$sum_distrib)*100)/$main_os{$os};
	  $intpourcentage = int($pourcentage);
	  print FOUT "<TD";
	  print FOUT " CLASS=\"left\">" if (($tmp4/2) == int($tmp4/2));
	  print FOUT " CLASS=\"left_alter\">" if (($tmp4/2) != int($tmp4/2));
	  print FOUT "<img width=$intpourcentage height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">" if ($intpourcentage != 0);
	  print FOUT "&nbsp;";
	  printf FOUT "%.1f",$pourcentage;
	  print FOUT "&nbsp;%</TD>\n</TR>\n";
      }

  }
  print FOUT "</TABLE>\n";
  print FOUT "</CENTER>\n";



  if ($tototo == 1) {
  print FOUT "<CENTER>\n";
  print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"os\">\n";
  print FOUT "<TR>\n<TH COLSPAN=2>$L{'OS'}</TH>\n<TH>$L{'Occurence'}</TH>\n<TH>$L{'Percentage'}</TH>\n</TR>\n";

  for ($i=0;$i < $boucleos;$i++) {
      $pourcentage = ($occuros[$i]*100)/$count;
      $intpourcentage = int($pourcentage);
      ($tmp) = split(/\s+/,$bestos[$i]);
      $tmp = "Unknown" if ($bestos[$i] =~ /unknown/g);
      $tmp =~ tr/[A-Z]/[a-z]/;
      $tmp = "Unknown" if (!(-f "$pathinit$dirress$dirsepurl$diros$dirsepurl$tmp$gifext"));
      print FOUT "<TR>\n";
      print FOUT "<TD><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$diros$dirsepurl$tmp$gifext\" WIDTH=\"14\" HEIGHT=\"14\" ALT=\"$tmp\"></TD>\n";
      print FOUT "<TD CLASS=\"left\">&nbsp;$bestos[$i]</TD>\n";
      print FOUT "<TD CLASS=\"right\"><B>$occuros[$i]</B></TD>\n<TD CLASS=\"left\">";
      print FOUT "<img width=$intpourcentage height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">" if ($intpourcentage != 0);
      print FOUT "&nbsp;<B>";
      printf FOUT "%.1f",$pourcentage;
      print FOUT "&nbsp;%</B></TD>\n</TR>\n";
  }

  print FOUT "</TABLE>\n";
  print FOUT "</CENTER>\n";
}


  print FOUT "</TD></TR></TABLE>\n";
  print FOUT "<P><BR>\n";
  print FOUT "</BODY></HTML>\n";
}
