#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                       DAILY STATS                              #####
####                                                                #####
####                      (http server)                             #####
####                                                                #####
####    domisse@w3perl.com                   version 16/05/2007     #####
####                                                                #####
#########################################################################

$version = "2.99";
$verdate = "16/05/07";

# Need to improve
# use $tmpfly$vtmp from dirsize to build usemap
# link for date in sortable table

$dirjs = "js";
$dircss = "css";

$sorttablejs = "sorttable.js";
$calendarjs = "basiccalendar.js";
$helpjs = "help.js";

$css_w3perl = "w3perl.css";
$css_help = "help.css";
$css_calendar = "calendar.css";
$enable_weekly = 0;

############ script to launch daily at 00 hour 01 minute  ##########

require "/home/httpd/cgi-bin/w3perl/libw3perl.pl";

$pos = rindex($conf_file,$dirsep);
$vtmp = substr($conf_file,$pos+1,length($conf_file));
$pos = rindex($0,"-");
$vtmp .= substr($0,$pos+1,length($0));
$vtmp =~ s/$plext//g;

$datesyst = &ctime(time);
($dayletter,$month,$day,$hourdate,$a,$year) = split(/[ \t\n\[]+/,$datesyst);
($hour,$minute,$second) = split(/:/,$hourdate);

# calculer le temps mis pour le calcul
$startrun = "$hour:$minute:$second";

print "Daily stats : $version\n";
print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");

#################################################################
###            parsing the command line option                ###
#################################################################

if ($opt_h == 1) {
      print STDOUT "Usage : \n";
      print STDOUT "        -c <file>             : load configuration file\n";
      print STDOUT "        -d <nbdays>           : number of days to scan\n";
      print STDOUT "        -g <";      
      for ($i=0;$i<$#graphic;$i++) {
      print STDOUT "$graphic[$i] ";
      } 
      print STDOUT "$graphic[$#graphic]";
      print STDOUT "> : graphic output (choose one)\n";
      print STDOUT "        -l <";
      for ($i=0;$i<$#lang;$i++) {
      print STDOUT "$lang[$i],";
      } 
      print STDOUT "$lang[$#lang]";
      print STDOUT ">            : language output (comma split)\n";            
      print STDOUT "        -p <level>            : precision level (from 1 to 4)\n";
      print STDOUT "        -x                    : show default value for flag options\n";
      print STDOUT "        -v                    : version\n"; 
      print STDOUT "\n";
      exit;
}


if ($opt_v == 1) {
      print STDOUT "cron-day.pl version $version $verdate\n";
      exit;
}

if ($opt_x == 1) {
      print STDOUT "Default : \n";
      print STDOUT "          -c            : $configfile\n";
      print STDOUT "          -d <nbdays>   : $nbdays\n";
      print STDOUT "          -g <graphic>  : $graphic[0]\n";
      print STDOUT "          -l <language> : ";
      for ($i=0;$i<$#lang;$i++) {
      print STDOUT "$lang[$i],";
      }
      print STDOUT "$lang[$#lang]\n";      
      print STDOUT "          -p <level>    : $precision\n";
      print STDOUT "          -v            : $version\n";
      exit;
}

if ($opt_l ne '') {
  @lang = split(/, /,$opt_l);
  for ($i=0;$i<=$#lang;$i++) {
      $tmp = $dirress.$dirsep."lang".$dirsep.$lang[$i].$plext;
      $tmp = $pathinit.$tmp;
      require "$tmp";
  }
  if ($lang[0] eq '') {
      &error_exit("\nNone of your language choices have been yet translated !");
      }
}

if ($opt_g ne '') {
  if ($opt_g eq "3d")  {
      $bargraph = 1;
      $linegraph = 0;
      $tridim = 1;
  }
  if ($opt_g eq "fill") {
      $bargraph = 0;
      $linegraph = 1;
      $fillgraph = 1;
  }
  if ($opt_g eq "line") {
      $bargraph = 0;
      $linegraph = 1;
  }
  if ($opt_g eq "bar") {
      $bargraph = 1;
      $linegraph = 0;
      $tridim = 0;
  }
}

if ($opt_d ne '') {
$nbdays = $opt_d; 
}

if ($opt_p ne '') {
$precision = $opt_p; 
}

#################################################################
####          debut de l'initialisation                   #######
#################################################################

&MakeDirectories;

$starttime = time();
     
$linkdirdate = $data;

$file1 = $path.$dirgraph.$dirsep."day".$gifext;
$file1x = $path.$dirgraph.$dirsep."dayx".$gifext;
$file1y = $path.$dirgraph.$dirsep."dayy".$gifext;
$linkfile1 = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."day".$gifext;
$linkfile1x = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."dayx".$gifext;
$linkfile1y = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."dayy".$gifext;

$file2 = $path.$dirgraph.$dirsep."daysize".$gifext;
$file2x = $path.$dirgraph.$dirsep."daysizex".$gifext;
$file2y = $path.$dirgraph.$dirsep."daysizey".$gifext;
$linkfile2 = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."daysize".$gifext;
$linkfile2x = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."daysizex".$gifext;
$linkfile2y = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."daysizey".$gifext;

$sizedirgraph = $path.$dirgraph.$dirsep."day_repert_size".$gifext;
$linksizedirgraph = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."day_repert_size".$gifext;

$others = "others".$gifext;
$tabnamecsv = $tabnamedays;
$tabnamecsv =~ s/$htmlext//;

#################################################################
####                   date de ce jour                    #######
#################################################################

### today date

$datesyst = &ctime(time);
($dayletter,$month,$day,$hourdate,$a,$year) = split(/\s+/,$datesyst);
$year = $a if ($year eq '');
$day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);
$month_number = $month_equiv{$month};
$month_number--;
($hour,$minute,$second) = split(/:/,$hourdate);
$today = $day." ".$month." ".$year;

$year_now = $year;
$tt_deb = &nbday($today);

# annee bissextile ==> fevrier a 29 jours

if (($year%4 == 0 && $year%100 != 0) || $year%400 == 0) {
$month_of_year{'Feb'} = '29';
$bisextil = 1;
}

### nombre de jour entre le 1er janvier et $today

#$timesec = time;
#&get_time($timesec);
#($jour_of_year_end) = split(/ /,$datemisc);
$jour_of_year_end = &nbday($today);

#print STDERR "JOUR_OF_YEAR_END : $jour_of_year_end\n";

### date il y a $nbdays jours

if ($nbdays != 0 ) {

$pastday = $day  - $nbdays; 
$pastyear = $year;
$pastmonth = $month_nb[$month_number];

while ($pastday < 1) {
  $month_number--;
  if ($month_number < 0) {
      $pastyear--;
      $month_number = 11;
   }
   $pastmonth = $month_nb[$month_number];
   $pastday = $pastday + $month_of_year{$pastmonth};
}

$pasttoday = $pastday." ".$pastmonth." ".$pastyear;         
  
}

#print "Aujourd'hui nous sommes le $today\n";
#print STDERR "il y a $nbdays jours , nous etions le $pasttoday\n";

#################################################################
### number of days found

$line = 0;
$count = 0;

 open(INFILE, "$path$dirdata$dirsep$datafile") || &error_exit("Error, unable to open $path$dirdata$dirsep$datafile");
 $count_day = 1;
 while (<INFILE>) {

     $line++;
     next unless ($line > 3);

     $count++;

     $oldjour = $jour;
     $oldmonth = $month;

    ($jour,$month,$year,$m_tot,$m_new,$m_dom,$req_tot,$req_dom,$access,$totsize,$tothtmlsize,$domsize,$script,$pays) = split('\s+');

     $intervalle = $jour - $oldjour;
     if ($intervalle != 1 && $line > 4) {
	 if ($oldmonth ne $month) {
	     $intervalle = $month_of_year{$oldmonth} - $oldjour; # suppose le mois suivant
	     $intervalle += $jour;
	 }

	 for ($i=$count;$i<($intervalle+$count-1);$i++) {
	     $oldjour++;
	     if ($oldjour > $month_of_year{$oldmonth}) {
                 $oldjour = 1;
	     } 
	     
	     $oldjour = "0".$oldjour if (length($oldjour) == 1 && $struct_compressed_logfile !~ /\%smallday/);
	     $day = $oldjour." ".$affmonth." ".$year;

	 }
	 $count_day += $intervalle-1;
	 $line = $count;
     }

     $count_day++;

     }

$count_day--;
#$count_day -= 4; #ote ligne du header
$count_day = $nbdays if ($count_day > $nbdays && $nbdays != 0);
$line_density = 0.001*$count_day;
$shift_factor = 0.3;

 close(INFILE);

#################################################################
#####               computing daily stats                  ######
#################################################################

for ($nblang=0;$nblang<=$#lang;$nblang++) {

    $tabdays = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$tabnamedays;
    
    open(TABOUT, ">$tabdays") || &error_exit("Error, unable to open $tabdays");
    &TableHeader(*TABOUT, eval($Lang{$lang[$nblang]}));
    close(TABOUT);
}

&TableDays();


sub TableHeader { 
 local(*FOUT,*L) = @_;

 print FOUT "$doctype\n";
 print FOUT "<HTML><HEAD>\n";
 print FOUT "$charset\n";
 print FOUT "<TITLE>$L{'Tab_about_lastdays1'} $count_day $L{'Tab_about_lastdays2'} ($L{'Textual_version'})</TITLE>\n";
 print FOUT "<!-- Page generated by w3perl - cron-day.pl $version - $today $hourdate -->\n";
 print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
# print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$tablejs\"></script>\n";
 print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
 print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
 print FOUT "</HEAD>\n";
 print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
 print FOUT "<H2> $L{'Tab_about_lastdays1'} $count_day $L{'Tab_about_lastdays2'}</H2><P>\n";
 print FOUT "<P><HR><P>\n";
 print FOUT "<A HREF=\"..$dirsepurl..$dirsepurl$dircsv$dirsepurl$tabnamecsv$csvext\">CSV</A>" if (-f "$path$dircsv$dirsep$tabnamecsv$csvext");
 print FOUT "<TABLE CLASS=\"sortable\" ID=\"day-table\">\n";
 print FOUT "<TR>\n";
 print FOUT "<TH>$L{'Date'}</TH>\n";
 print FOUT "<TH>$L{'Hosts'}</TH>\n";
 print FOUT "<TH>$L{'New_Hosts'}</TH>\n";
 print FOUT "<TH>$L{'Domain_Hosts'}</TH>\n";
 print FOUT "<TH>$L{'Requests'}</TH>\n" if ($mail_format == 0 && $ftp_format == 0);
 print FOUT "<TH>$L{'Files'}</TH>\n" if ($ftp_format == 1);
 print FOUT "<TH>$L{'Email'}</TH>\n" if ($mail_format == 1);
 print FOUT "<TH>$L{'Accesses'}</TH>\n" if ($mail_format == 0 && $ftp_format == 0);
 print FOUT "<TH>$L{'DomReq'}</TH>\n";
 print FOUT "</TR>\n";
}

sub TableDays { 
 $line = 0;
 $inc = 0;
 $count_day = 1;
 $count_week = 1;
 $count = 0;

# On verifie que l'on peut obtenir un graph sur les $nbdays derniers jours
 
 open(INFILE, "$path$dirdata$dirsep$datafile") || &error_exit("Error, unable to open $path$dirdata$dirsep$datafile");

 while (<INFILE>) {
     $line++;
     next unless ($line > 3);
     $count++;

    ($jour,$month,$year,$m_tot,$m_new,$m_dom,$req_tot,$req_dom,$access,$totsize,$tothtmlsize,$domsize,$script,$pays) = split('\s+');

     $tmp = "$jour $month $year";

     if ($nbdays != 0) {
	 $jour_of_year = &nbday($tmp);
	 $jour_ecoule = $jour_of_year_end - $jour_of_year;
     }

     next unless ($jour_ecoule <= $nbdays || $nbdays == 0);
     $day = $jour." ".$month." ".$year;  

     if ($start_date eq '') {
       $start_date = $day;
     }

 }
 close(INFILE);

 if ($count == 0) {
     &error_exit("No data found. File is either corrupt or empty !");
 }

if ($start_date eq '') {
    $nbdays = $jour_ecoule+$count;
    print "Overriding current value of \$nbdays to $nbdays\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
}

#

 $line = 0;
 $count = 0;
# $tmp3 = 7;

 open(OUT, ">$path$dircsv$dirsep$tabnamecsv$csvext");
 print OUT "#\"Date\",\"Hosts\",\"New_Hosts\",\"Domain_Hosts\"";
 print OUT ",\'Requests\"" if ($mail_format == 0 && $ftp_format == 0);
 print OUT ",\"File\"" if ($ftp_format == 1);
 print OUT ",\"Email\"" if ($mail_format == 1);
 print OUT ",\"Accesses\"" if ($mail_format == 0 && $ftp_format == 0);
 print OUT ",\"DomReq\"\n";

 open(INFILE, "$path$dirdata$dirsep$datafile") || &error_exit("Error, unable to open $path$dirdata$dirsep$datafile");

 while (<INFILE>) {
     $line++;
     next unless ($line > 3);

     $count++;
     $oldjour = $jour;
     $oldmonth = $month;

    ($jour,$month,$year,$m_tot,$m_new,$m_dom,$req_tot,$req_dom,$access,$totsize,$tothtmlsize,$domsize,$script,$pays) = split('\s+');

     $tmp = "$jour $month $year";

     push(@listhost,$m_tot);
     push(@listsize,$totsize);
     push(@listreq,$req_tot);
     push(@listacc,$access);
     push(@listdate,$tmp);

     if ($nbdays != 0) {
	 $jour_of_year = &nbday($tmp);
	 $jour_ecoule = $jour_of_year_end - $jour_of_year;
     }

     next unless ($jour_ecoule <= $nbdays || $nbdays == 0);

     $inc++;
     $day = $jour." ".$month." ".$year;  

     if ($start_date eq '') {
       $start_date = $day;
       $tmp_start_date = &nbday($day);
     }

     ### test sur le jour suivant
    
     $intervalle = $jour - $oldjour;
     if ($intervalle != 1 && $line > 4) {

	 if ($oldmonth ne $month) {
	     $intervalle = $month_of_year{$oldmonth} - $oldjour; # suppose le mois suivant
	     $intervalle += $jour;
	 }
	 $affmonth = $oldmonth;
	 for ($i=$count;$i<($intervalle+$count-1);$i++) {
	     $oldjour++;

	     if (($year%4 == 0 && $year%100 != 0) || $year%400 == 0) {
		 $month_of_year{'Feb'} = '29';
	     } else {
		 $month_of_year{'Feb'} = '28';
	     }

	     if ($oldjour > $month_of_year{$oldmonth}) {
                 $oldjour = 1;
                 $affmonth = $month;
	     } 
	     
	     $oldjour = "0".$oldjour if (length($oldjour) == 1 && $struct_compressed_logfile !~ /\%smallday/);

	     $year_tmp = $year;
             $year_tmp = $year-1 if ($affmonth eq "Dec" && ($oldmonth eq "Dec" && $oldmonth ne $month));
             $day = $oldjour." ".$affmonth." ".$year_tmp;

	     $day = $oldjour." ".$affmonth." ".$year_tmp;
	     $tmp_start_date2 = &nbday($day);

	     if ($tmp_start_date2 < $tmp_start_date) {
		 $tmp_start_date = $tmp_start_date2;
		 $start_date = $day;
	     }


	     for ($nblang=0;$nblang<=$#lang;$nblang++) {
		 $tabdays = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$tabnamedays;
		 open(FOUT, ">>$tabdays") || &error_exit("Error, unable to open $tabdays");
		 print FOUT "<TR>\n";
		 print FOUT "<TD CLASS=\"left\">$day</TD>\n";
		 print FOUT "<TD CLASS=\"right\">0</TD>\n<TD CLASS=\"right\">0</TD>\n<TD CLASS=\"right\">0</TD>\n<TD CLASS=\"right\">0</TD>\n";
		 print FOUT "<TD CLASS=\"right\">0</TD>\n" if ($mail_format == 0 && $ftp_format == 0);
		 print FOUT "<TD CLASS=\"right\">0</TD>\n</TR>\n";
		 close(FOUT);
	    }

	     print OUT "\"$day\",\"0\",\"0\",\"0\",\"0\"";
	     print OUT ",\"0\"" if ($mail_format == 0 && $ftp_format == 0);
	     print OUT ",\"0\"\n";
	     
	     if ($inc == 7 && $enable_weeky == 1) {
		 for ($nblang=0;$nblang<=$#lang;$nblang++) {
		     $tabdays = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$tabnamedays;
		     open(FOUT, ">>$tabdays") || &error_exit("Error, unable to open $tabdays");
		     print FOUT "<TR>\n<TD>&nbsp;</TD>\n<TD ALIGN=CENTER>";
		     print FOUT "-" x (2 + length($m_total));
		     print FOUT "</TD>\n<TD>&nbsp;</TD>\n<TD>&nbsp;</TD>\n<TD ALIGN=CENTER>";
		     print FOUT "-" x (2 + length($req_total));
		     print FOUT "</TD>\n<TD ALIGN=CENTER>";
		     print FOUT "-" x (2 + length($access_total));
		     print FOUT "</TD>\n<TD>&nbsp;</TD>\n</TR>\n";
		     print FOUT "<TR>\n<TD>&nbsp;</TD>\n";
		     print FOUT "<TD ALIGN=CENTER><B>$m_total</B></TD>\n";
		     print FOUT "<TD>&nbsp;</TD><TD>&nbsp;</TD>\n";
		     print FOUT "<TD ALIGN=CENTER><B>$req_total</B></TD>\n";
		     print FOUT "<TD ALIGN=CENTER><B>$access_total</B></TD>\n" if ($mail_format == 0 && $ftp_format == 0);
		     print FOUT "<TD>&nbsp;</TD>\n</TR>\n";
		     print FOUT "<TR>\n<TD COLSPAN=7>&nbsp;</TD>\n</TR>\n";
		     close(FOUT);
		 }
		 $m_total = 0;
		 $req_total = 0;
		 $access_total = 0;
		 $inc -= 7;
	     }
	     $inc++;
	 }
	 $count += $intervalle-1;
	 $count_day += $intervalle-1;
	 $line = $count;
     }

     $access_total += $access;
     $m_total += $m_tot;
     $req_total += $req_tot;
     $reqmaxtot{$count_day} = $req_tot;
     $accessmaxtot{$count_day} = $access;
     $mmaxtot{$count_day} = $m_tot;

     $reqmax = $req_tot if ($req_tot > $reqmax);    

     $sizetot{$count_day} = $totsize if ($optdirsize > 3);
     $sizetot{$count_day} = $tothtmlsize if ($optdirsize < 4);

     $maxtot = $sizetot{$count_day} if ($sizetot{$count_day} > $maxtot);    

     $day = $jour." ".$month." ".$year;

     for ($nblang=0;$nblang<=$#lang;$nblang++) {

	 $linkjour = "..".$dirsepurl.$dirdate.$dirsepurl.$year."-".$month."-".$jour.$dirsepurl.$menu;
	 $fulljour = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$year."-".$month."-".$jour.$dirsep.$fileresumemenu;

	 if (-e $fulljour){
	     $writeday = '<A HREF="'.$linkjour.'">'.$day;
	     $writeday .= "</A>";
	 } else {
	     $writeday = $day;
	 }

       # MAJ des resumes

	 ($dayprevious,$monthprevious,$yearprevious) = split(/ /,$previousday);

	 $dirresumeprevious = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$yearprevious."-".$monthprevious."-".$dayprevious.$dirsep.$fileresumemenu;

	 $dirresume = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$year."-".$month."-".$jour.$dirsep;
	 $dirresume2 = $path.$lang[$nblang].$dirsep.$dirsession.$dirsep.$filemoyenne;

	 open(FILERESUME,"$fulljour");
	 @dataline = (<FILERESUME>);
	 close (FILERESUME);

	 # Calcul jour suivant
	 $dirresumenext = '';
	 $jjour = $jour;
	 $jmonth = $month;
	 $jyear = $year;
	 while (!(-e $dirresumenext) && $tt < $tt_deb) {
	     $jjour++;
	     $jjour = "0".$jjour if (length($jjour) == 1 && $struct_compressed_logfile !~ /\%smallday/);

	     if (($jyear%4 == 0 && $jyear%100 != 0) || $jyear%400 == 0) {
		 $month_of_year{'Feb'} = '29';
	     } else {
		 $month_of_year{'Feb'} = '28';
	     }

	     if ($jjour > $month_of_year{$jmonth}) {
		 $jmonth = $month_nb[$month_equiv{$jmonth}];
		 $jmonth = $month_nb[0] if ($jmonth eq '');
		 $jjour = "1" if ($struct_compressed_logfile =~ /\%smallday/);
		 $jjour = "01" if ($struct_compressed_logfile !~ /\%smallday/);
		 $jyear++ if ($jmonth eq $month_nb[0]);
	     }
	     $dirresumenext = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$jyear."-".$jmonth."-".$jjour.$dirsep.$fileresumemenu;

	     $tt = &nbday("$jjour $jmonth $jyear");
	 }

	 if (-e $fulljour) {
	     open(FILERESUME,">$fulljour");
	     for ($i=0;$i<=$#dataline;$i++) {
		 $dataline[$i] =~ s/<!-- PREVIOUS (.*)-->/<IMG SRC=$1/ if (-e "$dirresumeprevious");
		 $dataline[$i] =~ s/<!-- NEXT (.*)-->/<IMG SRC=$1/ if (-e "$dirresumenext");
		 $dataline[$i] =~ s/<!-- REFER (.*)-->/<IMG SRC=$1/ if (-e "$dirresume$refer");
		 $dataline[$i] =~ s/<!-- REFER2 (.*) -->/$1/ if (-e "$dirresume$refer");
		 $dataline[$i] =~ s/<!-- AGENT (.*)-->/<IMG SRC=$1/ if (-e "$dirresume$agent");
		 $dataline[$i] =~ s/<!-- AGENT2 (.*) -->/$1/ if (-e "$dirresume$agent");
		 $dataline[$i] =~ s/<!-- SESSION (.*)-->/<IMG SRC=$1/ if (-e "$dirresume$dirsession$htmlext");
		 $dataline[$i] =~ s/<!-- SESSION2 (.*) -->/$1/ if (-e "$dirresume$dirsession$htmlext");
		 $dataline[$i] =~ s/<!-- HOUR (.*)-->/<IMG SRC=$1/ if (-e "$dirresume$filenamehour");
		 $dataline[$i] =~ s/<!-- HOUR2 (.*) -->/$1/ if (-e "$dirresume$filenamehour");
		 $dataline[$i] =~ s/<!-- VIRUS (.*)-->/<IMG SRC=$1/ if (-e "$dirresume$filevirus");
		 $dataline[$i] =~ s/<!-- VIRUS2 (.*) -->/$1/ if (-e "$dirresume$filevirus");
		 $dataline[$i] =~ s/<!-- AVERAGE (.*)-->/<IMG SRC=$1/ if (-e "$dirresume2");
		 $dataline[$i] =~ s/<!-- AVERAGE2 (.*) -->/$1/ if (-e "$dirresume2");

		 # tester si les liens existent toujours (effacement des fichiers anciens)
		 if ($dataline[$i] =~ /$icon_flecheg/i) {
		     $tmp = $dataline[$i];
		     $tmp1 = $2 if ($tmp =~ /(.*)<A HREF="(.*)" TARGET/i);
		     $tmp2 = $1;
		     $tmp1 =~ s/\.\.\///;
		     $tmp1 = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$tmp1;
		     $dataline[$i] = "$tmp2</TD>\n" if (!(-f "$tmp1"));
		 }
		 print FILERESUME "$dataline[$i]";
	     }
	     close (FILERESUME);
	 }
    
	 if ($enable_pdf == 1 && $nblang == 0) {

	     if (-d $dirresume) {

		 push(@pdf_page,$filemoyenne);
		 push(@pdf_page,"$dirpage$htmlext");
		 push(@pdf_page,"$dirsite$htmlext");
		 push(@pdf_page,"$dirlist$htmlext") if ($mail_format != 0);

		 if (-f "$path$lang[0]$dirsep$dirdate$dirsep$year-$month-$jour$dirsep$dirpays$htmlext") {

		     push(@pdf_page,"$dirpays$htmlext");

		     # add countries if available
		     if ($precision > 3) {
			 $file = $path.$lang[0].$dirsep.$dirdate.$dirsep.$year."-".$month."-".$jour.$dirsep.$dirpays.$htmlext;
	    
			 open(FILEHTML,"$file") || &error_exit("Can't open $file");
			 while (<FILEHTML>) {
			     next if ($_ =~ /\"javascript\"/i);
			     next if ($_ =~ /\"stylesheet\"/i);
			     next if ($_ =~ /<body/i && $i != 0);
			     next if ($_ =~ /<\/body>/i);
			     next if ($_ =~ /<\/html>/i);
			     if (/<[A|AREA]([",a-z=\s\d]+)HREF="([&;~: &*#0-9a-z_\?\-\/\<\>\!.]+)"([\(\)!';",_a-z=\s\d]*)>/i) {
				 push(@pdf_page,$2) if (-f "$path$lang[0]$dirsep$dirdate$dirsep$year-$month-$jour$dirsep$2");
			     }
			  }
			  close(FILEHTML);
		      }
		 }

		 push(@pdf_page,"$dirscript$htmlext") if ($mail_format != 0);
		 push(@pdf_page,"$filetype$htmlext") if ($mail_format != 0);
		 push(@pdf_page,"$dirtraffic$htmlext") if (-e "$dirresume$dirtraffic$htmlext");
		 push(@pdf_page,$tabnamerefer) if (-e "$dirresume$refer");
		 push(@pdf_page,$tabnamekeyword) if (-e "$dirresume$refer");
		 push(@pdf_page,$tabnamebrowser) if (-e "$dirresume$agent");
		 push(@pdf_page,$filevirus) if (-e "$dirresume$filevirus");
		 push(@pdf_page,$filenamehour) if (-e "$dirresume$filenamehour");
		 push(@pdf_page,"$dirsession$htmlext") if (-e "$dirresume$dirsession$htmlext");

	     
		 $fileday = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$filenameday;
		 $filepdf = $path.$dirpdf.$dirsep.$year."-".$month."-".$jour.$pdfext;
#		 $command = "$HTMLDOC $htmldoc_option --titlefile $fileday --outfile $filepdf ";
		 $command = "$htmldoc_option --titlefile $fileday -f $filepdf | ";
#		 $command = "$htmldoc_option -f $filepdf | ";
		 for ($i=0;$i<=$#pdf_page;$i++) {
		     $tmp = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$year."-".$month."-".$jour.$dirsep.$pdf_page[$i];
		     $command .= "$tmp ";
		 }
#	     print "$command\n\n";
		 push(@list_cmd,$command);
		 undef(@pdf_page);
	     }
	 }

	 $previousday = $day;

        $tabdays = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$tabnamedays;
	 open(FOUT, ">>$tabdays") || &error_exit("Error, unable to open $tabdays");
#	 print FOUT "<TR onmouseover=\"setPointer(this, $count, 'over', '$bgcolor', '$bgcolor_tab3', '$bgcolor_tab4','$tmp3');\" onmouseout=\"setPointer(this, $count, 'out', '$bgcolor', '$bgcolor_tab3', '$bgcolor_tab4','$tmp3');\" onmousedown=\"setPointer(this, $count, 'click', '$bgcolor', '$bgcolor_tab3', '$bgcolor_tab4','$tmp3')\">\n<A NAME=\"$count_day\">";
	 print FOUT "<TR>\n";
	 print FOUT "<TD CLASS=\"left\"><A NAME=\"$count_day\"></A>$writeday</TD>\n";
	 print FOUT "<TD CLASS=\"right\">$m_tot</TD>\n";
	 print FOUT "<TD CLASS=\"right\">$m_new</TD>\n";
	 print FOUT "<TD CLASS=\"right\">$m_dom</TD>\n";
	 print FOUT "<TD CLASS=\"right\">$req_tot</TD>\n";
	 print FOUT "<TD CLASS=\"right\">$access</TD>\n" if ($mail_format == 0 && $ftp_format == 0);
	 print FOUT "<TD CLASS=\"right\">$req_dom</TD>\n";
	 print FOUT "</TR>\n";
	 close(FOUT);
     }
     print OUT "\"$day\",\"$m_tot\",\"$m_new\",\"$m_dom\",\"$req_tot\"";
     print OUT ",\"$access\"" if ($mail_format == 0 && $ftp_format == 0);
     print OUT ",\"$req_dom\"\n";        

     if ($inc == 7 && $enable_weekly == 1) {
	 for ($nblang=0;$nblang<=$#lang;$nblang++) {
	     $tabdays = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$tabnamedays;
	     open(FOUT, ">>$tabdays") || &error_exit("Error, unable to open $tabdays");
	     print FOUT "<TR><TD>&nbsp;</TD>\n<TD ALIGN=CENTER>";
	     print FOUT "-" x (2 + length($m_total));
	     print FOUT "</TD><TD>&nbsp;</TD>\n<TD>&nbsp;</TD>\n<TD ALIGN=CENTER>";
	     print FOUT "-" x (2 + length($req_total));
	     print FOUT "</TD>\n<TD ALIGN=CENTER>";
	     print FOUT "-" x (2 + length($access_total));
	     print FOUT "</TD>\n<TD>&nbsp;</TD>\n</TR>\n";
	     print FOUT "<TR>\n<TD>&nbsp;</TD>\n";
	     print FOUT "<TD ALIGN=CENTER><B>$m_total</B></TD>\n";
	     print FOUT "<TD>&nbsp;</TD>\n<TD>&nbsp;</TD>\n";
	     print FOUT "<TD ALIGN=CENTER><B>$req_total</B></TD>\n";
	     print FOUT "<TD ALIGN=CENTER><B>$access_total</B></TD>\n" if ($mail_format == 0 && $ftp_format == 0);
	     print FOUT "<TD>&nbsp;</TD>\n</TR>\n";
	     print FOUT "<TR>\n<TD COLSPAN=7>&nbsp;</TD>\n</TR>\n";
	     close(FOUT);
	 }
	 
	 $m_total = 0;
	 $req_total = 0;
	 $access_total = 0;
	 $inc -= 7;
     }
        
     $count_day++;
}

 $count_day--;
 close(INFILE);
 close(OUT);
 close(FLY); 

# fermeture de la page HTML du tableau sur les jours

for ($nblang=0;$nblang<=$#lang;$nblang++) {

    $tabdays = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$tabnamedays;
    open(FOUT, ">>$tabdays") || &error_exit("Error, unable to open $tabdays");
    print FOUT "</TABLE>\n";
    print FOUT "<P><HR><P>\n";    
    print FOUT "</BODY></HTML>\n";
    close (FOUT);
}
}

# check if something have been log

if ($count_day == 0 && $line == 0) {
    &error_exit("Error : No data have been yet recorded");
    }

if ($start_date eq '') {
    $msg = "Error : You choose to scan the $nbdays previous day\n";
    $msg .= "        but the most recent day in the data file is only $jour_ecoule days old\n";
    $msg .= "        Use the switch \"-d <days>\" with <days> from $jour_ecoule to ".($jour_ecoule+$count).".\n";
    &error_exit($msg);
}

#################################################################
#####                      proxy                          #######
#################################################################

if ($squid_format == 1) {
    open(FILEDATESQUID, "$path$dirdata$dirsep$dirproxy") || &error_exit("Error, unable to open $path$dirdata$dirsep$dirproxy");
    while (<FILEDATESQUID>) {
	next if ($_ =~ /^\#/);
	    ($jour,$month,$year,@proxydata) = split('\s+');
	    for ($k=0;$k<$#proxydata;$k+=3) {
		$status = $proxydata[$k];
		next if ($status !~ /TCP/);
		if ($status =~ /HIT/ || $status =~ /MISS/) {
		    $knext = $k+1;
		    if ($status =~ "HIT") {
			$hit_squid{$count_day_squid} += $proxydata[$knext];
			$knext++;
			$hit_size{$count_day_squid} += $proxydata[$knext];
		    }
		    if ($status =~ "MISS") {
			$miss_squid{$count_day_squid} += $proxydata[$knext];
			$knext++;
			$miss_size{$count_day_squid} += $proxydata[$knext];
		    }

		}
	    }
#	    print "HIT - $hit_squid{$count_day_squid} - $hit_size{$count_day_squid}\n";
#	    print "MISS - $miss_squid{$count_day_squid} - $miss_size{$count_day_squid}\n";
	    $count_day_squid++;
	}
    close(FILEDATESQUID);
}


#################################################################
#####         requests, accesses and hosts graphs         #######
#################################################################

#################################################################
# Fly

#if (-x $FLY) {
$it = length($count_day)-1;
$div = 10**$it;
$factx = ($div*(int($count_day/$div)+1))/$grad;

$it = length($reqmax)-1;
$div = 10**$it;
$facty = ($div*(int($reqmax/$div)+1))/$grad;

$fymax = $ymax-1;

$perspec = $xstep/$factx if (($perspec > $xstep/$factx) && ($tridim == 1));

### image pour les abscisses

($startday, $startmonth) = split(/ /,$start_date);

$moischiffre = $month_equiv{$startmonth};
$moischiffre--;
$moisvar = $startmonth;
$valmois = $moischiffre;

$valstep = $startday;
$valstep = "0".$valstep if (length($valstep) == 1);

$xlegend = "$count_day days (starting $start_date)";

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xmax,$ydecal\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 $posx = (($xmax/2)-(length($xlegend)*7/2));
 print FLY "string 0,0,0,$posx,$ydecalm,medium,$xlegend\n";
 for ($i=$xstep;$i<$xmax;$i+=$xstep) {
 $valstep = int(($i/$xmax)*(($xmax*$factx/$xstep)))+$startday;

 $moisvar = $startmonth;
 $valmois = $moischiffre;

 while  ($valstep > $month_of_year{$moisvar}) {
     $valstep = ($valstep - $month_of_year{$moisvar});
     $valmois++;
     $valmois = 0 if ($valmois > 11);
     $moisvar = $month_nb[$valmois];
 }

 $valstep = "0".$valstep if (length($valstep) == 1);
 $val = "$moisvar/$valstep";
 $posx = $i - length($valstep)*10;
 print FLY "line $i,0,$i,5,0,0,0\n";
 print FLY "string 0,0,0,$posx,10,small,$val\n";

 }
print FLY "transparent 200,200,200\n";
close (FLY);
 
open(FOO,"$FLY -q -i $tmpfly$vtmp -o $file1x |");
while( <FOO> ) {print;}
close(FOO);

### image pour les ordonnees
 
open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xdecal,$ymax\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 for ($i=$ystep;$i<$ymax;$i+=$ystep) {
 $valstep = int(($ymax - $i) * ($facty/$ystep));
 print FLY "line $xdecalm,$i,$xdecal,$i,0,0,0\n";
 $pos = ($xdecal - length($valstep)*9);
 $posy = $i-5;
 print FLY "string 0,0,0,$pos,$posy,small,$valstep\n";
 }
print FLY "transparent 200,200,200\n";
close (FLY);
 
open(FOO,"$FLY -q -i $tmpfly$vtmp -o $file1y |");
while( <FOO> ) {print;}
close(FOO);

###

 open(FLY,">$tmpfly$vtmp");
 print FLY "new\n";
 print FLY "size $xmax,$ymax\n";
 print FLY "frect 0,0,0,0,200,200,200\n"; 
 for ($i=1;$i<=$count_day;$i++) {
 $x1 = ($i-1+$tridim)*$xstep/$factx;
 $x2 = ($i+$tridim)*$xstep/$factx;
 $y2 = $ymax - ($ystep/$facty * $reqmaxtot{$i});
# $y2ppp = $ymax - ($ystep/$facty * $reqmaxtot{$i-1});

 $x1 = $x1 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);
 $x2 = $x2 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);


 if ($bargraph == 1) {
   $x2 -= $perspec if ($tridim == 1);
   $x1 -= $perspec if ($tridim == 1);
   print FLY "frect $x1,$y2,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
   print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n"; 
#   print FLY "rect $x1,$y2,$x1,$y2ppp,0,0,0\n";
   if ($tridim == 1 && $y2 != $ymax) {

        $x1plus = $x1+$perspec;
        $x2plus = $x2+$perspec;
        $y2plus = $y2-$perspec;
        $y1plus = $ymax - $perspec;

        print FLY "fpoly $red[0],$green[0],$blue[0],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";

        print FLY "fpoly $red[0],$green[0],$blue[0],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
        print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";

   }
 }

 if ($linegraph == 1) {
   $y1 = $ymax - ($ystep/$facty * $reqmaxtot{$i+1});
   print FLY "line $x1,$y2,$x2,$y1,$red[0],$green[0],$blue[0]\n";

   if ($fillgraph == 1) {
      if ($y1 != $y2 || $y2 != $ymax) {
        print FLY "line $x1,$ymax,$x1,$y2,$red[0],$green[0],$blue[0]\n";
        print FLY "line $x2,$ymax,$x2,$y1,$red[0],$green[0],$blue[0]\n";
        print FLY "line $x1,$ymax,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
        $fx1 = $x1+1;

        print FLY "fill $fx1,$fymax,$red[0],$green[0],$blue[0]\n";
     }
   }
 }
}

close (FLY);

if ($mail_format == 0 && $ftp_format == 0) {
open(FLY,">>$tmpfly$vtmp");
 for ($i=1;$i<=$count_day;$i++) {

 $x1 = ($i-1+$tridim)*$xstep/$factx;
 $x2 = ($i+$tridim)*$xstep/$factx;

 $x1 = $x1 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);
 $x2 = $x2 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);

 $x1 += $factx*$shift_factor;
 $x2 += $factx*$shift_factor;

 $y2 = $ymax - ($ystep/$facty * $accessmaxtot{$i});
# $y2ppp = $ymax - ($ystep/$facty * $accessmaxtot{$i-1});

 if ($bargraph == 1) {
   $x2 -= $perspec*2 if ($tridim == 1);
   $x1 -= $perspec*2 if ($tridim == 1);
   print FLY "frect $x1,$y2,$x2,$ymax,$red[1],$green[1],$blue[1]\n";
   print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n"; 
#   print FLY "rect $x1,$y2,$x1,$y2ppp,0,0,0\n"; 
   if ($tridim == 1 && $y2 != $ymax) {

        $x1plus = $x1+$perspec;
        $x2plus = $x2+$perspec;
        $y2plus = $y2-$perspec;
      
        print FLY "fpoly $red[1],$green[1],$blue[1],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";

        print FLY "fpoly $red[1],$green[1],$blue[1],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
        print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";

   }
 }

 if ($linegraph == 1) {
    $y1 = $ymax - ($ystep/$facty * $accessmaxtot{$i+1});
    print FLY "line $x1,$y2,$x2,$y1,$red[1],$green[1],$blue[1]\n";

    if ($fillgraph == 1) {
      if ($y1 != $y2 || $y1 != $ymax) {
        print FLY "line $x1,$ymax,$x1,$y2,$red[1],$green[1],$blue[1]\n";
        print FLY "line $x2,$ymax,$x2,$y1,$red[1],$green[1],$blue[1]\n";
        print FLY "line $x1,$ymax,$x2,$ymax,$red[1],$green[1],$blue[1]\n";
        $fx1 = $x1+1;
        print FLY "fill $fx1,$fymax,$red[1],$green[1],$blue[1]\n";
      }
    }
 }
}

close (FLY);
}

open(FLY,">>$tmpfly$vtmp");
 for ($i=1;$i<=$count_day;$i++) {

 $x1 = ($i-1+$tridim)*$xstep/$factx;
 $x2 = ($i+$tridim)*$xstep/$factx;

 $x1 = $x1 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);
 $x2 = $x2 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);

 $x1 += $factx*2*$shift_factor;
 $x2 += $factx*2*$shift_factor;

 $y2 = $ymax - ($ystep/$facty * $mmaxtot{$i});
# $y2ppp = $ymax - ($ystep/$facty * $mmaxtot{$i-1});

 if ($bargraph == 1) {
   $x2 -= $perspec*3 if ($tridim == 1);
   $x1 -= $perspec*3 if ($tridim == 1);
   print FLY "frect $x1,$y2,$x2,$ymax,$red[2],$green[2],$blue[2]\n";
   print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n"; 
#   print FLY "rect $x1,$y2,$x1,$y2ppp,0,0,0\n"; 
   if ($tridim == 1 && $y2 != $ymax) {

        $x1plus = $x1+$perspec;
        $x2plus = $x2+$perspec;
        $y2plus = $y2-$perspec;

        print FLY "fpoly $red[2],$green[2],$blue[2],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";

        print FLY "fpoly $red[2],$green[2],$blue[2],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
        print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";

   }
 }

 if ($linegraph == 1) {
   $y1 = $ymax - ($ystep/$facty * $mmaxtot{$i+1});
   print FLY "line $x1,$y2,$x2,$y1,$red[2],$green[2],$blue[2]\n";

   if ($fillgraph == 1) {
    if ($y1 != $y2 || $y1 != $ymax) {
      print FLY "line $x1,$ymax,$x1,$y2,$red[2],$green[2],$blue[2]\n";
      print FLY "line $x2,$ymax,$x2,$y1,$red[2],$green[2],$blue[2]\n";
      print FLY "line $x1,$ymax,$x2,$ymax,$red[2],$green[2],$blue[2]\n";
      $fx1 = $x1+1;

      print FLY "fill $fx1,$fymax,$red[2],$green[2],$blue[2]\n";
    }
   }
 }
}

print FLY "transparent 200,200,200\n";

close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $file1 |");
while( <FOO> ) {print;}
close(FOO);
#unlink($tmpfly$vtmp);

###

#### Tri pour les peaks

@trireq = reverse sort bynumber @listreq;


for ($i=0;$i<=$topten;$i++) {
    for ($j=0;$j<=$#listreq;$j++) {
	if ($trireq[$i] eq $listreq[$j]) {
	    $trireqdate[$i] = $listdate[$j];
	    $listreq[$j] = 0;
	    last;
	}
    }
}

@triacc = reverse sort bynumber @listacc;

for ($i=0;$i<=$topten;$i++) {
    for ($j=0;$j<=$#listacc;$j++) {
	if ($triacc[$i] eq $listacc[$j]) {
	    $triaccdate[$i] = $listdate[$j];
	    $listacc[$j] = 0;
	    last;
	}
    }
}

@trisize = reverse sort bynumber @listsize;

for ($i=0;$i<=$topten;$i++) {
    for ($j=0;$j<=$#listsize;$j++) {
	if ($trisize[$i] eq $listsize[$j]) {
	    $trisizedate[$i] = $listdate[$j];
	    $listsize[$j] = 0;
	    last;
	}
    }
}

@trihost = reverse sort bynumber @listhost;

for ($i=0;$i<=$topten;$i++) {
    for ($j=0;$j<=$#listhost;$j++) {
	if ($trihost[$i] eq $listhost[$j]) {
	    $trihostdate[$i] = $listdate[$j];
	    $listhost[$j] = 0;
	    last;
	}
    }
}

###

open(IN, "$path$dirdata$dirsep$filerepertsize") || &error_exit("Error, unable to open $path$dirdata$dirsep$filerepertsize");

$line = 0;

while (<IN>) {
    $line++;
    next unless ($line > 3);
    
    ($jour,$month,$year,@reste) = split('\s+');
#     next unless ($jour_ecoule <= $nbdays || $nbdays == 0);

    $tmp = "$jour $month $year";
    push(@listdirdate,$tmp);

     for ($i=0;$i<=$#selecrepert;$i++) {
	 $tmp2 = "dirlist"."_".$i;
	 push(@{$tmp2},$reste[$i*6+$optdirsize-1]);
     }
    
}
close(IN);

for ($i=0;$i<=$#selecrepert;$i++) {
    $tmp2 = "dirlist"."_".$i;
    $tmp3 = "tridir"."_".$i;
    @{$tmp3} = reverse sort bynumber @{$tmp2};

    $tmp4 = "tridirdate"."_".$i;

    for ($k=0;$k<=$topten;$k++) {
	for ($j=0;$j<=$#{$tmp2};$j++) {
	    if ($$tmp3[$k] eq $$tmp2[$j]) {
		$$tmp4[$k] = $listdirdate[$j];
		$$tmp2[$j] = 0;
		last;
	    }
	}
    }
}

###

for ($nblang=0;$nblang<=$#lang;$nblang++) {

    $fileday = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$filenameday;

    open(FILEDAY,">$fileday") || &error_exit("Error, unable to open $fileday");
    &DayStats(*FILEDAY, eval($Lang{$lang[$nblang]}), $lang[$nblang]);
    close(FILEDAY);
}

if ($precision > 2 && $#selecrepert != -1 && $notrafic == 0 && $mail_format == 0 && $ftp_format == 0) {
    for ($nblang=0;$nblang<=$#lang;$nblang++) {
	$tabsize = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$filenametabsize;

	open(TABSIZE,">$tabsize") || &error_exit("Error, unable to open $tabsize");
	&TabDaySize(*TABSIZE, eval($Lang{$lang[$nblang]}),$nblang);
	close(TABSIZE);
    }
}

unlink("$tmpfly$vtmp");

##############################################################
### creation du fichier contenant les stats pour les jours ###
##############################################################

sub DayStats {
 local(*FOUT, *L, $I) = @_;

 print FOUT "$doctype\n";
 print FOUT "<HTML><HEAD>\n";
 print FOUT "$charset\n";
 print FOUT "<TITLE>$L{'Stats_aboutlastdays1'} $count_day $L{'Stats_aboutlastdays2'}</TITLE>\n";
 print FOUT "<!-- Page generated by w3perl - cron-day.pl $version - $today $hourdate -->\n";	 
 print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$calendarjs\"></script>\n";
 print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
 print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
 print FOUT "<SCRIPT LANGUAGE=\"JavaScript\" type=\"text/javascript\">\n";
 print FOUT "var todaydate=new Date()\n";
 print FOUT "var curmonth=todaydate.getMonth()+1 //get current month (1-12)\n";
 print FOUT "var curyear=todaydate.getFullYear() //get current year\n";
 print FOUT "</SCRIPT>\n";

 print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
 print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_calendar\">\n";
 print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
 print FOUT "</HEAD>\n";
 print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

# USEMAP Day1

 $num = 1;

 ($jour, $monthletter,$year) = split(/ /,$start_date);

 $month = $month_equiv{$monthletter};

 print FOUT "<MAP NAME=\"day1\">\n";

 open(FLY,"$tmpfly$vtmp");
 while (<FLY>) {

     if ($_ =~ /^rect/ && $num <= $count_day) {
	 ($tmp,$x1,$tmp,$x2) = split(/[ ,]/);
	 $x1 = 0 if ($x1 < 0);
	 $x1 = int($x1);
	 $x2 = int($x2);

	 $num2 = $num-1;
	 if ($jour > $month_of_year{$monthletter}) {
	     $month++;
	     $year++ if ($month == 13);
	     $month = 1 if ($month == 13);
	     $jour = "1" if ($struct_compressed_logfile =~ /\%smallday/);
	     $jour = "01" if ($struct_compressed_logfile !~ /\%smallday/);
	 }
	 $jour = "0".$jour if (length($jour) == 1 && $struct_compressed_logfile !~ /\%smallday/);
	 $month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
	 $monthletter = $month_nb[$month-1];
	 
	 if ($month == 2) {
	     if (($year%4 == 0 && $year%100 != 0) || $year%400 == 0) {
		 $month_of_year{'Feb'} = "29";
		 $bisextil = 1;
	     } else {
		 $month_of_year{'Feb'} = "28";
		 $bisextil = 0;
	     }
	 }

	 $linkjour = "..".$dirsepurl.$dirdate.$dirsepurl.$year."-".$monthletter."-".$jour.$dirsepurl.$menu;
	 $fulljour = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$year."-".$monthletter."-".$jour.$dirsep.$menu;

	 print FOUT "<AREA SHAPE=\"rect\" COORDS=\"$x1,0,$x2,$ymax\" HREF=\"$tabnamedays#$num\" ALT=\"$num\">\n" if (!(-e $fulljour));
	 print FOUT "<AREA SHAPE=\"rect\" COORDS=\"$x1,0,$x2,$ymax\" HREF=\"$linkjour\" ALT=\"$year$month$jour\">\n" if (-e $fulljour);
	 
	 if (-e $fulljour) {
	     $list[$num2] = "$year$month$jour";
	 }
	 
	 $num++;
	 $jour++;
     }
 }
 print FOUT "</MAP>\n";

# USEMAP Day2

 $num = 1;
 ($jour, $monthletter,$year) = split(/ /,$start_date);

 $month = $month_equiv{$monthletter};

 print FOUT "<MAP NAME=\"day2\">\n";
 open(FLY,"$tmpfly$vtmp");
 while (<FLY>) {
     
     if ($_ =~ /^rect/ && $num <= $count_day) {
	 ($tmp,$x1,$tmp,$x2) = split(/[ ,]/);
	 $x1 = 0 if ($x1 < 0);
	 $x1 = int($x1);
	 $x2 = int($x2);
	 
	 if ($jour > $month_of_year{$monthletter}) {
	     $month++;
	     $year++ if ($month == 13);
	     $month = 1 if ($month == 13);
	     $jour = "1" if ($struct_compressed_logfile =~ /\%smallday/);
	     $jour = "01" if ($struct_compressed_logfile !~ /\%smallday/);
	 }
	 $jour = "0".$jour if (length($jour) == 1 && $struct_compressed_logfile !~ /\%smallday/);
	 $month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
	 $monthletter = $month_nb[$month-1];
	 
	 $linkjour = "..".$dirsepurl.$dirdate.$dirsepurl.$year."-".$monthletter."-".$jour.$dirsepurl.$menu;
	 $fulljour = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$year."-".$monthletter."-".$jour.$dirsep.$menu;
	 
	 print FOUT "<AREA SHAPE=\"rect\" COORDS=\"$x1,0,$x2,$ymax\" HREF=\"$filenametabsize#$num\" ALT=\"$num\">\n" if (!(-e $fulljour));
	 print FOUT "<AREA SHAPE=\"rect\" COORDS=\"$x1,0,$x2,$ymax\" HREF=\"$linkjour\" ALT=\"$year$month$jour\">\n" if (-e $fulljour);
	 
	 $num++;
	 $jour++;
#	 print "UU1 - $jour\n";
     }
 }
 print FOUT "</MAP>\n";

 $jour--;
 $jour = "0".$jour if (length($jour) == 1 && $struct_compressed_logfile !~ /\%smallday/);

 print FOUT "<CENTER>\n";

# print FOUT "<div class=\"CTooltip\" id=\"tt1\">\n";
# print FOUT "Number of times a <b>request</b> is made.<br /> It include any files send as an image, HTML page or Word file.\n";
# print FOUT "</div>\n";

 print FOUT "<TABLE BORDER=0 WIDTH=\"100%\">\n";
 print FOUT "<TR>\n";
 print FOUT "<TD ALIGN=LEFT VALIGN=MIDDLE WIDTH=\"20%\">";

 print FOUT "<DIV ID=\"calendarspace\">\n";
 print FOUT "<SCRIPT LANGUAGE=\"JavaScript\" type=\"text/javascript\">\n";
 print FOUT "document.write(buildCal(curmonth ,curyear, \"main\", \"month\", \"daysofweek\", \"days\", 1,'@list'));\n";
 print FOUT "</SCRIPT>\n";
 print FOUT "</DIV>\n";


# print FOUT "<B>$L{'Requests'}, $L{'Users'}</B><BR><BR>\n";
# print FOUT "<B><A HREF=\"#graph1\">$L{'Graphic'}</A></B><BR><BR>\n";

 print FOUT "</TD>\n";
 print FOUT "<TD ALIGN=CENTER WIDTH=\"60%\">\n";

 print FOUT "<TABLE BORDER=1 BGCOLOR=\"#000000\">\n<TR>\n<TD BGCOLOR=\"#FFEECC\" ALIGN=CENTER>\n";
 print FOUT "<H1>".uc(&noaccentinhtml($L{'Stats_aboutlastdays1'}))." $count_day ".uc(&noaccentinhtml($L{'Stats_aboutlastdays2'}))."</H1>\n";
 print FOUT "</TD>\n</TR>\n</TABLE>\n";

 print FOUT "</TD>\n";
 print FOUT "<TD ALIGN=RIGHT VALIGN=MIDDLE WIDTH=\"20%\">\n";

print FOUT "<B><A HREF=\"$tabnamedays\" TITLE=\"Table of data for the last days\">$L{'Text'}</A></B><BR><BR>\n";
#print FOUT "<B><A HREF=\"..$dirsepurl$dirsession$dirsepurl$filemoyenne#moyjour\">$L{'Average'} $L{'by'} $L{'day'}</A></B><br><br>\n" if (-f "$path$I$dirsep$dirsession$dirsep$filemoyenne");

 if ($precision > 2 && $#selecrepert != -1 && $notrafic == 0 && $mail_format == 0 && $ftp_format == 0) {
#     print FOUT "<B>$L{'Traffic_about'} <br>$L{'directories'}</B><br><br>\n";
#     print FOUT "<B><A HREF=\"#graph2\">$L{'Graphic'}</A></B><br><br>\n";
     print FOUT "<B><A HREF=\"$filenametabsize\" TITLE=\"Traffic for the last days\">$L{'Text'}</A></B><br><br>\n";
 }
 print FOUT "</TD>\n";
 print FOUT "</TR>\n";
 print FOUT "</TABLE>\n";
 print FOUT "</CENTER>\n";

 print FOUT "<HR SIZE=5><P>\n";
 print FOUT "<A NAME=\"graph1\"></A>\n";

#if (-x $FLY) {
 print FOUT "<CENTER>\n<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
 print FOUT "<TR>\n";
 print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkfile1y\" ALT=\"y\"></TD>\n";
 print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkfile1\" ALT=\"graph1\" USEMAP=\"#day1\" BORDER=0></TD>\n";
 print FOUT "</TR><TR><TD></TD>\n";
 print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkfile1x\" ALT=\"x\"></TD>\n";
 print FOUT "</TR>\n";
 print FOUT "<TR>\n<TD>\n</TD>\n";
 print FOUT "<TD ALIGN=CENTER>\n";
 
 print FOUT "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0><TR>\n";
# print FOUT "<TD onmouseover=\"ShowTip(1);\" onmouseout=\"HideTip(1);\"><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[0]\" ALT=\"$gcolor[0]\"></TD>\n";
# print FOUT "<TD onmouseover=\"ShowTip(1);\" onmouseout=\"HideTip(1);\">&nbsp; $L{'Number_of'} $L{'requests'}</TD>\n";
 print FOUT "<TD><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[0]\" ALT=\"$gcolor[0]\"></TD>\n";
 print FOUT "<TD>&nbsp; $L{'Number_of'} ";
 print FOUT "$L{'requests'}" if ($mail_format == 0 && $ftp_format == 0);
 print FOUT "$L{'File'}" if ($ftp_format == 1);
 print FOUT "$L{'Email'}" if ($mail_format == 1);
 print FOUT "</TD>\n";
 print FOUT "</TR>\n";

 if ($mail_format == 0 && $ftp_format == 0) {
     print FOUT "<TR>\n";
     print FOUT "<TD><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"></TD>\n";
     print FOUT "<TD>&nbsp; $L{'Number_of'} $L{'accesses'}</TD>\n";
     print FOUT "</TR>\n";
 }
 print FOUT "<TR>\n";
 print FOUT "<TD><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"></TD>\n";
 print FOUT "<TD>&nbsp; $L{'Number_of'} $L{'Conn_Mach'}</TD>\n";
 print FOUT "</TR>\n</TABLE>\n";
 
 print FOUT "</TD>\n</TR>\n";        
 print FOUT "</TABLE>\n</CENTER>\n";
#}

 print FOUT "<P><HR><P><CENTER>\n";

 print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"day-main\">\n";
 print FOUT "<TR>\n";
 print FOUT "<TH>$L{'Date'}</TH>\n";
 print FOUT "<TH>$L{'Requests'}</TH>\n";
 if ($mail_format == 0 && $ftp_format == 0) {
     print FOUT "<TH>$L{'Date'}</TH>\n";
     print FOUT "<TH>$L{'Accesses'}</TH>\n";
 }
 if ($notrafic == 0) {
     print FOUT "<TH>$L{'Date'}</TH>\n";
     print FOUT "<TH>$L{'Traffic'}";
     if ($trisize[0] > (1024*1024*1024)) {
	 print FOUT "&nbsp;($L{'Gb'})";
     } elsif ($trisize[0] > (1024*1024)) {
	 print FOUT "&nbsp;($L{'Mb'})";
     } elsif ($trisize[0] > 1024) {
	 print FOUT "&nbsp;($L{'Kb'})";
     }
     print FOUT "</TH>\n";
 }
 print FOUT "<TH>$L{'Date'}</TH>\n";
 print FOUT "<TH>$L{'Hosts'}</TH>\n";
 print FOUT "</TR>\n";
 $tmp = 0;
 for ($i=0;$i<$topten;$i++) {
     if ($trireq[$i] ne '' && $trireq[$i] != 0) {
	 print FOUT "<TR>\n";
	 @tmp = split(/\s+/,$trireqdate[$i]);
	 $linkjour = "..".$dirsepurl.$dirdate.$dirsepurl.$tmp[2]."-".$tmp[1]."-".$tmp[0].$dirsepurl.$menu;
	 $fulljour = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$tmp[2]."-".$tmp[1]."-".$tmp[0].$dirsep.$menu;
	 print FOUT "<TD><I>";
	 print FOUT "<A HREF=\"$linkjour\">" if (-f $fulljour);
	 print FOUT "$trireqdate[$i]";
	 print FOUT "</A>" if (-f $fulljour);
	 print FOUT "</I></TD>\n";
	 $tmp = int(50*$trireq[$i]/$trireq[0]) if ($trireq[0] != 0);
	 $tmp = 1 if ($tmp == 0);
	 print FOUT "<TD CLASS=\"left\"><IMG WIDTH=$tmp SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[0]\" HEIGHT=$square ALT=\"$gcolor[0]\">&nbsp;$trireq[$i]</TD>\n";
#	 print FOUT "<TD ALIGN=CENTER>&nbsp;</TD>\n";

	 if ($mail_format == 0 && $ftp_format == 0) {
	     print FOUT "<TD><I>$triaccdate[$i]</I></TD>\n";
	     $tmp = int(50*$triacc[$i]/$triacc[0]) if ($triacc[0] != 0);
	     $tmp = 1 if ($tmp == 0);
	     print FOUT "<TD CLASS=\"left\"><IMG WIDTH=$tmp SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" HEIGHT=$square ALT=\"$gcolor[1]\">&nbsp;$triacc[$i]</TD>\n";
#	 print FOUT "<TD ALIGN=CENTER>&nbsp;</TD>\n";
	 }
	 if ($notrafic == 0) {
	     print FOUT "<TD><I>$trisizedate[$i]</I></TD>\n";	 
	     $tmp2 = $trisize[$i];
	     $tmp2 = $tmp2/(1024*1024*1024) if ($trisize[0] > (1024*1024*1024));
	     $tmp2 = $tmp2/(1024*1024) if ($trisize[0] > (1024*1024) && $trisize[0] <= (1024*1024*1024));
	     $tmp2 = $tmp2/1024 if ($trisize[0] > 1024 && $trisize[0] <= (1024*1024));
	     $tmp = int(50*$trisize[$i]/$trisize[0]) if ($trisize[0] != 0);
	     $tmp = 1 if ($tmp == 0);
	     $tmp2 = int($tmp2*10)/10;
	     print FOUT "<TD CLASS=\"left\"><IMG WIDTH=$tmp SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" HEIGHT=$square ALT=\"$gcolor[3]\">&nbsp;$tmp2</TD>\n";
	 }
#	 print FOUT "<TD ALIGN=CENTER>&nbsp;</TD>\n";
	 print FOUT "<TD><I>$trihostdate[$i]</I></TD>\n";
	 $tmp = int(50*$trihost[$i]/$trihost[0]) if ($trihost[0] != 0);
	 $tmp = 1 if ($tmp == 0);
	 print FOUT "<TD CLASS=\"left\"><IMG WIDTH=$tmp SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" HEIGHT=$square ALT=\"$gcolor[4]\">&nbsp;$trihost[$i]</TD>\n";
#	 print FOUT "<TD ALIGN=CENTER>&nbsp;</TD>\n";
	 print FOUT "</TR>\n";
     }
 }

 print FOUT "</TABLE></CENTER><P>\n";

if (($precision > 2) && (($#selecrepert) != -1) && $notrafic == 0) {

print FOUT "<A NAME=\"graph2\"></A>";
print FOUT "<HR><P>\n";

#if (-x $FLY) {
print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
print FOUT "<TR>\n";
print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkfile2y\" ALT=\"y\"></TD>\n";
print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkfile2\" ALT=\"graph2\" USEMAP=\"#day2\" BORDER=0></TD>\n";
print FOUT "</TR><TR><TD></TD>\n";
print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkfile2x\" ALT=\"x\"></TD>\n";
print FOUT "</TR>\n";
print FOUT "<TR><TD></TD>\n";
print FOUT "<TD ALIGN=CENTER>\n";

print FOUT "<I>\n";
print FOUT "$L{'optdirsize1'}\n" if ($optdirsize == 1);
print FOUT "$L{'optdirsize2'}\n" if ($optdirsize == 2);
print FOUT "$L{'optdirsize3'}\n" if ($optdirsize == 3);
print FOUT "$L{'optdirsize4'}\n" if ($optdirsize == 4);
print FOUT "$L{'optdirsize5'}\n" if ($optdirsize == 5);
print FOUT "$L{'optdirsize6'}\n" if ($optdirsize == 6);
print FOUT "</I><P>\n";
print FOUT "</TD></TR>\n";        
print FOUT "</TABLE>\n";

print FOUT "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0><TR>\n";

@tmprepert = @selecrepert;

print FOUT "<TD><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$others\" ALT=\"$others\"></TD>\n";
print FOUT "<TD>&nbsp; $L{'total_data_sent_for'} <B>$tri</B></TD>\n";
print FOUT "</TR>\n";

if ($#selecrepert > 0) {
    for ($i=$#selecrepert;$i>=0;$i--) {
        $cureper = pop(@tmprepert);
        $j = $i % ($#gcolor);
        $couleur = $gcolor[$j];
	if ($cureper ne $dirsepurl) {
	    print FOUT "<TR><TD><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$couleur\" ALT=\"$couleur\"></TD>\n";
	    print FOUT "<TD>&nbsp; $L{'data_sent_for_dir'} <B>$cureper</B></TD>\n";
	    print FOUT "</TR>\n";
	}
    }

}

print FOUT "</TABLE>\n";

print FOUT "</CENTER>";


if ($#selecrepert > 0) {
    # Display Peak
    print FOUT "<P><HR><P><CENTER>\n";
    print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"day-sizerepert\"><TR>\n";
    for ($i=0;$i<=$#selecrepert;$i++) {
	$tmp3 = "tridir"."_".$i;
	if ($$tmp3[0] != 0) {
	    print FOUT "<TH ALIGN=CENTER>$L{'Date'}</TH>\n<TH ALIGN=CENTER>$selecrepert[$i]";
	    if ($$tmp3[0] > (1024*1024)) {
		print FOUT "&nbsp;($L{'Mb'})";
	    } elsif ($$tmp3[0] > 1024) {
		print FOUT "&nbsp;($L{'Kb'})";
	    }
	    print FOUT "&nbsp;</TH>\n";
	}
    }
    print FOUT "</TR>\n";

    for ($j=0;$j<$topten;$j++) {
	$tmp3 = "tridir"."_0";
	if ($$tmp3[$j] ne '') {
	    print FOUT "<TR>\n";
	    for ($i=0;$i<=$#selecrepert;$i++) {
		$tmp3 = "tridir"."_".$i;
		if ($$tmp3[0] != 0) {
		    $tmp4 = "tridirdate"."_".$i;
		    $k = $i % ($#gcolor);
		    $couleur = $gcolor[$k];
		    @tmp = split(/\s+/,$$tmp4[$j]);
		    $linkjour = "..".$dirsepurl.$dirdate.$dirsepurl.$tmp[2]."-".$tmp[1]."-".$tmp[0].$dirsepurl.$menu;
		    $fulljour = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$tmp[2]."-".$tmp[1]."-".$tmp[0].$dirsep.$menu;
		    print FOUT "<TD><I>";
		    print FOUT "<A HREF=\"$linkjour\">" if (-f $fulljour);
		    $tmp5 = $$tmp4[$j];
		    $tmp5 =~ s/\s+/&nbsp;/g;
		    print FOUT "$tmp5";
#		print FOUT "$$tmp4[$j]";
		    print FOUT "</A>" if (-f $fulljour);
		    print FOUT "</I></TD>\n";
		    $tmp = int(50*$$tmp3[$j]/$$tmp3[0]) if ($$tmp3[0] != 0);
		    $tmp = 1 if ($tmp == 0);
		    $tmp2 = $$tmp3[$j];
		    $tmp2 = $$tmp3[$j]/(1024*1024) if ($$tmp3[0] > (1024*1024));
		    $tmp2 = $$tmp3[$j]/1024 if ($$tmp3[0] > 1024 && $$tmp3[0] <= (1024*1024));
		    $tmp2 = int($tmp2*10)/10 if ($$tmp3[0] > (1024*1024));
		    $tmp2 = int($tmp2) if ($$tmp3[0] <= (1024*1024));
		    print FOUT "<TD CLASS=\"left\"><IMG WIDTH=$tmp SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$couleur\" HEIGHT=$square ALT=\"$couleur\">&nbsp;$tmp2</TD>\n";
		}
	    }
	    print FOUT "</TR>\n";
	}
    }
    print FOUT "</TABLE></CENTER>\n";
}

#print FOUT "</TD></TR>\n";        
#print FOUT "</TABLE></CENTER>\n";
#}

}
print FOUT "<HR><P>\n";

print FOUT "</BODY></HTML>\n";
}


###########################################################################
####              computing directories data traffic                  #####
###########################################################################

# Need for new format output including totsize
sub TabDaySize {
 local(*FOUT, *L, $langcount) = @_;

 print FOUT "$doctype\n";
 print FOUT "<HTML><HEAD>\n";
 print FOUT "$charset\n";
 print FOUT "<TITLE>$L{'Tab_about_lastdays1'} $count_day $L{'Tab_about_lastdays2'}</TITLE>\n";
 print FOUT "<!-- Page generated by w3perl - cron-day.pl $version - $today $hourdate -->\n";	 
 print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
# print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$tablejs\"></script>\n";
 print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_w3perl\">\n";
 print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_help\">\n";
 print FOUT "</HEAD>\n";
 print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
 print FOUT "<H2> $L{'Tab_about_lastdays1'} $count_day $L{'Tab_about_lastdays2'}</H2><P>\n";
 print FOUT "<P><HR><P>\n";
 print FOUT "<A HREF=\"..$dirsepurl..$dirsepurl$dircsv$dirsepurl$filerepertsize$csvext\">CSV</A>" if (-f "$path$dircsv$dirsep$filerepertsize$csvext");
 print FOUT "<TABLE CLASS=\"sortable\" ID=\"day-size\">\n";
 print FOUT "<TR>\n";
 print FOUT "<TH>$L{'Date'}</TH>\n";

 @tmprepert = @selecrepert;

 open(OUT, ">$path$dircsv$dirsep$filerepertsize$csvext") if ($langcount == 0);

 $tmp = '';
 for ($i=0;$i<=$#selecrepert;$i++) {
     $cureper = shift(@tmprepert);
     print FOUT "<TH>$cureper&nbsp;<I>($L{'Kb'})</I></TH>\n";
     $tmp .= "\"$cureper ($L{'Kb'})\",";
 }
 print FOUT "</TR>\n";
 chop($tmp);
 print OUT "#\"$L{'Date'}\",$tmp\n";

 open(IN, "$path$dirdata$dirsep$filerepertsize") || &error_exit("Error, unable to open $path$dirdata$dirsep$filerepertsize");

 $line = 0;
 $inc = 0;
 $count = 0;
 $count_day = 1;
 $count_week = 1;

 while (<IN>) {
     $line++;
     next unless ($line > 3);

     $count++;
        
     $oldjour = $jour;
     $oldmonth = $month;

    ($jour,$month,$year,@reste) = split('\s+');

     $day = $jour." ".$month." ".$year;  

     if ($nbdays != 0) {

	 $jour_of_year = &nbday($day);
	 $jour_ecoule = $jour_of_year_end - $jour_of_year;     
     }

     next unless ($jour_ecoule <= $nbdays || $nbdays == 0);

     $inc++;

     if ( $line == 4) {
       $start_date = $day;
     }

     ### test sur le jour suivant
    
     $intervalle = $jour - $oldjour;
     if ($intervalle != 1 && $line > 4) {
        if ($oldmonth ne $month) {
        $intervalle = $month_of_year{$oldmonth} - $oldjour; # suppose le mois suivant
        $intervalle += $jour;
             }
       $affmonth = $oldmonth;
       for ($i=$count;$i<($intervalle+$count-1);$i++) {
          $oldjour++;
          if ($oldjour > $month_of_year{$oldmonth}) {
                 $oldjour = 1;
                 $affmonth = $month;
                 } 
          
	  $oldjour = "0".$oldjour if (length($oldjour) == 1 && $struct_compressed_logfile !~ /\%smallday/);
          $day = $oldjour." ".$affmonth." ".$year;

#	  print TABSIZE "<TR class=\"$parity\" onmouseover=\"setPointer(this, $count, 'over', '$bgcolor', '$bgcolor_tab3', '$bgcolor_tab4','$tmp');\" onmouseout=\"setPointer(this, $count, 'out', '$bgcolor', '$bgcolor_tab3', '$bgcolor_tab4','$tmp');\" onmousedown=\"setPointer(this, $count, 'click', '$bgcolor', '$bgcolor_tab3', '$bgcolor_tab4','$tmp')\"><A NAME=\"$count_day\">\n";
#	  print TABSIZE "<TD ALIGN=CENTER bgcolor=\"$bgcolor\">";
	  $tmp = "\"$day\",";
	  print TABSIZE "<TR>\n";
	  print TABSIZE "<TD CLASS=\"left\">";
	  print TABSIZE "<A NAME=\"$count_day\"></A>";
	  print TABSIZE "$day";
	  print TABSIZE "</TD>\n";
           for ($j=0;$j<=$#selecrepert;$j++) {
#	       print TABSIZE "<TD ALIGN=CENTER bgcolor=\"$bgcolor\">0</TD>\n";
	       print TABSIZE "<TD CLASS=\"right\">0</TD>\n";
	       $tmp .= "\"0\",";
          }
          print TABSIZE "</TR>\n";
	  chop($tmp);
	  print OUT "$tmp\n" if ($langcount == 0);
          $inc++;
            }
     $count+=$intervalle-1;
     $count_day += $intervalle-1;
     $line = $count;
     }

     $m_total += $m_tot;
     $req_total += $req_tot;
        
     # 1 mod 6 = html tot dir1#
     # 2 mod 6 = html ext dir1#
     # 3 mod 6 = html dom dir1#
     # 4 mod 6 = sizetot  dir1#
     # 5 mod 6 = sizetot ext dir1#
     # 6 mod 6 = sizetot dom dir1#
     # 7 mod 6 = html tot dir2#
     # ...... #

     $day = $jour." ".$month." ".$year;

    $linkjour = "..".$dirsepurl.$dirdate.$dirsepurl.$year."-".$month."-".$jour.$dirsepurl.$menu;
    $fulljour = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$year."-".$month."-".$jour.$dirsep.$menu;

#     print TABSIZE "<TR class=\"$parity\" onmouseover=\"setPointer(this, $count, 'over', '$bgcolor', '$bgcolor_tab3', '$bgcolor_tab4','$tmp');\" onmouseout=\"setPointer(this, $count, 'out', '$bgcolor', '$bgcolor_tab3', '$bgcolor_tab4','$tmp');\" onmousedown=\"setPointer(this, $count, 'click', '$bgcolor', '$bgcolor_tab3', '$bgcolor_tab4','$tmp')\"><A NAME=\"$count_day\">\n";
     print TABSIZE "<TR>\n";
#     print TABSIZE "<TD ALIGN=CENTER bgcolor=\"$bgcolor\">";
     print TABSIZE "<TD CLASS=\"left\">";
     print TABSIZE "<A NAME=\"$count_day\"></A>";
     print TABSIZE "<A HREF=\"$linkjour\">" if (-f $fulljour);
     print TABSIZE "$day";
     print TABSIZE "</A>" if (-f $fulljour);
     print TABSIZE "</TD>\n";

     $tmp = "\"$day\",";
     for ($i=0;$i<=$#selecrepert;$i++) {

         $maxdir{$count_day,$i} = $reste[$i*6+$optdirsize-1];
# Need for new format output including totsize
         $max{$count_day} += $maxdir{$count_day,$i} if ($langcount == 0); 

         $kovalue = $reste[$i*6+$optdirsize-1]/1024;
	 push(@listdiropt,$reste[$i*6+$optdirsize-1]);
#         print FOUT "<TD ALIGN=CENTER bgcolor=\"$bgcolor\">";
         print FOUT "<TD CLASS=\"right\">";
         printf FOUT "%.1f",$kovalue;
         print FOUT "</TD>\n";
	 $tmp .= "\"$kovalue\",";
         }
     chop($tmp);
     print OUT "$tmp\n" if ($langcount == 0);

# Need for new format output including totsize
     $maxtot = $max{$count_day} if ($max{$count_day} > $maxtot);
     print FOUT "</TR>\n";

     $count_day++;     
 }

 close(IN);
 close(OUT) if ($langcount == 0);

 $count_day--;

# fermeture de la page HTML du tableau sur les jours
 print FOUT "</TABLE>\n";
 print FOUT "<P><HR><P>\n";    
 print FOUT "</BODY></HTML>\n";
}

###########################################################################
####              directories data traffic graph                      #####
###########################################################################

#################################################################
# Fly

#if (-x $FLY) {

$it = length($count_day)-1;
$div = 10**$it;
$factx = ($div*(int($count_day/$div)+1))/$grad;
 
$it = length($maxtot)-1;
$div = 10**$it;
$facty = ($div*(int($maxtot/$div)+1))/$grad;
 
 open(FLY,">$tmpfly$vtmp");
 print FLY "new\n";
 print FLY "size $xmax,$ymax\n";
 print FLY "frect 0,0,0,0,200,200,200\n";

###

 for ($i=1;$i<=$count_day;$i++) {
 $x1 = ($i-1)*$xstep/$factx;
 $x2 = $i*$xstep/$factx;
 
 $y2 = $ymax - ($ystep/$facty * $maxdir{$i,0});
# $y2ppp = $ymax - ($ystep/$facty * $maxdir{$i-1,0});
 $y1 = $ymax;

 $yfinal = $ymax - ($ystep/$facty * $sizetot{$i});
 
 if ($bargraph == 1) {
  print FLY "frect $x1,$y2,$x2,$y1,$red[0],$green[0],$blue[0]\n";
  print FLY "rect $x1,$y2,$x2,$y1,0,0,0\n";
#   print FLY "rect $x1,$y2,$x1,$y2ppp,0,0,0\n";
   if ($tridim == 1 && $y2 != $ymax && ($y1-$y2) > 2) {

        $x1plus = $x1+$perspec;
        $x2plus = $x2+$perspec;
        $y2plus = $y2-$perspec;
        $y1plus = $ymax-$perspec;

        print FLY "fpoly $red[0],$green[0],$blue[0],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
        print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";

#        if ($yfinal == $y1) {

#        print FLY "fpoly $red[0],$green[0],$blue[0],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
#        print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
#        last;
#        }
        
   }
 }

 if ($linegraph == 1) {
   $y1 = $ymax - ($ystep/$facty * $maxdir{$i+1,0});
   print FLY "line $x1,$y2,$x2,$y1,$red[0],$green[0],$blue[0]\n";

   if ($fillgraph == 1) {
     if ($y1 != $y2 || $y1 != $ymax) {
       print FLY "line $x1,$ymax,$x1,$y2,$red[0],$green[0],$blue[0]\n";
       print FLY "line $x2,$ymax,$x2,$y1,$red[0],$green[0],$blue[0]\n";
       print FLY "line $x1,$ymax,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
       $fx1 = $x1+1;

       print FLY "fill $fx1,$fymax,$red[0],$green[0],$blue[0]\n";
     }
   }
 }


###

 for ($j=1;$j<=$#selecrepert;$j++) {

 $y1 = $y2;
# $y2ppp = $y2 - ($ystep/$facty * $maxdir{$i-1,$j});
 $y2 = $y2 - ($ystep/$facty * $maxdir{$i,$j});

 $ji = $j % ($#gcolor);

 if ($bargraph == 1) {
   print FLY "frect $x1,$y2,$x2,$y1,$red[$ji],$green[$ji],$blue[$ji]\n";
   print FLY "rect $x1,$y2,$x2,$y1,0,0,0\n";
#   print FLY "rect $x1,$y2,$x1,$y2ppp,0,0,0\n";
   if ($tridim == 1 && ($y1-$y2) > 2) {

        $x1plus = $x1+$perspec;
        $x2plus = $x2+$perspec;
        $y2plus = $y2-$perspec;
        $y1plus = $y1-$perspec;
        
        print FLY "fpoly $red[$ji],$green[$ji],$blue[$ji],$x2,$y1,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
        print FLY "poly 0,0,0,$x2,$y1,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";

        if ($yfinal == $y1) {
        print FLY "fpoly $red[$ji],$green[$ji],$blue[$ji],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        last;
        }

   }

 }

 if ($linegraph == 1) {
    $y2 = $ymax - ($ystep/$facty * $maxdir{$i,$j});
    $y1 = $ymax - ($ystep/$facty * $maxdir{$i+1,$j});
    print FLY "line $x1,$y2,$x2,$y1,$red[$ji],$green[$ji],$blue[$ji]\n";

    if ($fillgraph == 1) {
      if ($y1 != $y2 || $y1 != $ymax) {
       print FLY "line $x1,$ymax,$x1,$y2,$red[$ji],$green[$ji],$blue[$ji]\n";
       print FLY "line $x2,$ymax,$x2,$y1,$red[$ji],$green[$ji],$blue[$ji]\n";
       print FLY "line $x1,$ymax,$x2,$ymax,$red[$ji],$green[$ji],$blue[$ji]\n";
       $fx1 = $x1+1;

       print FLY "fill $fx1,$fymax,$red[$ji],$green[$ji],$blue[$ji]\n";
      }
     }
 }
 
}

###

if ($y1 != $yfinal) {

 $y1 = $y2;
 $y2 = $yfinal;
 
 if ($bargraph == 1) {
   print FLY "frect $x1,$y2,$x2,$y1,$red[100],$green[100],$blue[100]\n";
   print FLY "line $x1,$y2,$x1,$y1,0,0,0\n";
   if ($tridim == 1 && $y1 != $yfinal) {

        $x1plus = $x1+$perspec;
        $x2plus = $x2+$perspec;
        $y2plus = $y2-$perspec;
        $y1plus = $y1-$perspec;

	if ($y1 < $y2) {
        print FLY "fpoly $red[100],$green[100],$blue[100],$x1,$y1,$x1plus,$y1plus,$x2plus,$y1plus,$x2,$y1\n";
        print FLY "poly 0,0,0,$x1,$y1,$x1plus,$y1plus,$x2plus,$y1plus,$x2,$y1\n";
    } else {
        print FLY "fpoly $red[100],$green[100],$blue[100],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
    }

        print FLY "fpoly $red[100],$green[100],$blue[100],$x2,$y1,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
        print FLY "poly 0,0,0,$x2,$y1,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";

   }
 }

 if ($linegraph == 1) {
    $y2 = $ymax - ($ystep/$facty * $maxdir{$i,$j});
    $y1 = $ymax - ($ystep/$facty * $maxdir{$i+1,$j});
    print FLY "line $x1,$y2,$x2,$y1,$red[100],$green[100],$blue[100]\n";

    if ($fillgraph == 1) {
      if ($y1 != $y2 || $y1 != $ymax) {
       print FLY "line $x1,$ymax,$x1,$y2,$red[100],$green[100],$blue[100]\n";
       print FLY "line $x2,$ymax,$x2,$y1,$red[100],$green[100],$blue[100]\n";
       print FLY "line $x1,$ymax,$x2,$ymax,$red[100],$green[100],$blue[100]\n";
       $fx1 = $x1+1;

       print FLY "fill $fx1,$fymax,$red[100],$green[100],$blue[100]\n";
      }
     }
 }

}

}
print FLY "transparent 200,200,200\n";

close (FLY);

open(FOO,"$FLY -q -i $tmpfly$vtmp -o $file2 |");
while( <FOO> ) {print;}
close(FOO);

### image pour les abscisses

($startday, $startmonth) = split(/ /,$start_date);

$moischiffre = $month_equiv{$startmonth};
$moischiffre--;
$moisvar = $startmonth;
$valmois = $moischiffre;

$valstep = $startday;
$valstep = "0".$valstep if (length($valstep) == 1);

$xlegend = "$count_day days (starting $start_date)";

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xmax,$ydecal\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 $posx = (($xmax/2)-(length($xlegend)*7/2));
 print FLY "string 0,0,0,$posx,$ydecalm,medium,$xlegend\n";
 for ($i=$xstep;$i<$xmax;$i+=$xstep) {
 $valstep = int(($i/$xmax)*(($xmax*$factx/$xstep)))+$startday;

 $moisvar = $startmonth;
 $valmois = $moischiffre;

 while  ($valstep > $month_of_year{$moisvar}) {
     $valstep = ($valstep - $month_of_year{$moisvar});
     $valmois++;
     $valmois = 0 if ($valmois > 11);
     $moisvar = $month_nb[$valmois];
 }

 $valstep = "0".$valstep if (length($valstep) == 1);
 $val = "$moisvar/$valstep";
 $posx = $i - length($valstep)*10;
 print FLY "line $i,0,$i,5,0,0,0\n";
 print FLY "string 0,0,0,$posx,10,small,$val\n";

 }
print FLY "transparent 200,200,200\n";
close (FLY);
 
open(FOO,"$FLY -q -i $tmpfly$vtmp -o $file2x |");
while( <FOO> ) {print;}
close(FOO);

### image pour les ordonnees

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xdecal,$ymax\n";
 print FLY "frect 0,0,0,0,200,200,200\n";
 $posy = $ymax - (($ymax/2)-(length("Kbytes 5total added)")*2));

 if ($maxtot > 1024*1024) {
 print FLY "stringup 0,0,0,5,$posy,medium,Mbytes (Total added)\n";
 } else {
 print FLY "stringup 0,0,0,5,$posy,medium,Kbytes (Total added)\n";
 }
 for ($j=$ystep;$j<$ymax;$j+=$ystep) {
 $valstep = int(($ymax - $j) * ($facty/$ystep));
 $valstep /= 1024; # in Kb
 $valstep /= 1024 if ($maxtot > (1024*1024));
 $valstep = int($valstep*10)/10;
 $valstep .= ".0" if ($valstep !~ /\./);
 $pos = ($xdecal - length($valstep)*11);
 $posy = $j-5;
 print FLY "line $xdecalm,$j,$xdecal,$j,0,0,0\n";
 print FLY "string 0,0,0,$pos,$posy,small,$valstep\n";
 }

print FLY "transparent 200,200,200\n";
close (FLY);
 
open(FOO,"$FLY -q -i $tmpfly$vtmp -o $file2y |");
while( <FOO> ) {print;}
close(FOO);
unlink("$tmpfly$vtmp");

# PDF report

if ($enable_pdf == 1) {

    for ($i=0;$i<=$#list_cmd;$i++) {

	$ENV{HTMLDOC_NOCGI} = 1;

	$cmd = $list_cmd[$i];
	($tmp1,$tmp2) = split(/\s+\|\s+/,$cmd);
	@tmp3 = split(/\s+/,$tmp2);
#	print "Write to $path$dirtmp$dirsep$dirpdf$dirtmp\n";
	open(PDFTMP,">$path$dirtmp$dirsep$dirtmp$dirpdf$dirtmp") || &error_exit("Unable to write to $path$dirtmp$dirsep$dirtmp$dirpdf$dirtmp");
	print PDFTMP "#HTMLDOC\n";
	print PDFTMP "$tmp1\n";
#	print "#HTMLDOC\n";
#	print "$tmp1\n";
	for ($j=0;$j<=$#tmp3;$j++) {
	    print PDFTMP "$tmp3[$j]\n";
#	    print "$tmp3[$j]\n";
	}
	close(PDFTMP);
	$command = "$HTMLDOC --batch $path$dirtmp$dirsep$dirtmp$dirpdf$dirtmp";
#	print "TOTO $command\n";
#	$command = $list_cmd[$i];
	$commit = system("$command");
	# Add run_and_check_exit
	if ($commit != 0) {
	    &error_exit("The command to create PDF report failed ($command)");
	}
	unlink("$path$dirtmp$dirsep$dirtmp$dirpdf$dirtmp");
    }
}

if ($enable_email == 1 && $emailadr ne '' && $email_daily == 1) {

    # Send only the last day : $filepdf

    $month = $monthletter;

    $subject = "W3Perl Daily Report - $year/$month/$jour";
    $from = "webmaster\@".$localdomainename;

#    $msg = "W3Perl Daily Report for $year/$month/$jour";

    if ($email_html == 1) {

#    print "TOTO1 - $year-$month-$jour\n";

	push(@html_page,$filemoyenne);
	push(@html_page,"$dirpage$htmlext");
	push(@html_page,"$dirsite$htmlext");
	push(@html_page,"$dirlist$htmlext") if ($mail_format == 0);

#	if ($toto == 1) {
	if (-f "$path$lang[0]$dirsep$dirdate$dirsep$year-$month-$jour$dirsep$dirpays$htmlext") {
	    push(@html_page,"$dirpays$htmlext");

	    # add countries if available
#	    $precision = 2;
	    if ($precision > 3) {
		$file = $path.$lang[0].$dirsep.$dirdate.$dirsep.$year."-".$month."-".$jour.$dirsep.$dirpays.$htmlext;
	    
		open(FILEHTML,"$file") || &error_exit("Can't open $file");
		while (<FILEHTML>) {
		    next if ($_ =~ /\"javascript\"/i);
		    next if ($_ =~ /\"stylesheet\"/i);
		    next if ($_ =~ /<body/i && $i != 0);
		    next if ($_ =~ /<\/body>/i);
		    next if ($_ =~ /<\/html>/i);
		    if (/<[A|AREA]([",a-z=\s\d]+)HREF="([&;~: &*\#0-9a-z_\?\-\/\<\>\!.]+)"([\(\)!';",_a-z=\s\d]*)>/i) {
		       $tmp = $2;
		       push(@html_page,$tmp) if (-f "$path$lang[0]$dirsep$dirdate$dirsep$year-$month-$jour$dirsep$tmp");
		    } 
	         }
	         close(FILEHTML);
	     }
	}
#	}
		
	push(@html_page,"$dirscript$htmlext") if ($mail_format == 0);
	push(@html_page,"$filetype$htmlext") if ($mail_format == 0);
	push(@html_page,"$dirtraffic$htmlext") if (-e "$dirresume$dirtraffic$htmlext");
	push(@html_page,$tabnamerefer) if (-e "$dirresume$refer");
	push(@html_page,$tabnamekeyword) if (-e "$dirresume$refer");
	push(@html_page,$tabnamebrowser) if (-e "$dirresume$agent");
	push(@html_page,$filevirus) if (-e "$dirresume$filevirus");
	push(@html_page,"$dirsession$htmlext") if (-e "$dirresume$dirsession$htmlext");
	push(@html_page,$filenamehour) if (-e "$dirresume$filenamehour");

	$html = '';
	$count_ima = 0;
	for ($i=0;$i<=$#html_page;$i++) {
	    $file = $path.$lang[0].$dirsep.$dirdate.$dirsep.$year."-".$month."-".$jour.$dirsep.$html_page[$i];
	    
	    $out = 1;

	    open(FILEHTML,"$file") || &error_exit("Can't open $file");
	    while (<FILEHTML>) {
		$out = 1 if ($_ =~ /Email_report_exclude_begin/);
		$out = 0 if ($_ =~ /Email_report_exclude_end/);
		$out = 1 if ($_ !~ /<body/i && $out == 1 && $i != 0);
		$out = 0 if ($_ =~ /<body/i && $i != 0);
		$line = $_;
		next if ($line =~ /\"javascript\"/i);
		next if ($line =~ /\"stylesheet\"/i);
		next if ($line =~ /<body/i && $i != 0);
		next if ($line =~ /<\/body>/i);
		next if ($line =~ /<\/html>/i);
		next if ($out == 1 && $i != 0);
		# extract img file
#		if ($line =~ /<IMG([#"a-z=\s\d]+)SRC="([&;~: 0-9a-z_\-\/\>\<\!.]+)"([\.\!\?\[\-\]#"a-z=\s\d]*)>/gi) {

#		if ($toto == 1) {
		$line2 = $line;
		while ($line2 =~ /<IMG([\#"a-z=\s\d]+)SRC="([&;~: 0-9a-z_\-\/\>\<\!.]+)"([\.\!\?\[\-\]#"a-z=\s\d]+)>/gi) {
			   $tmp1 = $1;
			   $tmp2 = $2;
			   $tmp3 = $3;
			   $delstring = $&;
			   $delstring =~ s/\?/\\?/g;
			   $delstring =~ s/\*/\\*/g;
			   $delstring =~ s/\(/\\(/g;
		       	   $delstring =~ s/\)/\\)/g;

			   $link = $tmp2;
			   $link =~ s/\.\.\///g;
			   $link = $path.$link;

#			       $newlink = "cid:ID0";					
			   if ($seen_ima_html{$link} == 0) {
			       $count_ima++;
			       $ima_find[$count_ima] = $link;
			       $ima_find_nb{$link} = $count_ima;
			       $newlink = "cid:ID$count_ima";
			       $seen_ima_html{$link}++;
			   } else {
			       $newlink = "cid:ID".$ima_find_nb{$link};
			       $o = $ima_find_nb{$link};
			   }

			   $line2 =~ s/$delstring//i;
##			   $line =~ s/$delstring/<IMG$tmp1 SRC=\"$newlink\"$tmp3>/i;
			   $line =~ s/$delstring/<IMG $tmp1 SRC=\"$newlink\" $tmp3>/i;

#			   print "TT $tmp1\n$tmp2\n$tmp3\n$delstring\n$newlink\n$line\n\n";

		       }
#				   }
		$html .= $line;
	    }
	    $html .= "<BR><BR><HR><BR><BR>\n";
	    
	    close(FILEHTML);
	}
##	$html = encode_entities($text);


	$html =~ s/<H3 CLASS=\"center\">/<FONT COLOR=\"\#209090\" SIZE=\"+2\" face=\"arial\"><strong>&nbsp;/gi;
	$html =~ s/<H3>/<FONT COLOR=\"\#209090\" SIZE=\"+1\" style=\"arial\"><strong>&nbsp;/gi;
#	$html =~ s/<H3>/<TABLE><TR bgcolor=\"\#ccaa99\"><TD><FONT COLOR=\"\#209090\" SIZE=\"1\" style=\"verdana, arial\">&nbsp;/gi;
#	$html =~ s/<\/H3>/&nbsp;<\/FONT><\/TD><\/TR><\/TABLE>/gi;
	$html =~ s/<\/H3>/&nbsp;<\/strong><\/FONT>/gi;
	$html =~ s/<TH/<TH bgcolor=\"\#ffeecc\"/gi;
	$html =~ s/BACKGROUND=\"([&;~: 0-9a-z_\-\/\>\<\!.]+)\"//gi; 
	$html =~ s/CLASS=\"sortable\"//gi;
	$html =~ s/CLASS=\"item_page\"//gi;
	$html =~ s/CLASS=\"head\"/align=\"center\" bgcolor=\"\#ffeecc\"/gi;
	$html =~ s/CLASS=\"right\"/align=\"right\"/gi;
	$html =~ s/CLASS=\"left\"/align=\"left\"/gi;
#	$html =~ s/CLASS=\"left\"/align=\"right\"/gi;
	$html =~ s/CLASS=\"right_alter\"/bgcolor=\"\#f5f5f5\" align=\"right\"/gi;
	$html =~ s/CLASS=\"left_alter\"/bgcolor=\"\#f5f5f5\" align=\"left\"/gi;
	$html =~ s/CLASS=\"head_right\"/bgcolor=\"\#ffeecc\" align=\"right\"/gi;
	$html =~ s/CLASS=\"head_left\"/bgcolor=\"\#ffeecc\" align=\"left\"/gi;

#	$html =~ s/<IMG([#"a-z=\s\d]+)SRC="([&;~: 0-9a-z_\-\/\>\<\!.]+)"([\.\!\?\[\-\]#"a-z=\s\d]*)>//gi; 

	$html .= "</body></html>\n";
	    }


#	    print "HTML : $html\n";

    #
    ### MIME::Lite module
    #

    if ($perl_mail_module eq "MIME::Lite") {

	MIME::Lite->send('smtp',$email_smtp);

	  $mime = MIME::Lite->new (
				   From => $from,
				   To => $emailadr,
				   Subject => $subject,
#				   Type => 'multipart/mixed'
				   Type => 'multipart/related'
				   ) || die "Error creating multipart container: $!\n";


	  if ($email_html == 1) {
	      $mime->attach(
			    Type => 'text/html; charset=iso-8859-1',
			    Encoding => '8bit',
			    Data => $html
			    ) || die "Error adding the html message part: $!\n";

	      # Attach images
#	      if ($toto == 1) {
	      for ($i=1;$i<=$count_ima;$i++) {
		  $tmp = "ID".$i;
		  $fileshort = substr($ima_find[$i],rindex($ima_find[$i],$dirsep)+1,length($ima_find[$i]));
#		  print "$i - $tmp - $ima_find[$i] - $fileshort\n";
		  $mime->attach(Type => 'image/gif',
			    Id   => $tmp,
			    Path => $ima_find[$i],
			    Filename   => $fileshort
			    ) || die "Error adding $fileshort: $!\n";
	      }
	  }
#	  }


#		  $mime->attach(Type => 'image/gif',
#			    Id   => 'ID1',
#			    Path => '/var/w3perl/htdocs/demo/resources/green.gif',
#			    Filename   => 'green.gif'
#			    );
#		  $mime->attach(Type => 'image/gif',
#			    Id   => 'ID2',
#			    Path => '/var/w3perl/htdocs/demo/resources/darkblue.gif',
#			    Filename   => 'darkblue.gif'
#			    );
#		  $mime->attach(Type => 'image/gif',
#			    Id   => 'ID3',
#			    Path => '/var/w3perl/htdocs/demo/resources/rose.gif',
#			    Filename   => 'rose.gif'
#			    );

	  if ($email_pdf == 1 && $filepdf ne '') {
	      $fileshort = $year."-".$month."-".$jour.$pdfext;
	      $mime->attach(
			    Type       => 'application/pdf',
			    Encoding   => 'base64',
			    Path       => $filepdf,
			    Filename   => $fileshort
			    ) || die "Error adding $fileshort: $!\n";
	  }

	  #envoi du message

#	  $mime->MIME::Lite::quiet();

	  if (substr($pathserver,1,1) eq ":") {
	      # win
	      $mime->MIME::Lite::send_by_smtp($email_smtp);
	  } else {
	      $mime->MIME::Lite::send();
#	      eval {$mime->MIME::Lite::send()};
#	      die "MIME::Lite->send failed: $@\n" if $@;
#	      print $@ if $@;  ### or do_something() if $@;
	 }

      }

    print "Email daily report sent to $emailadr";
    print " : $filepdf" if ($email_pdf == 1);
    print "\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET"); 
	}


# calculer le temps mis pour le calcul

$datesyst = &ctime(time);
($dayletter,$month,$day,$hourdate,$a,$year) = split(/[ \t\n\[]+/,$datesyst);
($hour,$minute,$second) = split(/:/,$hourdate);

$endrun = "$hour:$minute:$second";

($hour,$min,$sec) = &timetaken($startrun,$endrun);

$endtime = time();

print "Computing took";
print " $hour h" if ($hour > 0);
print " $min min $sec sec\n\n";
print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET"); 
#print "<A HREF=\"$ENV{'HTTP_REFERER'}\">Go back</A>" if ($ENV{'HTTP_REFERER'} ne '');


$today =~ s/ /\//g;

open(FILE,">>$history");
#print FILE "cron-day\t$today\t$startrun\t$endrun\t$min:$sec\n";
printf FILE "cron-day\t%s\t%s\t%s\t%d:%d:%d\n",$today,$startrun,$endrun,$hour,$min,$sec;
close(FILE);
